; 68HC11 Disassembler V0.10 (c) Copyright 2000 Tech Edge Pty. Ltd.
;
; Disassembly of lotusc.BIN - from $8000 to $FFFF

NVRAMWD0	=	$0000
NVRAMWD0_SWI = 	%00000001	; SWI Interrupt occured
NVRAMWD0_PEI = 	%00000010	; Periodic or ALDL Interrupt occured
NVRAMWD0_EXI = 	%00000100	; External Interrupt occured
NVRAMWD0_III = 	%00001000	; Illegal Instruction Interrupt Vector
NVRAMWD0_BRI = 	%00010000	; Bus Reset Vector (read or write 0x6000-0x6FFF)
NVRAMWD0_WDI = 	%00100000	; Watchdog Vector 
NVRAMWD0_CKF = 	%01000000	; Clock Fail Vector 
NVRAMWD0_RST = 	%10000000	; Reset Vector 

NVRAMWD1	=	$0001
NVRAMWD1_CTSCOOL =	%00000010	; CTS Failed ?

NVRAMWD2	=	$0002
NVRAMWD2_TC51 = 	%00001000	; TC51 (Checksum error) detected 
NVRAMWD2_FPUMP = 	%00100000	; Fuel Pump On 
NVRAMWD2_ESCON = 	%10000000	; Electronic Spark Control On 

MALFWD1	=	$0003
MALFWD1_TC23 = 	%00000001	; TC23
MALFWD1_TC22 = 	%00000010	; TC22
MALFWD1_TC21 = 	%00000100	; TC21
MALFWD1_TC16 = 	%00001000	; TC16
MALFWD1_TC15 = 	%00010000	; TC15
MALFWD1_TC14 = 	%00100000	; TC14
MALFWD1_TC13 = 	%01000000	; TC13
MALFWD1_TC12 = 	%10000000	; TC12

MALFWD2	=	$0004
MALFWD2_TC35 = 	%00000001	; TC35
MALFWD2_TC34 = 	%00000010	; TC34
MALFWD2_TC33 = 	%00000100	; TC33
MALFWD2_TC32 = 	%00001000	; TC32
MALFWD2_TC31 = 	%00010000	; TC31
MALFWD2_TC26 = 	%00100000	; TC26
MALFWD2_TC25 = 	%01000000	; TC25
MALFWD2_TC24 = 	%10000000	; TC24

MALFWD3	=	$0005
MALFWD3_TC51 = 	%00000001	; TC51
MALFWD3_TC46 = 	%00000010	; TC46
MALFWD3_TC45 = 	%00000100	; TC45
MALFWD3_TC44 = 	%00001000	; TC44
MALFWD3_TC43 = 	%00010000	; TC43
MALFWD3_TC42 = 	%00100000	; TC42
MALFWD3_TC41 = 	%01000000	; TC41
MALFWD3_TC36 = 	%10000000	; TC36

MALFWD4	=	$0006
MALFWD4_TC63 = 	%00000001	; TC63
MALFWD4_TC62 = 	%00000010	; TC62
MALFWD4_TC61 = 	%00000100	; TC61
MALFWD4_TC56 = 	%00001000	; TC56
MALFWD4_TC55 = 	%00010000	; TC55
MALFWD4_TC54 = 	%00100000	; TC54
MALFWD4_TC53 = 	%01000000	; TC53
MALFWD4_TC52 = 	%10000000	; TC52

MALFWD5	=	$0007
MALFWD5_TC75 = 	%00000001	; TC75
MALFWD5_TC74 = 	%00000010	; TC74
MALFWD5_TC73 = 	%00000100	; TC73
MALFWD5_TC72 = 	%00001000	; TC72
MALFWD5_TC71 = 	%00010000	; TC71
MALFWD5_TC66 = 	%00100000	; TC66
MALFWD5_TC65 = 	%01000000	; TC65
MALFWD5_TC64 = 	%10000000	; TC64

AFRCTS	=	$0008	; FA_RATIO enrichment as a function of CTS116MAX
L000A	=	$000A
L000C	=	$000C
L000E	=	$000E
STARTTIMES =	$0010	; Counts the number of (TC free) times the engine has been started since last TC was set
CSUM_MALFWD =	$0011	; 16 bit checksum of MALFWD1..MALFWD5
TIMERUN	=	$0013
TIMELSB	=	$0014
FBLMTABLE	=	$0015	; 16 byte Exhaust BLM table
RBLMTABLE	=	$0025	; 16 byte Exhaust BLM table
ISSPMP	=	$0035
L0036	=	$0036	; BLM value of some sort, min = L0036_MIN, max = L0036_MAX, init = L0036_INI
L0037	=	$0037	; PWM down counter ?
WGBLMTABLE =	$0038	; 16 byte Wastegate BLM table
WGBLMTABLE2 =	$003A
WGBLMTABLE4 =	$003C
WGBLMTABLE6 =	$003E
WGBLMTABLE8 =	$0040
WGBLMTABLEA =	$0042
WGBLMTABLEC =	$0044
WGBLMTABLEE =	$0046
TIMER_TICK =	$0048	; Ticks every 6.25mS, or 160 times per second

FMDSDI	=	$0049
FMDSDI_CTSGT50 =    %00000001	; Set once CTS > 50C. Cleared when CTS < 39.5
FMDSDI_COP2 =	%00000010	; COP2 Watchdog

SPIDEV8_OUT =	$004A
SPIDEV8_IN =	$004B

FMD1	=	$004C
FMD1_ACREQ =	%10000000 ; Dashboard A/C switch

FMD2	=	$004D
FMD2_CYLSEL =	%00011000	; Mask the CYLSEL from the MEMCAL

SPIDEV7_MSB =	$004E	; MSB Input from SPIDEV7
SPIDEV7_LSB =	$004F	; LSB Input from SPIDEV7 

VBATMW	=	$0050
VBATMW_STACK_ERROR = %00000001 ; Set when a timeslice end stack error occurs
VBATMW_TICK_ERROR = %00000010 ; Set when timeslice processing is not completed
VBATMW_VLOW =	%00010000	; Set if ADBAT < 4.0V, Cleared if ADBAT >= 9.0V
VBATMW_HUD =	%10000000	; Set if GM HUD is fitted. Always clear on LC

MW1	=	$0051 
MW1_FANON =	%00000001	; Set if electric fan is running
MW1_ECPVSHUT =	%00000010	; Set if exhaust counter pressure valve is shut
MW1_EWPON =	%00000100	; Set if electric water pump is running
MW1_MV10MIN =	%00001000	; Set if (NMPH > 0) for more than L801C seconds
MW1_ACCUTOFF =	%00100000	; Clear if ACCUTOFF set
MW1_ENGRUN =	%10000000	; Set if engine running
	
MW2	=	$0052
MW2_MAPVACUUM =	%00010000	; Set when MAP is in vacuum
MW2_TC53 =	%01000000	; Overvoltage

MW3	=	$0053
MW3_SPARK_BK =	%00000001	; Spark backup mode
MW3_BUSY =	%00000100	; Set when 6.25 mS Time slice begins. 
			; Cleared once timeslice processing is complete 

SEQMW1	=	$0054

LCCPMW	=	$0055
LCCPMW_FUEL_BK =	%00001000	; Fuel backup mode
LCCPMW_CTFIRST =	%00010000	; Set on first CTS reading
LCCPMW_TC43 =	%00100000	; Set when ADKNOCK > 4.51V or < 0.65V for more than 2 seconds

L0056	=	$0056

CLCCMW	=	$0057
CLCCMW_CSUMERR =	%00000010	; Set if MEMCAL checksum error
CLCCMW_BLMINIT =	%01000000	; Set if BLM is initilised to 0x80

L0058	=	$0058

DIAGMW1	=	$0059
DIAGMW1_TC21 = 	%00000100	; Set if condition for TC21 detected
DIAGMW1_TC22 =	%00100000	; Set if condition for TC22 detected
DIAGMW1_DEFCTS = 	%01000000	; Set if using KKTCDF override
DIAGMW1_OILTEMP =	%10000000 ; Set if TC52 or TC62 set

DIAGMW2	=	$005A
DIAGMW2_MATDF =	%00000010	; Set if condition for TC23 or 25 detected
DIAGMW2_TC54 =	%00100000	; Set if condition for TC54 detected
DIAGMW2_TC41 =	%10000000	; Set if condition for TC41 detected

DIAGMW3	=	$005B
DIAGMW3_TC44 =	%00000010 ; Set when TC44 or TC45 detected
DIAGMW3_INTRST =	%00000100 ; Set when O2 integrators are reset
DIAGMW3_TC53 =	%00001000 ; Set when TC53 detected
DIAGMW3_TC13 = 	%00010000	; Set when TC13 detected

DIAGMW4	=	$005C
DIAGMW4_TC33 =	%00000001 ; Set when TC33 detected
DIAGMW4_TC34 =	%00000010 ; Set when TC34 detected
DIAGMW4_TC63 =	%00000100 ; Set when TC63 detected
DIAGMW4_TC64 =	%00001000 ; Set when TC64 or TC65 detected

DIAGMW5	=	$005D
DIAGMW5_OVBSTTM =	%00000001	; Set when (MAP > KOVBSTMAPON) for more than KOVBSTTM (seconds?)
DIAGMW5_TC16 = 	%00000010
DIAGMW5_TC66 = 	%00000100	; Set when instantaneous MAP over boost detected

BLINKMW	=	$005E	; Flag bits used when blinking out trouble codes on the dashboard lamp (CEL) 
BLINKMW_LSBLINK =	%00100000	; Clear when blinking out MSChar, set when blinking out LSChar
BLINKMW_MORE =	%01000000 ; Clear when routine is done, Set when mode TC blinkout work to do 

L005F	=	$005F
MWFA1	=	$0060

LHFLMW	=	$0061
LHFLMW_RDY =	%00000001
LHFLMW_RICH =	%00000010

RHFLMW	=	$0062
RHFLMW_RDY =	%00000001
RHFLMW_RICH =	%00000010

FANMW	=	$0063
FANMW_EFANON = 	%00000001
FANMW_HICTS =	%00000010 ; Set when (CTS > )
FANMW_HIOIL =	%00100000	; Set when (ADOIL > L8425)
FANMW_HIRPM =	%01000000	; Set when (RPM > L8427) for (NTRPMX_COUNT >= L8428)

WGATEMW	=	$0064
WGATEMW_ENABLE =	%00000001 ; Set when WGATE Solenoid is allowed to be used
WGATEMW_LAUNCH =	%00000010 ; Set when ((MPH < 2) && (RPM > 2700)) Launch Control ?
WGATEMW_NOCK =	%00000100 ; Set when KS active for > 0.625 Sec
WGATEMW_BIT3 =	%00001000
WGATEMW_OVBSTTM =	%00010000	; Set when MAP exceeds TBO1B6/3 for more than KOVBSTTM
WGATEMW_BLMNEW =	%00100000	; Set when WGBLMTABLE is updated 
WGATEMW_TC66 =	%01000000	; Set if TC66 Detected
WGATEMW_PULLAWAY =	%10000000 ; Set when we are about to pullaway for the first time

L0065	=	$0065
L0065_WGNEWCELL =	%00000001	; Set when new WGATEBLM cell is being used
L0065_BIT1 =	%00000010

L0066	=	$0066
L0066_DEFCTS = 	%00000010	; Set if using KKTCDF override
L0066_OILTEMP =	%00000100 ; Set if TC52 or TC62 set
L0066_ALDL_DIAG =	%00010000	; Set when in ALDL Diag Mode
L0066_ALDL_AWAKE =	%00100000	; Set if ALDL is awake
L0066_CELON =	%01000000 ; Set Dashboard CEL lamp on

L0067	=	$0067
L0067_TC24 =	%00001000 ; Set if VSS is believed failed
L0067_DEFCTS = 	%01000000	; Set if using KKTCDF override

ALDLMW	=	$0068
ALDLMW_MALFWD_CLR =	%00000001	; Set if ALDL has cleared MALFWD's
ALDLMW_IACV_RESET =	%00000010	; Set if ALDL has reset the IACV 
ALDLMW_BLM_RESET =	%00000100	; Set if ALDL has reset the BLM 
ALDLMW_STARTMD4 =	%00001000	; Set if ALDL is processing a MODE 4 command 
ALDLMW_TEST =	%00010000	; Set if ALDL strange mode
ALDLMW_TX =	%01000000	; Set if ALDL TX is active
ALDLMW_LSB =	%10000000	; Set if ALDL TX is a 16 bit

L0069	=	$0069
IACMW1	=	$006A

IACMW2	=	$006B
IACMW2_ALDL_IACV =	%00000001 ; ALDL is controlling IACV
IACMW2_IACV_RESET =	%00000100 ; IACV is resetting

MALFDET1	=	$006C 	; Logs currently detected faults, before MALFWD1 is set
MALFDET1_TC23 =	%00000001
MALFDET1_TC22 =	%00000010
MALFDET1_TC21 =	%00000100
MALFDET1_TC16 =	%00001000
MALFDET1_TC15 =	%00010000
MALFDET1_TC14 =	%00100000
MALFDET1_TC13 =	%01000000

MALFDET2	=	$006D	; Logs currently detected faults, before MALFWD2 is set
MALFDET2_TC34 = 	%00000010
MALFDET2_TC33 = 	%00000100
MALFDET2_TC31 = 	%00010000
MALFDET2_TC25 = 	%01000000
MALFDET2_TC24 = 	%10000000

MALFDET3	=	$006E	; Logs currently detected faults, before MALFWD3 is set
MALFDET3_TC51 = 	%00000001
MALFDET3_TC45 = 	%00000100
MALFDET3_TC44 = 	%00001000
MALFDET3_TC43 = 	%00010000
MALFDET3_TC42 = 	%00100000
MALFDET3_TC41 = 	%01000000

MALFDET4	=	$006F	; Logs currently detected faults, before MALFWD4 is set
MALFDET4_TC63 = 	%00000001
MALFDET4_TC62 = 	%00000010
MALFDET4_TC54 = 	%00100000
MALFDET4_TC53 = 	%01000000
MALFDET4_TC52 = 	%10000000

MALFDET5	=	$0070	; Logs currently detected faults, before MALFWD5 is set
MALFDET5_TC66 = 	%00100000
MALFDET5_TC65 = 	%01000000
MALFDET5_TC64 = 	%10000000

L0073	=	$0073

DOECW	=	$0076	; Discrete output control word
DOECW_CEL =	%00000001	; Check engine light
DOECW_FAN =	%00000010	; Fan On
DOECW_PURGE =	%00001000	; Canister Purge On
DOECW_AC =	%01000000	; A/C Compressor On

PWMCW	=	$0077
PWMCW_EXCPVDC = 	%00000100	; ALDL controlled Exhaust counterpressure valve
PWMCW_WGATEDC =	%01000000	; ALDL controlled WGATEDC 

L0078	=	$0078
L007A	=	$007A
L007C	=	$007C
L007E	=	$007E
L007F	=	$007F
L0080	=	$0080
LBPINJ1	=	$0082	;Does not include F33BVC contribution
LBPINJ	=	$0084	;Final LBPINJ value
L0086	=	$0086
L0088	=	$0088
RBPINJ1	=	$008A	;Does not include F33BVC contribution
RBPINJ	=	$008C	;Final RBPINJ value
CUREFIAP	=	$008E
CUREFIBP	=	$0090
L009E	=	$009E
L00A0	=	$00A0
L00A2	=	$00A2
L00A4	=	$00A4
CYLINDER	=	$00A7	;Counts 0,1,2,3,4,5,0,1 etc
L00A8	=	$00A8
L00AA	=	$00AA
L00AB	=	$00AB
L00AD	=	$00AD
L00AE	=	$00AE
L00AF	=	$00AF
L00B0	=	$00B0
L00B1	=	$00B1
L00B3	=	$00B3
L00B4	=	$00B4
L00B6	=	$00B6
L00B7	=	$00B7
NTREV65	=	$00B8
NTREV65LSB =	$00B9
NTREVCYL65 =	$00BA
L00BC	=	$00BC
L00BE	=	$00BE
L00C0	=	$00C0
L00C2	=	$00C2
SPARKADV	=	$00C4	; Spark advance w.r.t. TDC
L00C6	=	$00C6
L00C8	=	$00C8
L00CA	=	$00CA
ADKNOCK	=	$00CB
NOCKCNT	=	$00CC
PA3DELTA	=	$00CE
NOCKRTD	=	$00CF
SPARKADV1	=	$00D0	; Spark advance before ALDL and Fixed modification
L00D3	=	$00D3
ISSPMP_DELTA =	$00D5
ISESDD	=	$00D6
L00D7	=	$00D7
L00D8	=	$00D8
L00D9	=	$00D9
L00DA	=	$00DA
L00DB	=	$00DB
L00DC	=	$00DC
L00DD	=	$00DD
L00DE	=	$00DE
L00DF	=	$00DF
L00E1	=	$00E1
L00E2	=	$00E2
L00E3	=	$00E3
RPM	=	$00E4
NTRPMX	=	$00E5
RPM8000	=	$00E6
RPMFILT	=	$00E7	; Lag filtered RPM in 12.8 RPM increments
RPMFILT1	=	$00E9	; Last value of RPMFILT
RINT	=	$00EA
LINT	=	$00EC
L00EE	=	$00EE
L00F0	=	$00F0
FBLM	=	$00F2
RBLM	=	$00F3
ADMAPLAG	=	$00F4
ADMAP	=	$00F5
FILTMAP	=	$00F6
ADMAP1BAR	=	$00F8	; AD Value from 1 Bar MAP. Simulated in 2 Bar Code
ADMAPN	=	$00F9	; Something to do with MAP ?
MAP1N	=	$00FA
L00FB	=	$00FB
L00FC	=	$00FC
NMAP0	=	$00FD
NMAP1	=	$00FF
NMAP2	=	$0101
L0103	=	$0103
L0105	=	$0105
ADMAPN2	=	$0106
L0107	=	$0107
NBARO	=	$0108
NTPSLD	=	$010A
NTPSLDF	=	$010C
ADTHROT	=	$010D
NTPSLD1	=	$010E
NTPSLD2	=	$010F
ADTAOFF	=	$0110
ADTAOFF_LSB	=	$0111
ADLO2	=	$0112
ADRO2	=	$0113
ADRO2FILT	=	$0114
ADLO2FILT	=	$0116
ADRO2AFSC	=	$0118
ADLO2AFSC	=	$011A
RO2FILT	=	$011C
LO2FILT	=	$011E
L0120	=	$0120
L0122	=	$0122
L0124	=	$0124
L0125	=	$0125
L0126	=	$0126
L0127	=	$0127
LINTCNT	=	$0128	; Left integrator not 0x80 counter
RINTCNT	=	$0129	; Right integrator not 0x80 counter
L012A	=	$012A
L012B	=	$012B
L012C	=	$012C
L012D	=	$012D
L012E	=	$012E
L012F	=	$012F
L0130	=	$0130
L0131	=	$0131
L0132	=	$0132
L0133	=	$0133
L0134	=	$0134
L0135	=	$0135
L0136	=	$0136
L0137	=	$0137
L0138	=	$0138
L0139	=	$0139
L013A	=	$013A

BLMCELL	=	$013B
BLMCELL_RPMMASK =	%00000011 
BLMCELL_MAPMASK =	%00001100 

MPH	=	$013C	; Filtered MPH 16 bit resolution ??
NMPH	=	$013E	; NMPH = (16/5) * FILTMPH TurboP4.pdf 2.4.5 
L013F	=	$013F
L0140	=	$0140
L0142	=	$0142
L0144	=	$0144
L0146	=	$0146
L0148	=	$0148
CTSFILT	=	$0149
COOLDEGA	=	$014B	; Linearised CTS
CTS116MAX	=	$014C	; Linearised CTS Limited to 116 DegC
CTSSTART	=	$014D	; CTS At Engne Start
ADCTS	=	$014E
ADBAT	=	$014F
ADINJ	=	$0150
F33BVC	=	$0151
FA_RATIO	=	$0152	; Fuel-Air Ratio (1 / (AFRATIO * 10)) * 256
L0154	=	$0154
L0156	=	$0156
L0158	=	$0158
L0159	=	$0159
L015A	=	$015A
L015C	=	$015C	; Up/Down Counter
L015D	=	$015D
L015E	=	$015E
NTREV 	=	$015F	; NTREV65 / 1
L0161	=	$0161
L0163	=	$0163
L0164	=	$0164
L0166	=	$0166
L0168	=	$0168
BCDBLINK_CODE =	$016A	; Top 8 bits = number of blinks in MSChar. Bottom 8 bits = number of blinks in LSChar.
BLINK_INDEX =	$016C	; Index of current blinkcode in blinkout lookup table
BLINK_MALFWD =	$016D	; Stores the current MALFWD (MALFWD1..5) during TC Blink Codes
BLINK_TIMER =	$016E	; Used as a downcounter to time TC Blink Codes

L016F	=	$016F	; MALFWD1 History
L0170	=	$0170	; MALFWD2 History
L0171	=	$0171	; MALFWD2 History
L0172	=	$0172	; MALFWD2 History
L0173	=	$0173	; MALFWD2 History

L0174	=	$0174	; FANMW Down counter
L0175	=	$0175
L0176	=	$0176
NTRPMX_COUNT =	$0177
FANRUNON	=	$0178	; Timer to count how long the fan has been on once the engine is off. Turns fan off after KFANRUNON
ADOIL	=	$017A
OILTEMP	=	$017B
M33CNT	=	$017E
TC43_COUNT =	$017F
TC54_COUNT =	$0180
TC21_COUNT =	$0181	; Up Counter for TC21's
TC44_COUNT =	$0182	; Up Counter for TC44's
TC45_COUNT =	$0183	; Up Counter for TC45's
TC13_COUNT =	$0184	; Up Counter for TC13's
TC64_COUNT =	$0185	; Up Counter for TC64's
TC65_COUNT =	$0186	; Up Counter for TC65's
TC63_COUNT =	$0187	; Up Counter for TC63's
TC24_COUNT =	$0188	; Up Counter for TC24's
TC16_COUNT =	$0189	; Up Counter for TC16 & TC33
TC23_COUNT =	$018A	; Up Counter for TC23's
TC25_COUNT =	$018B	; Up Counter for TC25's
TC31_COUNT =	$018C	; Up Counter for TC31's (16 bit)

L018E	=	$018E
ESTFBCNT	=	$018F
TC42B_COUNT =	$0191
PURGEDC	=	$0192
L0193	=	$0193
L0194	=	$0194
WGATEDC	=	$0195
L0196	=	$0196
fnL8883	=	$0197
WGATE_BLMDC =	$0198
WGATE_NOCKT =	$0199
L019A	=	$019A
L019B	=	$019B
TBOTIME	=	$019C
MAPDES	=	$019E	; Desired MAP for this RPM
MAPDELTADES =	$019F	; Difference in Desired and Actual MAP for this RPM
;
;
L01A0	=	$01A0
OVBSTTM	=	$01A1	; 16 Bit Overboost timer 
WGATEMAPN2 =	$01A3
WGATEBLM	=	$01A4
WGBLMCELLCT =	$01A5
WGBLMCELL	=	$01A6	; Current Calculated Wastegate BLM Cell number
WGBLMCELL1 =	$01A7	; Last Calculated Wastegate BLM Cell number
;
;
TIMER_TICK_ERROR =	$01A8	; Stores the first failed TIMER_TICK value
REFRESH_ADDR =	$01A9
L01AB	=	$01AB
L01AD	=	$01AD
L01AE	=	$01AE
L01B0	=	$01B0
SPI_JUNK	=	$01B1	; This is the value that was in the SPI when we found it 
LAST_L3FC4 =	$01B2	; Last value of TIMER2
TIMESEC	=	$01B4
L01B6	=	$01B6
L01B7	=	$01B7
L01B8	=	$01B8
L01B9	=	$01B9
EWPRUNON	=	$01BA	; Timer to count how long the EWP has been on once the engine is off. Turns fan off after KEWPRUNON
ADBARO	=	$01BC
L01BD	=	$01BD
L01BE	=	$01BE
L01C0	=	$01C0
ADMAT	=	$01C1
ADMATFILT	=	$01C2
MATA	=	$01C3	; Linearised MAT, 1 DegC resolution, starting at -40 (0x00 = -40 DegC)
AIR_DENSITY =	$01C4	; Air density fuel correction from MAT
NTPSLDFILT =	$01C6
L01C8	=	$01C8
L01C9	=	$01C9
L01CA	=	$01CA
L01CB	=	$01CB
L01CC	=	$01CC
L01CD	=	$01CD
L01CE	=	$01CE
L01CF	=	$01CF
FILTL01D0	=	$01D0
L01D2	=	$01D2
L01D3	=	$01D3
L01D4	=	$01D4
L01D5	=	$01D5
L01D6	=	$01D6
TC33_COUNT =	$01D7	; Up Counter for TC33's
TC34_COUNT =	$01D8	; Up Counter for TC34's

ALDL_COUNT =	$0200	; ALDL Count of bytes transferred so far
ALDL_CSUM	=	$0201	; ALDL Checksum 
ALDL_PTABLE =	$0202	; Pointer to the current ALDL command's control table
ALDL_MODE	=	$0226	; Current ALDL mode / Start of copy of input data
L0227	=	$0227
L0229	=	$0229
L022B	=	$022B
L022D	=	$022D
L022F	=	$022F

ALDLMD_DCW =	$0248	; Discrete output control word

ALDLMD_DSTW =	$0249	; Discrete output enable word
ALDLMD_DSTW_CEL =	%00000001
ALDLMD_DSTW_FAN =	%00000010
ALDLMD_DSTW_AC =	%01000000	; A/C Compressor Off/On

ALDLMDEW =	$024A
ALDLMDEW_FCL =	%00000001	; Enable fuel closed loop backup
ALDLMDEW_SPARK =	%00001000	; Enable spark backup
ALDLMDEW_BLMRST = 	%00010000	; Reset O2 BLM's
ALDLMDEW_IACVRST = 	%00100000	; Reset IACV
ALDLMDEW_CLRMALF = 	%01000000	; Clear Malfunction codes

ALDLMDST	=	$024B
ALDLMDST_FCL =	%00000001	; Enable fuel closed loop backup

ALDLMD_PWMCW =	$024C     ; Pulse width modulator control word

ALDLMD_PWMDC =	$024D	; Desired ALDL PWM Duty Cycle

ALDLMD_FMCW =	$024E	; Function Modification Control Word. See TurboP4.pdf Sec 6.2.5.1.
ALDL_FMCW_IACMOD =	%00000001	; IACV Modify 	
ALDL_FMCW_IACRPM =	%00000010	; 0 = IAC position, 1 = RPM 	
ALDL_FMCW_AFMOD =	%00000100	; if set ALDLMD_AFRATIO is used 	
ALDL_FMCW_SPKMOD =	%00001000	; 1 = Spark modification used 	
ALDL_FMCW_SPKDTA =	%00010000	; 0 = Spark Mod Absolute, 1 = Spark mod Delta 	
ALDL_FMCW_SPKRTD =	%00100000	; 0 = Spark Mod Advance, 1 = Spark mod Retard 	

ALDLMD_IACRPM =	$024F	; Desired IAC Position, or Engine RPM

ALDLMD_AFRATIO =	$0250	; Desired Air/Fuel ratio 

ALDLMD_SAD = 	$0251	; Desired Spark Absolute/Delta modification

ALDL_MSGID =	$0252     ; ALDL Message ID of the command we are about to respond to
ALDL_BYTES_TODO =	$0253	; ALDL Count of bytes remaining to be transferred
ALDL_AWAKE_TIME =	$0254	; Increments every second. Cleared when a byte is Rx'ed. When = 5, puts ALDL to sleep
ALDL_SCHED =	$0255	; ALDL The Normal Mode Scheduled Frame
ALDL_WORDLSB =	$0256	; Used to store the hi byte of a 16bit ALDL value, so it doesn't change
ALDLMW_T1	=	$0257	; Some kind of ALDL timeout counter
ALDLMW_T2	=	$0259	; Some kind of ALDL timeout counter
MOVING_TIME =	$025B	; Incremented whilst NMPH > 0
RAM_TOP_WORD_ADDR = $025C
L025D	=	$025D

STACK_TOP =	$02FF

L0458	=	$0458
L0459	=	$0459
L045A	=	$045A
L045D	=	$045D
L0461	=	$0461
L0463	=	$0463

L3DFC	=	$3DFC
L3F80	=	$3F80
L3F82	=	$3F82
L3F84	=	$3F84
L3F86	=	$3F86
L3F88	=	$3F88
L3F8A	=	$3F8A
PWM_EFAN	=	$3F8C	; Electric Cooling Fan
PWM_ACCLUTCH =	$3F8E     ; Air Conditioning Clutch 
PWM_EXCPV	=	$3F90	; Exhaust Counterpressure Valve PW Out Cntr
L3F92	=	$3F92
L3F94	=	$3F94
L3F96	=	$3F96
L3F98	=	$3F98
L3F9A	=	$3F9A
L3F9C	=	$3F9C
L3F9E	=	$3F9E
L3FAC	=	$3FAC
L3FAE	=	$3FAE
L3FB0	=	$3FB0
L3FB2	=	$3FB2
L3FB4	=	$3FB4
L3FB6	=	$3FB6
L3FBC	=	$3FBC

L3FC0	=	$3FC0	; Ref Period Timer
L3FC2	=	$3FC2	; Timer #1 (Input 5)
L3FC4	=	$3FC4	; Timer #2 (Input 6)
L3FC6	=	$3FC6	; Cntr #1 (Cum Pulses)
CNT_EST	=	$3FC8	; Cntr #2 Spark PERIOD, (EST Feed Bk counter, in 3) - PA2 counter
L3FCA	=	$3FCA	; Cntr #3 (16.5 Khz cntr if In 4 is hi)
L3FCC	=	$3FCC	; PW Mod cntr, (P8) ARC
L3FCE 	=	$3FCE	; ??? DELAY - EFI DLY

L3FD0	=	$3FD0	; To MCU ? - Sync Fuel = 0 - BPW = 5 msec
PWM_WGATE	=	$3FD2	; WGATEDC PW Out Cntr
PWM_PURGE	=	$3FD4	; PURGEDC PW Out Cntr
PWM_EWP	=	$3FD6	; Electric Water Pump Output Controller
L3FD8	=	$3FD8	; CCP PW Out Cntr
L3FDA	=	$3FDA	; Mass Air B.U. PW TMR
L3FDC	=	$3FDC	; Spark Dwell Counter

L3FE0	=	$3FE0	; Cntr #4 (Cum pulses on in 5)
L3FE4	=	$3FE4     ; B Cntr Bgn nxt Dwell
L3FE6	=	$3FE6     ; Spark Dwell Counter
L3FE8	=	$3FE8     ; CURRENT EST FALL - LAST EST FALL
L3FEC	=	$3FEC     ; B Cntr last ref

L3FF2	=	$3FF2     ; Async PW Cntr
L3FF6	=	$3FF6     ; EST FALL CNTR (Time Fm Ref to Fire IGN Cntr)
L3FF8	=	$3FF8     ; PA1 (counter)
L3FFA	=	$3FFA     ; Get MCU Status Reg.
L3FFC	=	$3FFC     ; MCU CSR

IOREG4000	=	$4000	; SPI Port Base
SPI_CTRL_REG =	$4001	; SPI Control Register
IO_PORTA =	$4002	; IOPORT A                                       
DDR_PORTB =	$4003	; IOPORT B Data Direction Register ?                                       
IO_PORTB =	$4004	; IOPORT B
HW_COUNTER =	$4005	; Free running timer                                        
IRQ_TIME =	$4006	; Interrupt when 0x4005 = 0x4006                                       
SCI_CTRL_REG =	$4007	; SCI Control Port 
ALDL_FLAG_REG =	$4008	; ALDL Flags register
ALDL_RXD_REG =	$4009	; ALDL Rx register
ALDL_TXD_REG =	$400A	; ALDL Tx register
COP_WDOGFF =	$400B	; COP Watchdog timer = 0xFF
COP_WDOG00 =	$400C	; COP Watchdog timer = 0x00

;SPI_DATA is an 8 bit I/O port. It is used to transmit data to a 
;peripheral (on write) or to read data from a peripheral (when read)
;
SPI_DATA	=	$0	; SPI_DATA is at 0x4000, or IOREG4000[0]
;
VBATAtoD	=	$08	; ADBAT AtoD Register
L02AtoD	=	$10	; ADLO2 AtoD Register
MAPAtoD	=	$18	; ADMAP AtoD Register
CTSAtoD	=	$20	; ADCTS AtoD Register
TPSAtoD	=	$28	; ADTHROT AtoD Register
INJAtoD	=	$30	; Injector Voltage AtoD Register ?
ALDLAtoD	=	$38	; ADALDL AtoD Register
RO2AtoD	=	$48	; ADRO2 AtoD Register
KNOCKAtoD	=	$58	; Knock sensor AtoD Register
MATAtoD	=	$68	; ADMAT AtoD Register
OILAtoD	=	$78	; ADOIL AtoD Register
BAROAtoD	=	$80	; ADBARO AtoD Register
ENDAtoD	=	$98	; Tell AtoD were done

;
;SPI_CTRL is an 8 bit control port
;
SPI_CTRL	=	$1	; SPI_CTRL is at 0x4001, or IOREG4000[1]
SPI_START =	%10000000	; 
;
;IOPORTA is an 8 bit ouput port. Each bit, when cleared low, is used to
;enable a device on the Serial Peripheral Interface (SPI). Most SPI 
;routines start with a clr IOREG4000,IOPORTA,SPI_??, and end with a
;set IOREG4000,IOPORTA,SPI_??
;
IOPORTA	=	$2	; IOPORTA is at 0x4002, or IOREG4000[2]
IACV_DRIVE =	%00000011	; 2 phase IAC motor drive
NOT_IACV_DRIVE =	%11111100	; 2 phase IAC motor drive
SPI_DEV3	=	%00000100	; SPI Unknown Device 3 - I/O
SPI_ADC =		%00001000	; SPI Analog to digital converter
SPI_ALDLTX =	%00010000	; ALDL Output buffer enable bit
SPI_DEV7 =	%01000000	; SPI Unknown Device 7 - I/O
SPI_DEV8 =	%10000000	; SPI Unknown Device 8 - Output Only

IOPORTB	=	$4	; IOPORTB is at 0x4004, or IOREG4000[4]
COUNTER =		$5	; Free running counter
IRQTIME =		$6	; Interrupt when COUNTER = IRQTIME

SCI_CTRL =	$7	; SCI Control is at 0x4007, or IOREG4000[7]
SCI_EXTIRQ =	%00000001 ; External (Maskable ?) Interrupt Enable
SCI_RE =		%00000010 ; ALDL Rx Enable
SCI_RWU =		%00000100 ; ALDL Rx Sleep mode - wait for a wakeup event
SCI_TE =		%00001000 ; ALDL Tx Enable
SCI_ILIE =	%00010000 ; ALDL Rx IDLE Line Interupt Enable
SCI_RDRF =	%00100000 ; ALDL Rx Data Register Full Interrupt Enable
SCI_TC =		%01000000 ; ALDL Tx Complete Interrupt Enable
SCI_TDRE =	%10000000 ; ALDL Tx Data Register Empty Interrupt Enable
;
ALDL_REG =	$8	; Interrupt flags are at 0x4008, or IOREG4000[8]
ALDL_EXTIRQ =	%00000001 ; External Interrupt occured
ALDL_FE =		%00000010 ; ALDL Rx Framing error occurred
ALDL_NF =		%00000100 ; ALDL Rx Noise Flag occurred
ALDL_OE =		%00001000 ; ALDL Rx Overrun error occurred
ALDL_IDLE =	%00010000 ; ALDL Rx IDLE occurred
ALDL_RDRF =	%00100000 ; ALDL Rx Data Register Full
ALDL_TC =		%01000000 ; ALDL Tx Complete
ALDL_TDRE =	%10000000 ; ALDL Tx Data Register Empty
;
ALDL_RXD =	$9	; ALDL Receive reg at 0x4009, or IOREG4000[9]
;
L5000	=	$5000
L5800	=	$5800
L5803	=	$5803
L5806	=	$5806
L580C	=	$580C
L580F	=	$580F
L5812	=	$5812
L5B70	=	$5B70
L6000	=	$6000
;
	org	$8000
;
PROMIDA:	dw	$0919
DATECODE:	dw	$006F
SEQNUMR:	dw	$064F
KKSUM:	dw	$4F33
KKPGMID:	db	$B0
L8009:	db	$CA,$35,$14,$D1,$7E,$20
KNUMCYL:	db	$C0	; 0xC0 = 6 Cylinders. See TurboP4.pdf 2.4.4
KMAXCYL:	db	$06	; Maximum value of CYLINDER
L8011:	dw	$0008	; SPI_DEV7 Initialisation value
L8013:	dw	$0CCD
L8015:	dw	$0666
L8017:	dw	$BB80
KFILTMPH:	db	$FF	; Filtered MPH Lag Filter coefficient 
L801A:	db	$00	; MW2_MAPVACUUM flag on hysteresys
L801B:	db	$00	; MW2_MAPVACUUM flag off hysteresys 
L801C:	dw	$0258	; = 600 Seconds

KAFOPT1:	db	$06
KAFOPT1_BLMINIT =	%00000001 ; Set is we init the BLM
KAFOPT1_2BARMAP =	%00000100	; Set for a 2Bar MAP, Clear for a 1Bar MAP	
KAFOPT1_SINGLE_O2 =	%01000000	; Set for a single Lambda system, clear for a dual	

KAFOPT2:	db	$0F

KAFOPT3:	db	$80

L8021:	db	$92	; multiplier used in MPH calculations
L8022:	db	$00
KREFANGL:	db	$BC	; Fixed ignition retard angle = 66 Deg / -33 Deg ?
L8024:	dw	$0071
L8026:	dw	$FF1C
;**********************************************************************
;8 word table used in routine at B5FB. Indexed by CYLINDER.
L8028:	dw	$FFFC,$0000,$FFFE,$0000,$0000,$0000,$0000,$0000 
;**********************************************************************
;17 byte table used in routine at B65C. Indexed by NTRPMX.
L8038:	db	$28,$28,$28,$16,$14,$13,$12,$11,$11
	db	$11,$11,$11,$11,$11,$11,$11,$11
;**********************************************************************
;17 byte table used in routine at BC3C. Indexed by NTPSLD
L8049:	db	$A4,$A4,$A4,$A4,$A4,$A4,$A4,$A4,$A4
	db	$A4,$A4,$A4,$A4,$A4,$A4,$A4,$A4
;**********************************************************************
L805A:	db	$08
L805B:	db	$1C	; RPMFILT = 358 RPM
L805C:	db	$2D	; RPMFILT = 576 RPM
L805D:	db	$64	; RPMFILT1 = 2500 RPM
L805E:	db	$1E	; RPMFILT = 384 RPM
L805F:	dw	$0003
L8061:	db	$FF	; CTSSTART = 0xFF
L8062:	db	$00
MINCOOL:	db	$00
L8064:	db	$00
L8065:	db	$00
;
;********************************************************************** 
;
; Indexed by A = RPM
;            B = 
;
L8066:	db $03
	db $00
	db $00
	db $11 ; Number of columns per row
; 
	db $55,$55,$50,$50,$4A,$44,$3B,$33,$2A,$25,$25,$22,$22,$22,$22,$22,$22 ;  500 RPM
	db $55,$55,$50,$50,$4A,$44,$3B,$33,$2A,$25,$25,$25,$22,$22,$22,$22,$22 ;  750 RPM
	db $55,$55,$50,$50,$4A,$44,$3B,$33,$2A,$25,$25,$22,$22,$22,$22,$22,$22 ; 1000 RPM
	db $55,$55,$55,$55,$50,$49,$40,$3A,$35,$2E,$2A,$23,$23,$23,$23,$23,$23 ; 1250 RPM
	db $63,$63,$63,$5B,$55,$4D,$45,$41,$35,$2E,$2A,$23,$23,$23,$23,$23,$23 ; 1500 RPM
	db $63,$63,$63,$5E,$53,$50,$48,$46,$40,$39,$2E,$24,$24,$24,$24,$24,$24 ; 1750 RPM
	db $64,$64,$63,$5E,$55,$52,$4D,$4D,$40,$3B,$35,$22,$1D,$18,$18,$18,$18 ; 2000 RPM
	db $64,$64,$63,$63,$55,$51,$4E,$4C,$40,$3B,$35,$24,$1E,$14,$14,$14,$14 ; 2250 RPM
	db $63,$63,$63,$63,$57,$50,$50,$50,$46,$3B,$3B,$36,$2C,$2A,$2A,$21,$21 ; 2500 RPM
	db $63,$63,$63,$63,$5A,$54,$52,$51,$46,$3A,$32,$2C,$29,$29,$29,$1F,$1F ; 2750 RPM
	db $63,$63,$63,$63,$60,$58,$55,$52,$46,$3B,$37,$2D,$2D,$2D,$2D,$2D,$22 ; 3000 RPM
	db $63,$63,$5F,$5B,$5B,$55,$50,$4D,$48,$38,$36,$2D,$2D,$2D,$2D,$2A,$28 ; 3250 RPM
	db $63,$63,$60,$5A,$5A,$50,$4A,$47,$41,$37,$37,$2A,$2A,$2A,$2A,$25,$21 ; 3500 RPM
	db $65,$65,$5F,$5A,$57,$4E,$48,$41,$3E,$37,$37,$2A,$24,$1D,$1B,$1B,$1B ; 3750 RPM
	db $65,$65,$5E,$5A,$5A,$4E,$4E,$48,$48,$40,$30,$2B,$28,$25,$21,$21,$21 ; 4000 RPM
;
; Indexed by A = (RPM8000 - 0x80)
;            B = 
;
L8169:	db $03
	db $00
	db $00
	db $11 ; Number of columns per row
;	 
	db $65,$65,$5E,$5A,$5A,$4E,$4E,$48,$48,$40,$30,$2B,$28,$25,$21,$21,$21 ; 4000 RPM
	db $69,$69,$60,$60,$5B,$55,$4F,$47,$44,$41,$36,$31,$2C,$29,$28,$1F,$1F ; 4500 RPM
	db $68,$68,$66,$5F,$5B,$55,$50,$4C,$49,$47,$41,$38,$38,$36,$35,$2E,$2E ; 5000 RPM
	db $69,$69,$69,$69,$69,$69,$69,$66,$4E,$4C,$4A,$47,$47,$43,$39,$39,$39 ; 5500 RPM  
	db $69,$69,$69,$69,$69,$69,$69,$66,$4E,$4E,$4E,$4B,$4B,$4B,$46,$46,$46 ; 6000 RPM
	db $69,$69,$69,$69,$69,$69,$69,$66,$5A,$4E,$4E,$4B,$4B,$4B,$46,$46,$46 ; 6500 RPM
	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 7000 RPM
	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 7500 RPM
;
;********************************************************************** 
;
L81F5:	db	$55
;
;********************************************************************** 
; 3D table used in routine at BE2D. Indexed by CTS116MAX & ADMAPN2
L81F6:	db	$03
L81F7:	dw	$2020
L81F9:	db	$09
L81FA:	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$15,$25,$40,$55,$55,$55,$55,$55,$55
	db	$15,$25,$40,$55,$55,$55,$55,$55,$55
	db	$15,$25,$40,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
	db	$55,$55,$55,$55,$55,$55,$55,$55,$55
;********************************************************************** 
; 16/17 byte table used in routine at DE26. Indexed by ADMATFILT
L8266:	db	$00,$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
;********************************************************************** 
; 3D Lookup table used in routine at BF76
;
; Indexed by A = MATA Limited to 0xC0
;	   B = ADMAPN2 / 2
;
; This table gives the desired ???? vs MAP and MAT when moving for less 
; than L801C seconds. Higher boost is permitted during this time 
;
L8277	dw	$0040
	db	$05
	db	$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00
	db	$00,$03,$03,$03,$03
	db	$00,$06,$06,$06,$06
	db	$03,$0B,$0B,$0B,$0B
	db	$06,$0B,$0B,$0B,$0B
	db	$17,$17,$17,$17,$17	; These 4 rows never used,
	db	$17,$17,$17,$17,$17 ; because ADMAPN2 / 2 is 
	db	$17,$17,$17,$17,$17 ; always going to be less
	db	$17,$17,$17,$17,$17 ; than 0x80
;
; This table gives the desired ???? vs MAP and MAT when moving for more 
; than L801C seconds. Boost is limited after this time 
;
L82BB:	dw	$0040
	db	$05
	db	$06,$06,$06,$09,$09
	db	$06,$06,$06,$09,$09
	db	$06,$06,$06,$09,$09
	db	$06,$06,$09,$10,$10
	db	$06,$06,$0B,$14,$14
	db	$08,$0B,$0E,$10,$10
	db	$09,$10,$10,$1C,$1C
	db	$11,$15,$15,$1C,$1C
	db	$13,$1B,$1B,$1C,$1C
	db	$1D,$1D,$1D,$1D,$1D ; These 4 rows never used,
	db	$1D,$1D,$1D,$1D,$1D ; because ADMAPN2 / 2 is 
	db	$1D,$1D,$1D,$1D,$1D ; always going to be less
	db	$1D,$1D,$1D,$1D,$1D ; than 0x80
;
;**********************************************************************
;16/17 byte table used in routine at BF84. Indexed by NTRPMX
L82FF:	db	$28,$28,$28,$28,$28,$33,$80,$60,$60
	db	$70,$95,$80,$80,$80,$AD,$AD,$AD
;**********************************************************************
L8310:	db	$35	; CTSFILT = -0.25 DegC
;**********************************************************************
;8 byte table used in routine at BF63. Indexed by deltaISESDD
L8311:	db	$00,$00,$00,$00,$00,$00,$00,$00
;**********************************************************************
L8319:	db	$00
L831A:	db	$00
L831B:	db	$00
;**********************************************************************
;14 byte table used in routine at BDEE. Indexed by CTS116MAX
L831C	db	$47,$47,$47,$47,$47,$2B,$5C,$5C
	db	$5C,$1D,$1D,$1D,$1D,$1D
;**********************************************************************
L832A:	db	$55

;**********************************************************************
;14 byte table used in routine at B1C5. Indexed by CTS116MAX
L832B:	db	$71,$71,$71,$71,$71,$71,$71,$71
	db	$61,$55,$55,$55,$55,$55
;**********************************************************************
L8339	dw	$1DFF
;14 byte table used in routine at E6B7. Indexed by CTS116MAX
L833B:	db	$30,$30,$30,$30,$30,$30,$35,$25
	db	$1A,$10,$10,$10,$10,$10
;**********************************************************************
;14 byte table used in routine at B1F4. Indexed by CTS116MAX
L8349	db	$20,$20,$20,$20,$10,$05,$05,$05
	db	$05,$05,$05,$05,$05,$05
;**********************************************************************
;14 byte table used in routine at B1F4. Indexed by CTS116MAX
L8357:	db	$80,$80,$80,$80,$80,$80,$80,$80
	db	$80,$80,$80,$80,$80,$80
;**********************************************************************
KRPMKNOB:	db	$50	; RPMFILT = 1024 RPM
KMPHKNOB:	db	$05	; MPH = 5 MPH
L8367:	db	$0E
KESCOOL:	db	$70	; = 112 DegC CTS_149
L8369:	db	$01	; = 0.75 DegC Delta CTS
;
;********************************************************************** 
;
; Used to calculate the ESC knock retard vs RPM  (NTRPMX)
;
F6:	db	$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$10
	db	$10,$10,$10,$10,$10,$10,$10,$10
;
; F7 table used to calculate the ESC knock retard decay vs RPM (NTRPMX)
;
F7:	db	$20,$20,$20,$20,$20,$20,$20,$20,$20
	db	$20,$20,$20,$20,$20,$20,$20,$20
;********************************************************************** 
;8 byte table used in routine at BEDC. Indexed by (NTRPMX - 0x10) / 2
L838C:	db	$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C
;********************************************************************** 
;Malfunction Code Validation Table 
MALFWD1_MASK:
L8394:	db	$FF    	; TC 12,13,14,15,16,21,22,23

MALFWD2_MASK:
L8395:	db	$D6       ; TC 24,25,  ,31,  ,33,34,   

MALFWD3_MASK:
L8396:	db	$7D       ; TC    41,42,43,44,45,  ,51

MALFWD4_MASK:
L8397:	db	$41       ; TC   ,53,  ,  ,  ,  ,  ,63

MALFWD5_MASK:
L8398:	db	$E0       ; TC 64,65,66,  ,  ,  ,  ,
;**********************************************************************
L8399:	db	$32	; Number of times the engine needs to start before TC's are cleared
L839A:	db	$0A
	db	$14
L839C:	db	$64
	db	$78
;
; TC13 and TC63 Lambda/Oxygen sensor TurboP4.pdf 8.2.2 
;
KKO2CT:	db	$99	; CTSFILT = 74.75 DegC
KKO2MPTI:	dw	$0078	; TIMERUN = 120 seconds before loggint TC13 & TC63
KKO2LOW:	db	$4F	; ADRO2FILT/ADLO2FILT = 0.35V
KKO2HIGH:	db	$7C	; ADRO2FILT/ADLO2FILT = 0.55V
KKO2LOD:	db	$0D	; NTPSLD = 5%
KKO2OLTM:	db	$0F	; TC13_COUNT & TC63_COUNT Trigger value
;
; TC14 High Coolant Temperature TurboP4.pdf 8.2.3
;
KKCTMPHI:	db	$E3	; COOLDEGA = 130.25 DegC
KKTCDF:	db	$87       ; COOLDEGA = 61.25 DegC
KKETMPT:	dw	$0005	; TIME = 5
;
; TC15 Low Coolant Temperature TurboP4.pdf 8.2.4
;
KKETMPLO:	db	$F0	; ADCTS = 0xF0 = 240
;
; TC16 Wastegate Overboost  TurboP4.pdf 8.2.10
;
KK16TIME:	db	$1E	; 3.0 Seconds TC16_COUNT Trigger Value
KKM33CNT:	db	$0A
;
; TC21 High Throttle Position constants  TurboP4.pdf 8.2.5
;
KKTA21A:	db	$FF	; KKTA21A = 255
KKTA21:	db	$80	; ADTHROT = 2.5V
KK21TIM:	db	$32	; ADTHROT > 2.5V counter
KKRM21:	db	$08	; RPM = ??
KKTPDF:	db	$30	; KKTPDF Default TPS durung TC21 & TC22
;
; TC22 Low Throttle Position constants  TurboP4.pdf 8.2.6
;
KKTA22:	db	$05	; KKTA22 = TC22 Min TPS sensor reading
;
; TC23 Low Manifold Air Temperature constants  TurboP4.pdf 8.2.7
;
KKMATMPLO: db	$04	; MAT = Cold ??
KK23TIME:	db	$0A	; = 1 Sec
KKETCH:	db	$85
KKETMPTL:	dw	$00F0	; TIME = 240 Seconds
KKMATDF:	db	$1D	; Default MAT during TC23 & TC25
;
; TC24 Vehicle Speed Sensor constants  TurboP4.pdf 8.2.8
;
KKVSPD:	db	$03	; MPH = 3
KKVRPMLA:	db	$28	; RPM = 1000
KKVRPMH:	db	$F0	; RPM = 6000
KK24TPS:	db	$05	; NTPSLD = 2%
KK24MAP:	db	$19	; NMAP0 = 0.18 Bar
KKVST:	db	$03       ; TC24_COUNT Trigger value
;
; TC25 High Manifold Air Temperature constants  TurboP4.pdf 8.2.9
;
KKETMPHI:	db	$F3	; ADMAT
KK25TIME:	db	$1E       ; TC25_COUNT Trigger value
KKETMPTH:	dw	$003C	; TIME = 60 Seconds
KK25MPH:	db	$05	; MPH = 5
;
; TC31 Camshaft speed sensor constants  TurboP4.pdf ????
;
L83C3:	dw	$0708
L83C5:	dw	$000A
;
; TC33 Manifold Air Pressure Too High constants  TurboP4.pdf 8.2.12
;
KKPM33:	db	$E9	; ADMAP = 1.90 Bar
KKPMAC33:	db	$E9	; ADMAP = 1.90 Bar
KK2ATM33:	db	$E9	; ADMAP = 1.90 Bar
KKTA33:	db	$08	; NTPSLD = 3.125%
KK33TIME:	db	$04	; TC33_COUNT Trigger Value
;
; TC34 Manifold Air Pressure Too Low constants  TurboP4.pdf 8.2.13
;
KKPM34:	db	$0F	; ADMAP = 0.20 Bar
KKES34A:	db	$38	; RPMFILT = 700 RPM
KKTA34:	db	$33	; NTPSLD = 20%
KK34TIM:	db	$23	; TC34_COUNT Trigger Value
KMAPHIDF:	db	$F0	; ADMAP = 1.96 Bar
;
L83D1:	db	$FF	; Multiplied by NTPSLD at 0xC79C ish
; 
;16/17 byte table used in routine at 0xC7B0 ish. Indexed by RPM8000
;
L83D2:	db	$89,$6C,$55,$36,$20,$07,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
;
; TC41 Cylinder Select Error - Wrong MEMCAL
;
KK41CYLSEL: db	$08
;
; TC42 Bypass or EST Line Fail constants  TurboP4.pdf 8.2.15
;
KK42RM:	db	$04	; 100 RPM ????
KK42TIM:	db	$02
KK42ESTCT: db	$40	; MAX EST Pulses per TC42 Check
;
; TC43 Knock Sensor Failed constants  TurboP4.pdf 8.2.16
;
KK43KRDF:	db	$14	; Default Knock Rtd when TC43 signalled
L83E8:	db	$0E
L83E9:	db	$FF
L83EA:	db	$4B	; = 0.61 BAR
L83EB:	db	$2A
KK43ATIM:	db	$14	; = 2.0 Sec
KKM43ATH:	db	$E6	; ADKNOCK = 4.51 V
KKM43ATL:	db	$21	; ADKNOCK = 0.65 V
;
; TC44 & TC64 Lean Oxygen Sensor constants  TurboP4.pdf 8.2.17
;
KKO2MIN:	db	$2D	; 0.2V
KK44TIM:	db	$3C	; 60 Seconds
;
; TC45 & TC65 Rich Oxygen Sensor constants  TurboP4.pdf 8.2.18
;
KKO2MAX:	db	$AA	; 0.75V
KK45TIM:	db	$1E	; 30 Seconds
KK45TPH:	db	$33	; NTPSLD = 20%
KK45TPL:	db	$07	; NTPSLD = 2.7%
;
; TC52 High Oil Temperature sensor voltage (Not used ?)
;
KK52TIM:	dw	$0708	; TIMERUN = 1800 = 30 Mins
KK52OTHI:	db	$F0	; ADOIL = 140 Deg C 

KK54TIM:	db	$0F
L83F9:	db	$00
L83FA:	db	$00
L83FB:	db	$AF	; ADBAT = 17.5V
;
; TC62 Low Oil Temperature sensor voltage (Not used ?)
;
KK62OTLO:	db	$F0	; ADOIL = 140 Deg C
;
; TC66 Boost system out of limits KTA1567 TECH 1 Checking Procedures P93
;
KK66RPM:	db	$6C	; NTRPMX = 2700 RPM
;
L83FE:	dw	$00E6	; RUNTIME = 230 sec's
L8400:	db	$0A	; (NBARO - NMAP0) = 0x0A
L8401:	db	$5A
L8402:	db	$01
L8403:	db	$76
L8404:	db	$64
L8405:	db	$05
L8406:	db	$02
L8407:	db	$9A	; PURGEDC = 60%
L8408:	db	$FF	; NMPH = 79 MPH
L8409:	db	$7F	; LBLM,RBLM = 0x7F
L840A:	db	$78	; LBLM,RBLM = 0x78
L840B:	db	$9E	; CTSFILT = 78.5 DegC
L840C:	dw	$5012
L840E:	dw	$400F
;
L8410:	db	$08
	db	$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF
;
L841A:	db	$B9
L841B:	db	$B9
L841C:	db	$B9
L841D:	db	$B9
L841E:	db	$0C	; MPH = 12
L841F:	db	$06
L8420:	db	$06
L8421:	db	$96	; FANMW Downd Counter initial value = 150
L8422:	db	$0A
L8423:	db	$00
L8424:	db	$FF	; ADOIL Fan On
L8425:	db	$FF	; ADOIL
L8426:	db	$00	; ADOIL Fan Off hysteresys
L8427:	db	$FF	; NTRPMX = 6350 RPM
L8428:	db	$FF
L8429:	db	$FF
L842A:	db	$00	; MPH = 0x00
L842B:	db	$00	; L0175 initialisation value
L842C:	db	$0F  

KCTSFANON: db	$B6	; CTSFILT FANON 96.5 Deg C
KMATFANON: db	$99	; MATA FANON 113 Deg C
KCTSFANOFF: db	$AD	; CTSFILT FANOFF 89.75 Deg C
KMATFANOFF: db	$92	; MATA FANOFF 106 Deg C
KFANRUNON: dw	$0384	; FAN maximum run on time 900 sec / 15 mins

KCTSEWPON: db	$B0	; CTSFILT EWPON 92 Deg C
KMATEWPON: db	$9C	; MATA EWPON 116 Deg C
KCTSEWPOFF: db	$AD	; CTSFILT EWPOFF 89.75 Deg C
KMATEWPOFF: db	$92	; MATA EWPOFF 106 Deg C
KEWPRUNON: dw	$0384	; EWP maximum run on time 900 sec / 15 mins 

L8439:	db	$FE
L843A:	db	$C8	; CTSFILT = 110 Deg C
L843B:	db	$DE	; OILTEMP = 126.5 DegC
L843C:	db	$10	; deltaOILTEMP when A/C On = 12 DegC
L843D:	db	$84	; MPH = 132
L843E:	dw	$00B4	; Fan run on time 180 seconds
L8440:	db	$1E	; L01C0 initialisation value
L8441:	db	$C8	; NTRPMX = 5000 RPM
L0036_INI: db	$0A	; L0036 initalisation value - BLM stuff ?
L0036_MAX: db	$0C	; L0036 maximum value
L0036_MIN: db	$01	; L0036 minimum value
L8445:	db	$05
L8446:	db	$3C                         
;
;
;
L8447:	db	$FF	; CTSFILT 151.25 C
L8448:	db	$FF	; CTSFILT 151.25 C
L8449:	dw	$0050	; TIMERUN 80 Sec
L844B:	dw	$0019	; TIMERUN 25 Sec
L844D:	db	$E6	; NTPSLD = 90 %
L844E:	db	$FF
L844F:	db	$5B
L8450:	db	$FF	; NTRPMX = 6350 RPM
L8451:	db	$58	; NTRPMX = 2200 RPM
L8452:	db	$FF
L8453:	db	$24
;
; Exhaust Counterpressure valve opening/closing Constants 
;
L8454:	dw	$0000	; TIMERUN 0 sec Exhaust Counter Pressure EQN
L8456:	dw	$009E	; TIMERUN 158 sec Exhaust Counter Pressure EQN
L8458:	db	$4D	; CTSSTART 17.75 DegC Exhaust Counter Pressure EQN
L8459:	db	$5D	; CTSSTART 29.75 DegC Exhaust Counter Pressure EQN
L845A:	db	$93	; COOLDEGA 70.25 DegC Exhaust Counter Pressure EQN 
L845B:	db	$66	; NTPSLD 40% Exhaust Counter Pressure EQN
L845C:	db	$74	; NTRPMX 2900 RPM Exhaust Counter Pressure EQN 
L845D:	db	$68	; NTRPMX 2600 RPM Exhaust Counter Pressure EQN
L845E:	db	$69	; ADMAPN 0.9 Bar Exhaust Counter Pressure EQN
L845F:	db	$62	; ADMAPN 0.85 Bar Exhaust Counter Pressure EQN
;
;
;
L8460:	db	$25	; DELTA NTPSLD = 14.5 %
L8461:	db	$F0
L8462:	db	$FF 	; 6350 RPM
L8463:	db	$00
;
;********************************************************************** 
; 3D table used in routine at C2AF. Indexed by RPM8000 & ADMAPN2
L8464	dw	$3090
	db	$08
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
;********************************************************************** 
;16/17 byte table used in routine at 0xC2E0 ish. Indexed by NTPSLD
L84D7:	db	$80,$80,$80,$80,$80,$80,$80,$80,$80
	db	$80,$80,$80,$80,$80,$80,$80,$80
;********************************************************************** 
;16/17 byte table used in routine at 0xC2E6 ish. Indexed by ADBAT
L84E8:	db	$00,$FF,$FF,$FF,$F0,$57,$2C,$18,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00
;********************************************************************** 
L84F9:	db	$6D
L84FA:	dw	$0001	;NTREV65 divisor
L84FC:	db	$A7	;CTSSTART = 85.25 DegC
;
;
;
L84FD:	dw	$1300
;
;? byte table used in routine at DBFB. Indexed by CTS116MAX
L84FF:	db	$B0,$B0,$8D,$56,$2C,$2C,$2C
	db	$27,$24,$1C,$15,$12,$15,$15           
;	
;**********************************************************************
;8 byte table used in routine at C883. Indexed by NTPSLD
L850D:	db	$08
L850E:	db	$80,$A2,$A2,$B2,$C4,$D2,$E6,$00
;**********************************************************************

	db	$00
	
;**********************************************************************
;13? byte table used in routine at B1EC. Indexed by MATA
L8517:	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00
;**********************************************************************
	
L8524:	db	$FF,$00,$00,$FF,$00,$00,$FF,$00
	db	$00,$FF,$00,$00,$FF,$00,$00,$FF

L8534:	db	$FF,$00,$00,$FF,$00,$00,$FF,$00
	db	$00,$FF,$00,$00,$FF,$00,$00,$FF

L8544:	db	$FF,$00,$00,$FF,$00,$00,$FF,$00

K3:	db	$44	;NTPSLD Gain Calibration TurboP4.pdf 2.4.3
K4:	db	$0D	;Lower TPS Init value TurboP4.pdf 2.4.3.1
KTAOFF:	db	$01
KCTSFILT:	db	$10
KOILFILT:	db	$40
KADO2FILT: db	$05
KO2FFO:	db	$66
MINBPINJ:	dw	$0037	;LBPINJ & RBPINJ minimum limit
DEFBPINJ:	dw	$0037     ;LBPINJ & RBPINJ minimum default
L8557:	db	$FF	;MPH = 255
	dw	$00CC	;NTREV65
	dw	$0199	;NTREV65
L855C:	db	$FE	;MPH = 254
	dw	$00CE	;NTREV65
	dw	$019B	;NTREV65
;**********************************************************************
;17 byte table used in injector voltage corretion routines. Indexed by
;ADINJ or ADBAT, depending on various trouble codes
;	
;See TurboP4.pdf 9.1.6
; 
F33:	db	$00,$D0,$D0,$D0,$4B,$4B,$28,$18,$04
	db	$00,$00,$00,$00,$00,$00,$00,$00
;**********************************************************************
;17 byte table used in 
L8572:	db	$05,$05,$05,$05,$03,$03,$03,$03,$02
	db	$02,$02,$01,$01,$01,$00,$00,$00
;**********************************************************************
KFA_STOIC: dw	$01BD	; FA_RATIO = 14.7:1 (1 / (AF_RATIO * 10)) * 256
L8585:	dw	$03D0
;**********************************************************************
;17 byte table used in several (initialisation ?) routines.
L8587:	db	$00,$00,$00,$00,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00,$00
;**********************************************************************
;
; This table specifies the AFRATIO enrichment as a function of
; CTS116MAX. 
;
F54:	db	$C8,$B4,$A5,$96,$80,$3D,$3D,$34
	db	$21,$18,$00,$00,$00,$00
;**********************************************************************
L85A6:	dw	$0A00
;14 byte table used in routine at E6B7. Indexed by CTS116MAX
L85A8	db	$5E,$5E,$5E,$5E,$5E,$02,$02,$14
	db	$14,$14,$02,$02,$02,$02
;**********************************************************************
;14 byte table used in routine at B1F4. Indexed by CTS116MAX
L85B6:	db	$35,$35,$35,$35,$35,$09,$09,$0A
	db	$0A,$0A,$05,$05,$05,$05
;**********************************************************************
;14 byte table used in routine at B1F4. Indexed by CTS116MAX
L85C4:	db	$FC,$FC,$FC,$FC,$FF,$FF,$FF,$FF
	db	$FF,$FF,$FF,$FF,$FF,$FF
;**********************************************************************
L85D2:	db	$DD
;**********************************************************************
;14 byte table used in routine at B1F4. Indexed by CTS116MAX
L85D3:	db	$85,$71,$60,$60,$60,$4B,$4B,$43
	db	$41,$37,$23,$23,$23,$23
;**********************************************************************
L85E1:	db	$4D	; CTSFILT = 17.75 Deg C
L85E2:	db	$99	; CTSFILT = 74.75 Deg C
L85E3:	db	$3B	; MATA = 19 Deg C
L85E4:	db	$03	; NTPSLD = 3
L85E5:	db	$31	; NMPH  = 0x31 = 15 MPH 
L85E6:	db	$2C	; MPH = 44 MPH
L85E7:	db	$50	; RPMFILT = 1000 RPM
L85E8:	db	$80	; RPMFILT = 1600 RPM
L85E9:	db	$A0
L85EA:	db	$10
L85EB:	db	$01
L85EC:	db	$FF
L85ED:	db	$FF
KADO2AF:	db	$F0
KO2MAXMIN: dw	$6C5F	;Max = 0x6C, Min = 0x5F
KO2INTDEC: dw	$00C8	; O2 Integrator down adjust
KO2INTINC: dw	$00F0	; O2 Integrator up adjust
KO2INTMAX: dw	$C000	; O2 Integrator maximum value
KO2INTMIN: dw	$4000	; O2 Integrator minimum value
L85F9:	db	$01
L85FA:	db	$70,$90,$90,$90,$90
L85FF:	db	$90,$90,$90,$90,$90
L8604:	db	$90,$80,$80,$80,$80
L8609:	db	$80,$40,$40,$40,$40
L860E	db	$20,$20,$20,$20,$20
L8613:	db	$05,$25,$25,$25,$25
L8618:	db	$00,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
L8624:	db	$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
L8630:	db	$93
L8631:	db	$4D
L8632:	db	$96,$1E,$02 
L8635:	db	$00,$10,$10,$10,$10,$10,$10,$10
	db	$10,$10,$10,$10,$10,$10,$10,$10
;**********************************************************************
; 4 byte table of RPM values used in BLMCELL calculations
L8645:	db	$10	; = 400 RPM
L8646:	db	$20	; = 800 RPM
L8647:	db	$3C	; = 1500 RPM
L8648:	db	$50	; = 2000 RPM
;**********************************************************************
; 3 byte table of MAPN values used in BLMCELL calculations
L8649:	db	$28	; = 0.32 BAR ?
L864A:	db	$46	; = 0.57 BAR ?
L864B:	db	$64	; = 0.78 BAR ?
;**********************************************************************
L864C:	db	$02	; used in BLMCELL RPM change calculations
L864D:	db	$02       ; used in BLMCELL MAPN change calculations
;**********************************************************************
L864E:	db	$9A	; CTSFILT = 75.5 Deg C
L864F:	db	$F0	; CTSFILT = 140 Deg C
L8650:	db	$14	; NMAP0 = 0.24 Bar 
KBLMCNT:	db	$1C
L8652:	db	$01
;**********************************************************************
KBLMMAX:	db	$A0	; Upper limit on BLM values
KBLMMIN:	db	$5A       ; Lower limit on BLM values
;**********************************************************************
L8655:	db	$05
L8656:	db	$05
L8657:	db	$3C
L8658:	db	$28	; = 1000 RPM
L8659:	db	$1A
L865A:	db	$1E
L865B:	db	$FF
L865C:	db	$06
L865D:	db	$0A	; NTPSLD = 0x0A
L865E:	db	$7B
L865F:	db	$0D	; MPH = 13
L8660:	db	$08
L8661:	db	$26
L8662:	dw	$0120
L8664:	db	$02
L8665:	dw	$0018
L8667:	db	$00
KNTPSLDFILT: db	$1B
L8669:	db	$03
L866A:	db	$00
KFILTL01D0: db	$40
L866C:	db	$0B
L866D:	db	$00
;**********************************************************************
;16/17 byte table used in routine at 0xD065 ish. Indexed by ????
L866E:	db	$14,$14,$14,$14,$14,$14,$14,$14,$14
	db	$14,$14,$14,$14,$14,$14,$14,$14
;**********************************************************************
;16/17 byte table used in routine at 0xDBFB ish. Indexed by CTSFILT 
L867F:	db	$00,$00,$00,$00,$00,$C0,$80,$70,$60
	db	$40,$40,$40,$40,$40,$40,$40,$40
;**********************************************************************
;16/17 byte table used in routine at 0xDBFB ish. Indexed by CTSFILT 
L8690:	db	$F0,$F0,$E8,$E0,$DC,$A0,$90,$80,$70
	db	$5A,$55,$55,$55,$55,$46,$46,$46
;**********************************************************************
;16/17 byte table used in routine at 0xDE3B ish. Indexed by ADMATFILT
L86A1:	db	$80,$80,$80,$80,$80,$80,$80,$80,$80
	db	$80,$80,$80,$80,$80,$80,$80,$80
;**********************************************************************
;16/17 byte table used in routine at 0xDE3B ish. Indexed by ADMATFILT
L86B2:	db	$80,$80,$80,$80,$80,$80,$80,$80,$80
	db	$80,$80,$80,$80,$80,$80,$80,$80
;**********************************************************************
;16/17 byte table used in routine at 0xDBFB ish. Indexed by CTSFILT 
L86C3:	db	$10,$10,$10,$10,$10,$70,$40,$10,$10
	db	$10,$10,$10,$10,$10,$10,$10,$10
;**********************************************************************
;16/17 byte table used in routine at 0xD0D3. Indexed by ????
L86D4:	db	$00,$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E
	db	$1E,$1E,$1E,$1E,$1E,$1E,$1E,$1E
;**********************************************************************
L86E5:	db	$80
L86E6:	db	$0A
L86E7:	db	$05
;**********************************************************************
;16/17 byte table used in routine at 0xC96D ish. Indexed by NTRPMX
L86E8	db	$82,$82,$82,$82,$82,$82,$82,$82,$82
	db	$82,$78,$78,$73,$69,$64,$50,$50
;**********************************************************************
;5 byte table used in routine at 0xDBFB ish. Indexed by CTSFILT
L86F9:	db	$04
	db	$0C,$0C,$0C,$0C,$0C
;**********************************************************************
; 3D Lookup table used in routine at CA08
;
; Indexed by A = RPM8000 Limited to 0xF0
;	   B = ADMAPN2 / 2
;
; This table gives the desired ???? vs MAP and RPM when moving for less 
; than L801C seconds. Higher boost is permitted during this time 
;
L86FF:	dw	$00
	db	$09
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ;    0 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ;  500 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 1000 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 1500 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 2000 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 2500 RPM
	db	$80,$80,$80,$80,$80,$84,$84,$84,$84 ; 3000 RPM 
	db	$80,$80,$80,$80,$80,$84,$84,$86,$86 ; 3500 RPM
	db	$80,$80,$80,$80,$80,$84,$84,$8A,$8A ; 4000 RPM
	db	$80,$80,$80,$80,$80,$86,$91,$97,$97 ; 4500 RPM
	db	$80,$80,$80,$80,$80,$88,$8F,$9F,$9F ; 5000 RPM
	db	$80,$80,$80,$80,$80,$8C,$9A,$A6,$A6 ; 5500 RPM
	db	$80,$80,$80,$80,$80,$90,$A3,$AE,$AE ; 6000 RPM
	db	$80,$80,$80,$80,$80,$90,$A3,$AE,$AE ; 6500 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 7000 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 7500 RPM
;
; This table gives the desired ???? vs MAP and RPM when moving for more 
; than L801C seconds. Boost is lowered after this time 
;
L8792:	dw	$00
	db	$09
	db	$80,$80,$80,$80,$87,$8E,$8E,$8E,$8E ;    0 RPM
	db	$80,$80,$80,$80,$87,$8E,$8E,$8E,$8E ;  500 RPM
	db	$80,$80,$80,$80,$87,$8E,$94,$94,$94 ; 1000 RPM
	db	$80,$80,$80,$80,$87,$8E,$94,$94,$94 ; 1500 RPM
	db	$80,$80,$80,$80,$87,$8E,$70,$90,$90 ; 2000 RPM
	db	$80,$80,$80,$80,$87,$90,$90,$85,$92 ; 2500 RPM
	db	$80,$80,$80,$80,$87,$8E,$95,$70,$90 ; 3000 RPM
	db	$80,$80,$80,$80,$87,$8E,$75,$75,$96 ; 3500 RPM
	db	$80,$80,$80,$80,$87,$80,$90,$90,$A4 ; 4000 RPM
	db	$80,$80,$80,$80,$87,$80,$90,$90,$90 ; 4500 RPM
	db	$80,$80,$80,$80,$87,$90,$A5,$90,$CD ; 5000 RPM
	db	$80,$80,$80,$80,$87,$80,$A0,$A0,$D0 ; 5500 RPM
	db	$80,$80,$80,$80,$87,$90,$A0,$A0,$D4 ; 6000 RPM
	db	$80,$80,$80,$80,$87,$9B,$D1,$D9,$D9 ; 6500 RPM
	db	$80,$80,$80,$80,$80,$80,$FA,$FA,$FA ; 7000 RPM
	db	$80,$80,$80,$80,$80,$80,$80,$80,$80 ; 7500 RPM
;
;**********************************************************************
	db	$FF,$00
	db	$FF,$00,$10,$30,$06,$00,$00,$00,$00,$00
	fill	$00, 12
	db	$00
L883E:	db	$E0	; RPM8000 = 7000
L883F:	db	$99	; CTSFILT = 74.75 DegC
L8840:	db	$CE	; CTSFILT = 114.5 DegC
L8841:	db	$F0	; NTPSLD = 94%
L8842:	db	$02	; WGATEDC deltaADMAPN2
L8843:	db	$4A	; RPM8000 = 2312 RPM
L8844:	db	$04
KKMAPBLMUP: db	$01	; Value to increase WGATEBLM by
KKMAPBLMDN: db	$01	; Value to decrease WGATEBLM by
KKMAPBLMLO: db	$81	; WGATEBLM = -49.6%
KKMAPBLMHI: db	$7F	; WGATEBLM = +49.6%
MINTBORPM: db	$6C	; NTRPMX = 2700 RPM
L884A:	db	$10	; NOCKRTD = 16
L884B:	db	$08	; NOCKRTD = 8
L884C:	db	$32	; WGATE_NOCKT = 6.25 Sec
L884D:	db	$04
L884E:	db	$01
L884F:	db	$10
L8850:	db	$02
MINTBOMPH: db	$02	; MPH     = 2 MPH
MAXTBOTIME: dw	$0320	; TBOTIME = 800, = 10 Seconds
MAXTBOMPH: db	$87	; MPH     = 135 MPH
KOVBSTMAPON: db	$C6	; OVERBOOST On  value = 1.6 BAR
KOVBSTMAPOF: db	$A0	; OVERBOOST Off value = 1.3 BAR 
KOVBSTTM:	dw	$00A0	; OVERBOOST Time = 160 (Resolution ??)
L8859:	db	$00	; WGATEDC = 0 %
L885A:	db	$00
L885B:	db	$FF	; MPH = 255
L885C:	db	$E0
L885D:	db	$0C	; WGATEBLM increment value
L885E:	db	$0C	; WGATEBLM decrement value
L885F:	db	$01	; WGBLMCELLCT initialisation value
L8860:	db	$50	; NBARO = 0x50
;********************************************************************** 
;16/17 byte table used in routine at 0xD4D7 ish. Indexed by RPM8000
;
; This table gives the desired MAP vs RPM when moving for less than 
; L801C seconds. Higher boost is permitted during this time 
;
L8861:	db	$D1	; 1.71 Bar @    0 RPM
	db	$D1	; 1.71 Bar @  500 RPM
	db	$D1	; 1.71 Bar @ 1000 RPM
	db	$D1	; 1.71 Bar @ 1500 RPM
	db	$D1	; 1.71 Bar @ 2000 RPM
	db	$D4	; 1.74 Bar @ 2500 RPM
	db	$D4	; 1.74 Bar @ 3000 RPM
	db	$D1	; 1.71 Bar @ 3500 RPM
	db	$C3	; 1.61 Bar @ 4000 RPM
	db	$C3	; 1.61 Bar @ 4500 RPM
	db	$C3	; 1.61 Bar @ 5000 RPM
	db	$C8	; 1.64 Bar @ 5500 RPM
	db	$C8	; 1.64 Bar @ 6000 RPM
	db	$C8	; 1.64 Bar @ 6500 RPM
	db	$00	;    0 Bar @ 7000 RPM
	db	$00	;    0 Bar @ 7500 RPM
	db	$00	;    0 Bar @ 8000 RPM
;
; This table gives the desired MAP vs RPM when moving for more than 
; L801C seconds. Boost is lowered after this time
;
L8872:	db	$CF	; 1.70 Bar @    0 RPM
	db	$CF	; 1.70 Bar @  500 RPM
	db	$CF	; 1.70 Bar @ 1000 RPM
	db	$CF	; 1.70 Bar @ 1500 RPM
	db	$CF	; 1.70 Bar @ 2000 RPM
	db	$CF	; 1.70 Bar @ 2500 RPM
	db	$CF	; 1.70 Bar @ 3000 RPM
	db	$CC	; 1.67 Bar @ 3500 RPM
	db	$BC	; 1.55 Bar @ 4000 RPM
	db	$B9	; 1.53 Bar @ 4500 RPM
	db	$B9	; 1.53 Bar @ 5000 RPM
	db	$B9	; 1.53 Bar @ 5500 RPM
	db	$B9	; 1.53 Bar @ 6000 RPM
	db	$B9	; 1.53 Bar @ 6500 RPM
	db	$00	;    0 Bar @ 7000 RPM
	db	$00	;    0 Bar @ 7500 RPM
	db	$00	;    0 Bar @ 8000 RPM
;
;**********************************************************************
;
; 3D table used in routine at D342. Indexed by 
; 	if (NTRPMX < 4000)
;   	  A = NTRPMX
; 	else
;	  A = RPM8000+0x20
;
;	B = NTPSLD/2
;
L8883:	db	$00
	db	$00
	db	$09
;	
; 	NTPSLD	0%  12% 25% 37% 50% 62% 75% 87% 100%
	db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ;    0 RPM
	db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ;  400 RPM
	db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ;  800 RPM
	db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; 1200 RPM
	db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$FE ; 1600 RPM
	db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$A0 ; 2000 RPM
	db	$00,$00,$00,$00,$00,$00,$00,$32,$A5 ; 2400 RPM 
	db	$00,$00,$00,$00,$00,$00,$00,$65,$88 ; 2800 RPM
	db	$00,$00,$00,$00,$00,$00,$00,$65,$88 ; 3200 RPM
	db	$00,$00,$00,$00,$00,$00,$00,$6B,$8E ; 3600 RPM
	db	$00,$00,$00,$00,$00,$00,$00,$5A,$87 ; 4000 RPM
;
; At this point, index A switches to RPM8000 + 0x20
;                                                                 
	db	$00,$00,$00,$00,$00,$00,$00,$5A,$87 ; 4000 RPM 
	db	$00,$00,$00,$00,$00,$00,$32,$64,$99 ; 4500 RPM
	db	$00,$00,$00,$00,$00,$00,$32,$64,$CF ; 5000 RPM 
	db	$00,$00,$00,$00,$00,$00,$32,$64,$CF ; 5500 RPM 
	db	$00,$00,$00,$00,$00,$00,$00,$8C,$A5 ; 6000 RPM
	db	$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 6500 RPM
;
;********************************************************************** 
;5/6 byte table used in routine at 0xD3A8 ish. Indexed by (NBARO - 0x40)
;
;	NBARO   =<$40 $48 $50 $58,$60 $68
;		-----------------------
L891F	db	$C8,$B4,$8C,$87,$78,$78
;
;********************************************************************** 
;16/17 byte table used in routine at 0xD46B ish. Indexed by RPM8000
;Used to calculate WGATEDC vs RPM when WGATEMW_LAUNCH is set, i.e
;when RPM > 2700, but MPH < 2, for up to 10 seconds
;
L8925:	db	$00	; WGATEDC =  0% @    0 RPM
	db	$00	; WGATEDC =  0% @  500 RPM
	db	$00	; WGATEDC =  0% @ 1000 RPM	
	db	$00	; WGATEDC =  0% @ 1500 RPM
	db	$00	; WGATEDC =  0% @ 2000 RPM
	db	$00	; WGATEDC =  0% @ 2500 RPM
	db	$00	; WGATEDC =  0% @ 3000 RPM
	db	$00	; WGATEDC =  0% @ 3500 RPM
	db	$50	; WGATEDC = 31% @ 4000 RPM
	db	$50	; WGATEDC = 31% @ 4500 RPM
	db	$50	; WGATEDC = 31% @ 5000 RPM
	db	$20	; WGATEDC = 12% @ 5500 RPM
	db	$20	; WGATEDC = 12% @ 6000 RPM
	db	$20	; WGATEDC = 12% @ 6500 RPM
	db	$20	; WGATEDC = 12% @ 7000 RPM
	db	$00	; WGATEDC =  0% @ 7500 RPM
	db	$00	; WGATEDC =  0% @ 8000 RPM
;
;********************************************************************** 
L8936:
KRPMFILT:	db	$40
KISPKDL:	db	$AA	; 170 steps IAC Initial Value
L8938:	db	$00
L8939:	db	$00
L893A:	db	$00,$F0
	db	$00	; L8936 + 6
	db	$00	; L8936 + 7
;**********************************************************************
; This is the idle RPM vs Engine Temp Table
; The multiplier is 12.5 rpm, so....
; $78 = 1500, $70 = 1400, $58 = 1100, $4c = 950, $44 = 850, $3C = 750
;
L893E:	db	$78,$78,$78,$70,$70,$70,$58,$4C,$44
	db	$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C
;**********************************************************************
	db	$02,$06
L8951:	db	$03	; NTPSLD1 = 1.175%
L8952:	db	$02	; NTPSLD1 delta hysterysis
L8953:	db	$0A	; NTPSLD1 = 3.125%
L8954:	db	$06	; NMPH = 1.875 mph
	db	$05,$20,$20,$FF,$00,$05,$05,$20,$80
L895E:	db	$14
	db	$28,$0C,$02,$01,$40,$32,$5A,$20,$08,$28,$1E
L896A:	db	$14
L896B:	db	$14
	db	$08,$00,$AA,$10,$01
L8971:	db	$03
L8972:	db	$00
	db	$00	; L8936 + 61
;**********************************************************************
; 8/9 byte table indexed by CTSFILT
L8974:	db	$08
L8975:	db	$CC,$CC,$E6,$FF,$FF,$FF,$FF,$FF,$FF
;**********************************************************************
; 8/9 byte table indexed by CTSFILT 
L897E:	db	$08
L897F:	db	$91,$87,$7D,$4B,$28,$19,$19,$41,$4B
;**********************************************************************
;
;See TurboP4.pdf section 5.6.1
;
;This is the 'normal' mode ALDL message scheduler. This is often called
;Idle chatter. The interrupt program has 16 frames, each lasting 12.5mS.
;Each of these locations specify an ALDL data frame that is to be
;transmitted in the respective frame.        
;
;Since the table is completley blank, in this case no ALDL data
;if routinly transmitted - i.e. there is no idle chatter.
;
U8988:	db	$97
;
F90MST:
L8989: 	dw	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	dw	$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
;**********************************************************************
	db	$00
	db	$00,$80,$00,$05,$02,$04,$00,$00,$00,$00
	db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db	$10,$00,$06,$02,$04,$00,$00,$01,$49,$00
	db	$AB,$00,$AC,$89,$88,$00,$66,$01,$7B,$00
	fill	$00, 12
	db	$00,$F0,$00,$00,$02,$04,$00,$00
;**********************************************************************
;
;See TurboP4.pdf section 5.6.2.1
;
;Table F97 ALDL Function #0 Data;
;
;ALDL_MODE_0 Message control block
L89E6:	dw	$0000	; Link to next command
	db	$F4	; MESSAGE_ID
	db	$00
	db	$01       ; Bit 7 Clear means output Bits [5..0] data words
	dw	$0204     ; Message output buffer
	dw	$0204     ; Message input buffer

 	dw	$89E6	; F97 ALDL_MODE_0 control block pointer
 	dw	$89FB	; F95 ALDL_MODE_1 control block pointer
 	dw	$8A82	; ALDL_MODE_2 control block pointer
 	dw	$8A8B	; ALDL_MODE_3 control block pointer
 	dw	$8A94	; ALDL_MODE_4 control block pointer
 	dw	$8A9D	; ALDL_MODE_7 control block pointer
;
;**********************************************************************
;
;ALDL_MODE_1 Message control block
L89FB: 	dw	$0000	; Link to next command - no link 
L89FD: 	db	$F4	; MESSAGE_ID   
L89FE: 	db	$80       ; Bit 7 Set means TX table follows
L89FF: 	db	$40       ; Bit 7 Clear means output Bits [5..0] data words
L8A00: 	dw	$0204     ; Message output buffer
L8A02: 	dw	$0204     ; Message input buffer 
;
;Table F95 - See TurboP4.pdf section 5.6.2.2
;
L8A04: 	dw	$8000 ;-> PROMID LSB
L8A06: 	dw	$8001 ;-> PROMID MSB
L8A08: 	dw	$0003 ;-> MALFWD1 
L8A0A: 	dw	$0004 ;-> MALFWD2  
L8A0C: 	dw	$0005 ;-> MALFWD3  
L8A0E: 	dw	$0006 ;-> MALFWD4  
L8A10: 	dw	$0007 ;-> MALFWD5  
L8A12: 	dw	$0001 ;-> NVRAMWD1  
L8A14: 	dw	$0002 ;-> NVRAMWD2  
L8A16: 	dw	$0064 ;-> WGATEMW
L8A18: 	dw	$004C ;-> FMD1
L8A1A: 	dw	$004D ;-> FMD2
L8A1C: 	dw	$0051 ;-> MW1
L8A1E: 	dw	$0052 ;-> MW2
L8A20: 	dw	$0053 ;-> MW3
L8A22: 	dw	$0055 ;-> LCCPMW
L8A24: 	dw	$0057 ;-> CLCCMW
L8A26: 	dw	$0150 ;-> FUELPRLY
L8A28: 	dw	$0060 ;-> MWFA1
L8A2A: 	dw	$0049 ;-> FMDSDI
L8A2C: 	dw	$0060 ;-> MWFA1 	; (again !??)
L8A2E: 	dw	$014B ;-> COOLDEGA
L8A30: 	dw	$00F5 ;-> ADMAP
L8A32: 	dw	$010D ;-> ADTHROT
L8A34: 	dw	$014F ;-> ADBAT
L8A36: 	dw	$01BC ;-> ADBARO
L8A38: 	dw	$00CE ;-> PA3DELTA
L8A3A: 	dw	$01C1 ;-> ADMAT
L8A3C: 	dw	$0112 ;-> ADLO2
L8A3E: 	dw	$0113 ;-> ADRO2
L8A40: 	dw	$00F2 ;-> FBLM
L8A42: 	dw	$00F3 ;-> RBLM
L8A44: 	dw	$013B ;-> BLMCELL
L8A46: 	dw	$0061 ;-> LHFLMW
L8A48: 	dw	$0062 ;-> RHFLMW
L8A4A: 	dw	$00EC ;-> LINT
L8A4C: 	dw	$00EA ;-> RINT
L8A4E: 	dw	$0195 ;-> WGATEDC
L8A50: 	dw	$0192 ;-> PURGEDC
L8A52: 	dw	$0035 ;-> ISSPMP
L8A54: 	dw	$00D6 ;-> ISESDD
L8A56: 	dw	$30B8 ;-> NTREV65 MSB
L8A58: 	dw	$30B9 ;-> NTREV65 LSB
L8A5A: 	dw	$30C4 ;-> SPARKADV MSB
L8A5C: 	dw	$30C5 ;-> SPARKADV LSB
L8A5E: 	dw	$00E5 ;-> NTRPMX
L8A60: 	dw	$3013 ;-> TIMERUN MSB
L8A62: 	dw	$3014 ;-> TIMERUN LSB
L8A64: 	dw	$00CF ;-> NOCKRTD
L8A66: 	dw	$30CC ;-> NOCKCNT MSB
L8A68: 	dw	$30CD ;-> NOCKCNT LSB
L8A6A: 	dw	$013C ;-> MPH
L8A6C: 	dw	$010A ;-> NTPSLD
L8A6E: 	dw	$008E ;-> CUREFIAP
L8A70: 	dw	$0090 ;-> CUREFIBP
L8A72: 	dw	$3084 ;-> LBPINJ MSB
L8A74: 	dw	$3085 ;-> LBPINJ LSB
L8A76: 	dw	$308C ;-> RBPINJ MSB
L8A78: 	dw	$308D ;-> RBPINJ LSB
L8A7A: 	dw	$024B ;-> ALDLMDST
L8A7C: 	dw	$0054 ;-> SEQMW1
L8A7E: 	dw	$01A4 ;-> WGATEBLM
L8A80: 	dw	$0063 ;-> FANMDW 

;ALDL_MODE_2 Message control block
L8A82: 	dw	$0000	; Link to next command - no link 
L8A84: 	db	$F4	; MESSAGE_ID   
L8A85: 	db	$40       ; Bit 6 Set means TX address in output buffer
L8A86: 	db	$41	; Bit 7 Clear means output Bits [5..0] data words
L8A87: 	dw	$0204     ; Message output buffer 
L8A89: 	dw	$0204     ; Message input buffer

;ALDL_MODE_3 Message control block
L8A8B: 	dw	$0000	; Link to next command - no link 
L8A8D: 	db	$F4	; MESSAGE_ID
L8A8E: 	db	$40       ; Bit 6 Set means TX addresses in output buffer
L8A8F: 	db	$11       ; Bit 7 Clear means output Bits [5..0] data words
L8A90: 	dw	$0204     ; Message output buffer
L8A92: 	dw	$0204     ; Message input buffer 

;ALDL_MODE_4 Message control block
L8A94: 	dw	$0000	; Link to next command - no link 
L8A96: 	db	$F4	; MESSAGE_ID
L8A97: 	db	$40       ; Bit 6 Set means TX addresses in output buffer
L8A98: 	db	$01       ; Bit 7 Clear means output Bits [5..0] data words
L8A99: 	dw	$0204     ; Message output buffer 
L8A9B: 	dw	$0204     ; Message input buffer 

;ALDL_MODE_7 Message control block
L8A9D: 	dw	$0000	; Link to next command - no link 
L8A9F: 	db	$F4	; MESSAGE_ID   
L8AA0: 	db	$80       ; hummmmm
L8AA1: 	db	$0C	; Bit 7 Clear means output Bits [5..0] data words
L8AA2: 	dw	$0204     ; Message output buffer 
L8AA4: 	dw	$0204     ; Message input buffer 
;
;**********************************************************************
;
L8AA6:	dw	$FFFF     ; ALDL Timeout compare value ?
L8AA8:	dw	$0000	; ALDL Timeout compare value ?
KFILTMAP:	db	$F0	; ADMAP filter coeficient
L8AAB:	dw	$0300
L8AAD:	db	$0C
L8AAE:	db	$78
L8AAF:	db	$EE
L8AB0:	dw	$0043
;**********************************************************************
; 17 * 10 3D table used in routine at CFC6. 
; Indexed by A = RPM8000
;            B = 
;
L8AB2:	dw	$0000
L8AB4:	dw	$0070
L8AB6:	db	$0A
L8AB7:	db	$78,$7A,$7B,$7B,$7B,$7B,$7B,$7B,$7B,$7B ;    0 RPM
	db	$73,$76,$7B,$7B,$7B,$7B,$7B,$7B,$7B,$7B ;  500 RPM
	db	$73,$78,$81,$81,$81,$81,$81,$81,$81,$81 ; 1000 RPM
	db	$73,$78,$82,$82,$82,$82,$82,$82,$82,$82 ; 1500 RPM
	db	$78,$80,$84,$84,$84,$84,$84,$84,$84,$84 ; 2000 RPM
	db	$7D,$80,$89,$89,$89,$89,$89,$89,$89,$89 ; 2500 RPM
	db	$82,$82,$89,$89,$89,$89,$89,$89,$89,$89 ; 3000 RPM
	db	$89,$89,$8F,$8F,$8F,$8F,$8F,$8F,$8F,$8F ; 3500 RPM
	db	$91,$91,$94,$94,$94,$94,$94,$94,$94,$94 ; 4000 RPM
	db	$96,$96,$9C,$9C,$9C,$9C,$9C,$9C,$9C,$9C ; 4500 RPM
	db	$9B,$9B,$9C,$9E,$9E,$9E,$9E,$9E,$9E,$9E ; 5000 RPM
	db	$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E ; 5500 RPM
	db	$93,$93,$93,$93,$93,$93,$93,$93,$93,$93 ; 6000 RPM
	db	$90,$90,$90,$90,$90,$90,$90,$90,$90,$90 ; 6500 RPM
	db	$90,$90,$90,$90,$90,$90,$90,$90,$90,$90 ; 7000 RPM
	db	$94,$94,$94,$94,$94,$94,$94,$94,$94,$94 ; 7500 RPM
	db	$94,$94,$94,$94,$94,$94,$94,$94,$94,$94 ; 8000 RPM
;
;**********************************************************************
; 17 * 17 3D table used in routine at CFA7. 
; Indexed by A = (NTRPMX - 0x10) << 2 = RPM from 400 to 2000 in 100 steps
;            B = L0105
;
L8B61:	dw $0000
L8B63:	dw $0000
L8B65:	db $11
L8B66:	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$75,$73,$78,$7D,$7D,$78,$73 ;  400 RPM
	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$75,$73,$78,$7D,$7D,$78,$73 ;  500 RPM
	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$75,$73,$78,$7D,$7D,$78,$73 ;  600 RPM
	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$75,$73,$78,$7D,$7D,$78,$73 ;  700 RPM
	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$75,$76,$78,$7D,$7D,$78,$73 ;  800 RPM
	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7A,$76,$77,$78,$7D,$7D,$78,$73 ;  900 RPM
	db $79,$79,$79,$79,$79,$7A,$7A,$7A,$7A,$7E,$7A,$7A,$7D,$7D,$7D,$78,$73 ; 1000 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7E,$7A,$7A,$7D,$7D,$78,$73,$73 ; 1100 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7E,$76,$77,$78,$78,$78,$73,$73 ; 1200 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7E,$76,$76,$76,$78,$78,$73,$73 ; 1300 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7C,$7E,$76,$76,$76,$77,$78,$73,$73 ; 1400 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$77,$7E,$73,$75,$76,$77,$78,$73,$73 ; 1500 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$78,$7E,$73,$75,$76,$77,$78,$78,$78 ; 1600 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$78,$7E,$73,$73,$76,$77,$78,$78,$78 ; 1700 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$78,$7E,$78,$76,$77,$78,$78,$78,$78 ; 1800 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$78,$7E,$78,$78,$78,$78,$78,$78,$78 ; 1900 RPM
	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$78,$78,$78,$78,$78,$78,$78,$78,$78 ; 2000 RPM
;
;**********************************************************************
; 17 * 13 3D table used in routine at CFAB. 
; Indexed by A = (RPM - 0x80) (for RPM < 0xE0), i.e 2000..3500 RPM
;            A = (RPM8000) for (RPM > 0xE0), i.e 3500..7500
;            B = 
;
L8C87:	dw $0000
L8C89:	dw $0000
L8C8A:	db $11
L8C8B:	db $7C,$7C,$7C,$7C,$7C,$7C,$75,$76,$78,$78,$78,$78,$78,$78,$78,$78,$78 ; 2000 RPM
	db $82,$82,$82,$82,$82,$7F,$7F,$7C,$7C,$7C,$7A,$78,$7E,$7D,$7D,$7D,$7D ; 2250 RPM
	db $82,$82,$82,$82,$82,$82,$7F,$7F,$7F,$7F,$7E,$84,$85,$82,$7D,$7D,$7D ; 2500 RPM
	db $84,$84,$84,$84,$84,$84,$7E,$7E,$7E,$7E,$82,$87,$82,$7D,$7D,$80,$82 ; 2750 RPM
	db $89,$89,$89,$89,$89,$89,$82,$82,$82,$82,$87,$87,$87,$87,$87,$87,$87 ; 3000 RPM
	db $91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$8C,$8C ; 3250 RPM
	db $96,$96,$96,$96,$96,$96,$96,$96,$96,$96,$96,$96,$96,$96,$96,$91,$91 ; 3500 RPM
	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$96,$96 ; 4000 RPM
	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0,$96,$9B ; 4500 RPM
	db $9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E,$9E ; 5000 RPM
	db $93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93,$93 ; 5500 RPM
	db $90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90 ; 6000 RPM
	db $90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90 ; 6500 RPM
;
;**********************************************************************
; 
;16/17 byte table used in routine at 0xDE3B ish. Indexed by ADMATFILT
;
; This table looks is converting the MAT value into an air
; density value, but I don't know how ! Scott Sealander says that
; at -40C, the air density is 1.8 g/l, and at 200C, its 1.3 g/l.
; How this table relates to those values is anybody's guess.
; But since density falls with increasing temp, and this table
; rises with increasing temp, it must be an inverse table.
;
; Scott S explained all in a GMECM post on 6/6/2001 - Read the archives !
;
;                Fraction    1/Frac     AirTemp
L8D69:
db     $28     ; 0.533       1.875      -40 deg C
db     $38     ; 0.564       1.772       -8
db     $40     ; 0.580       1.724        6
db     $46     ; 0.592       1.690       16
db     $4A     ; 0.600       1.668       24
db     $4E     ; 0.607       1.646       30   
db     $51     ; 0.615       1.625       37
db     $55     ; 0.621       1.610       43
db     $59     ; 0.629       1.590       49 
db     $5D     ; 0.636       1.570       56
db     $61     ; 0.644       1.552       63
db     $65     ; 0.652       1.533       71
db     $6A     ; 0.662       1.510       80
db     $71     ; 0.676       1.480       91
db     $7A     ; 0.693       1.442      107 
db     $89     ; 0.723       1.384      136
db     $89     ; 0.723       1.384      200
;
;********************************************************************** 
;8 word table used in routine at 0xBA35 ish. Indexed by CYLINDER 
;This is an array of pointers to other 16 bit values stored at L8DCA ->
L8D7A:	dw	$8DD4,$8DCA,$8DCC,$8DCE,$8DD0,$8DD2,$8DCE,$8DD0
;********************************************************************** 
;8 word table used in routine at 0xBAEC ish. Indexed by CYLINDER
L8D8A:	dw	$0098,$008E,$0090,$0092,$0094,$0096,$0092,$0094
;********************************************************************** 
;8 word table used in routine at 0xBA03 & 0xBA69 ish. Indexed by CYLINDER
L8D9A:	dw	$008C,$0084,$008C,$0084,$008C,$0084,$0084,$008C
;********************************************************************** 
;8 byte table used in routine at 0xB945 ish. Indexed by CYLINDER
L8DAA:	db	$C0,$40,$40,$FF,$C0,$C0,$00,$00
;********************************************************************** 
;8 word table used in routine at 0xB893 ish. Indexed by CYLINDER
;This is an array of pointers to other 16 bit values stored at L8DCA ->
L8DB2:	dw	$8DD2,$8DD4,$8DCA,$8DCC,$8DCE,$8DD0,$8DD0,$8DD0
;********************************************************************** 
;8 byte table used in routine at 0xB8D2 ish. Indexed by CYLINDER
L8DC2:	db	$80,$00,$00,$40,$00,$00,$00,$00
;********************************************************************** 
;8 word table indexed into by tables at L8D7A & L8DB2
L8DCA:	dw	$00F8,$0088,$0098,$00A8,$00B8,$00C8,$00D8,$00E8
;********************************************************************** 
L8DDA:	fill	$00, 294
	db	$FF,$FF,$FF
	fill	$00, 8445
;********************************************************************** 
;
; Start of software program
;
LB000:	bset	NVRAMWD0,NVRAMWD0_SWI	; SWI Interrupt Vector
	ldaA	L6000

LB006:	ldaA	#NVRAMWD0_III	; Illegal Instruction Interrupt Vector
	jr	LB018
;
LB00A:	ldaA	#NVRAMWD0_BRI	; Bus Reset Vector (read or write 0x6000-0x6FFF)
	jr	LB018
;
LB00E:	ldaA	#NVRAMWD0_WDI	; Watchdog Vector Start Point
	jr	LB018
;
LB012:	ldaA	#NVRAMWD0_CKF	; Clock Fail Vector Start Point
	jr	LB018
;
LB016:	ldaA	#NVRAMWD0_RST	; Reset Vector Code Start Point
LB018:	oraA	NVRAMWD0
	staA	NVRAMWD0
	
	ldS	#STACK_TOP	; Set the SP -> 0x02FF

	ldaA	#$8C
	staA	SPI_CTRL_REG	; Initialise the SPI Control Register

	ldaA	#$88
	staA	IO_PORTA		; Iniialise the SPI Select register

	ldaA	#$FF
	staA	DDR_PORTB		; Set PORTB to all outputs

	ldaA	#$12
	staA	IO_PORTB

	clrA	
	staA	SCI_CTRL_REG	; SCI_CTRL_REG = 0

;
;************************************************************************
;
; Start of unknown hardware initialisation
;
	ldD	#$000A
	brclr	NVRAMWD2, #NVRAMWD2_TC51, LB041
	ldD	#$0002
LB041:	stD	L3FFC

	ldX	#$3F80
	ldD	#$0000
LB04A:	stD	0, X	; 0x3F80..0x3FB8 = 0
	stD	64, X	; 0x3FC0..0x3FF8 = 0
	incX	
	incX	
	cmpX	#$3FBA
	bne	LB04A	; for (x = 0x3f80; x < 0x3fba; x+=2)

	stD	L3FF8
	ldD	#$7FFF
	stD	L3FAC
	ldD	#$0040
	stD	L3FCE
	stD	L3FAE
	nop	
	nop	
	nop	
	nop	
	stD	L3FB0
	nop	
	nop	
	nop	
	nop	
	stD	L3FB2
	nop	
	nop	
	nop	
	nop	
	stD	L3FB4
	ldD	#$7FFF
	brn	LB082
	nop	
LB082:	addd	L3FB6
	nop	
	nop	
	nop	
	nop	
	stD	L3F94
	nop	
	nop	
	nop	
	nop	
	stD	L3F96
	nop	
	nop	
	nop	
	nop	
	stD	L3F98
	nop	
	nop	
	nop	
	nop	
	stD	L3F9A
	nop	
	nop	
	nop	
	nop	
	stD	L3F9C
	nop	
	nop	
	nop	
	nop	
	stD	L3F9E
;
; End of unknown hardware initialisation
;
;************************************************************************
;
	ldD	#$8040
	ldX	#IOREG4000
	call	LED2F	; Initialise SPIDEV7    
	
	ldaA	#ENDAtoD	; Initialise the AtoD SPI device
	call	ReadAtoD

	ldX	#$01D9
LB0C0:	clr	0, X
	decX	
	cmpX	#$0047
	bne	LB0C0	; [0x0048..0x01D9] = 0x00
	
	ldX	#$025D
LB0CB:	clr	0, X
	decX	
	cmpX	#$01FF
	bne	LB0CB	; [0x0200..0x025D] = 0x00 
	
	bset	FMDSDI, #%00000100
	call	LEDB3
	staA	FMD1

	clrA	
	staA	SPIDEV8_OUT

	call	LED93
	staA	SPIDEV8_IN

	ldX	#IOREG4000
	ldD	L8011
	call	LED2F

	ldX	#$8008	; start checksum at address 0x8008
	ldD	#$7FF8	; checksum length = 0x7FF8 (0x8008-0xFFFF)
	call	LEF1F	; call checksum calculation routine
	ldaA	KKPGMID	; A = Software version number
	cmpA	#$AA	; if Software version == 0xAA......
	beq	LB106	;     ignore checksum, and pretend everything is OK
	cmpA	#$B0	; if Software version != 0xB0......
	bne	LB10B	;     flag a prom error
	cmpY	KKSUM	; if Checksum in 8006..8007 != calculated checksum
	bne	LB10B	;     flag a prom error

; Software Version Number = 0xAA or 0xB0 && checksum ok
LB106:	bclr	CLCCMW,CLCCMW_CSUMERR
	jr	LB10E

; Software Version Nunber != 0xAA and != 0xD0 or checksum doesn't match
LB10B:	bset	CLCCMW,CLCCMW_CSUMERR 

LB10E:	ldX	#$3F80
	ldD	#$FB1A
	brclr	NVRAMWD2, #NVRAMWD2_TC51, LB11B
	ldD	#$FB12
	
LB11B:	stD	124, X 	; L3FFC = 0xFB1A or 0xFB12, depending on TC51

	andB	#%11110111
	stD	L3DFC 	; L3DFC = 0xFB0A or 0xFB02, depending on TC51

	ldD	#$7B8A
	stD	60, X 	; L3FBC = 0x7B8A
	
	call	MATREAD	; Set the MAT Variables

	call	TPSREAD	; Set the TPS Variables

	bset	L0056, #%10000000

	call	CTSREAD	; Set the CTS Variables    
	
	ldaA	#ALDLAtoD
	call	ReadAtoD
	cmpA	#$64 
	bcc	LB15C	; if (ADALDL >= 1.95V) then goto B15C
	cmpA	#$28
	bcs	LB15C	; if (ADALDL < 0.78V) then goto B15C
	
	ldaA	ADCTS
	cmpA	#$05
	bhi	LB15C	; if (ADCTS > 0x05) goto B15C
	
	ldaA	ADTHROT
	cmpA	#$FC
	bcs	LB15C	; if (ADTHROT < 0xFC) goto B15C

	ldaA	ADMAT     
	comA	     	; A = 0 - ADMAT
	cmpA	#$FC
	bcs	LB15C     ; effectivley, if (ADMAT > 4) goto B15C
;	
; We can only enter ALDLMW_TEST when all of the following are true....
;
; 1) ADALDL Voltage is betwen 0.78V and 1.95V
; 2) ADCTS < 0x05 - basically meaning it is short circuited
; 3) ADTHROT > 0xFC - basically meaning it is tied to +5V
; 4) ADMAT < 0x04 - basically meaning it is short circuited
;
; Realistically, this can only be achieved in a workshop, because with
; these sensors in this state, the engine ain't gonna run too well. 
;	
	bset	ALDLMW,#ALDLMW_TEST
	jmp	LB337
;
LB15C:	ldaA	#$08
	staA	L5000
	
	ldaA	KREFANGL
	clrB	
	stD	L0461
	
	ldD	#$FFFF
	stD	L045D      
	
	call	MALFWD_CSUM
	cmpD	CSUM_MALFWD
	bne	LB17F		; if (MALFWD CSUM failed) goto LB17F

	ldX	#KAFOPT1		; = 0x06
	brset	0,X,#KAFOPT1_BLMINIT,LB194 ; this jump never taken
	jr	LB19E		; this jump always taken
;
LB17F:	ldX	#$0047		; initialisation count
LB182:	clr	0, X		; [0x0000..0x0047] = 0x00
	decX			; X--
	bne	LB182		; Loop while (X > 0)

	call	MALFWD_CSUM	; Calculate tyhe new MALFWD Checksum
	stD	CSUM_MALFWD	; Remember it !!!
	
	ldaA	KISPKDL
	staA	ISSPMP 
	
	bset	CLCCMW,CLCCMW_BLMINIT
LB194:	ldaA	#$80		; A = 0x80 (BLM initialisation)
	ldX	#$0020		; X = 0x0020 (BLM size)
LB199:	staA	20, X		; [0x0015..0x0034] = 0x80
	decX			; X--
	bne	LB199		; Loop while (X > 0)

LB19E:	bclr	NVRAMWD2, #NVRAMWD2_TC51
	brclr	CLCCMW,CLCCMW_CSUMERR, LB1C5
	bset	NVRAMWD2, #NVRAMWD2_TC51
	ldD	#$FB12
	stD	L3FFC
	andB	#%11110111
	stD	L3DFC
	bset	MALFWD3,MALFWD3_TC51
	
	call	MALFWD_CSUM	; Calculate the MALFWD Checksum
	stD	CSUM_MALFWD	; Remember it !!    
	
	ldaA	#ALDLAtoD
	call	ReadAtoD
	cmpA	#$28
	bcs	LB1C5		; if (ADALDL < 0.78V) goto B1C5 
	swi
		
LB1C5:	brset	NVRAMWD1, #%00001000, LB1F4

	ldX	#F54
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	clrB	
	stD	AFRCTS
	
	ldX	#L832B
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	subA	L832A	; = 0x55
	staA	L000C
	
	ldaA	MATA
	cmpA	#$C0
	bls	LB1EC
	ldaA	#$C0	; Limit MATA to 0xC0 = 153 Deg C
	
LB1EC:	ldX	#L8517    ; This table is all 0's, so..
	call	LOOKUP1DBY16
	staA	L0037     ; L0037 = 0

LB1F4:	ldX	#L85B6
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L00AF

	ldX	#L8349
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L00B3

	ldX	#L85D3
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L0158

	ldX	#L8357
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	tAB	
	clrB	
	stD	L00B1

	ldX	#L85C4
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L00AE
	bclr	LCCPMW,#LCCPMW_CTFIRST
	
	ldaA	COOLDEGA
	cmpA	MINCOOL	; MINCOOL = 0
	bcs	LB23C	; carry never set! goto LB23C
	bset	NVRAMWD1,NVRAMWD1_CTSCOOL
	
LB23C:	clrB		; B = 0	
	ldaA	KO2FFO 	; A = 0x66
	stD	ADLO2FILT
	staA	ADLO2AFSC
	staA	LO2FILT
	stD	ADRO2FILT
	staA	ADRO2AFSC
	staA	RO2FILT
	
	ldaA	K4	; A = 0x0D
	staA	ADTAOFF
	
	call	TPSREAD	; Set the TPS Variables
	
; Lag NTPSLD	
	ldaA	NTPSLD
	staA	NTPSLDF	; NTPSLDF = NTPSLD 
	 
; Read the battery voltage	
	call	BATREAD	; Set the battery voltage variables	

; Read the MAP sensor	
	ldaA	#MAPAtoD
	call	ReadAtoD
	staA	ADMAPLAG
	staA	ADMAP
	staA	FILTMAP

	ldaB	KAFOPT1	; KAFOPT1 = 0x06
	bitB	#KAFOPT1_2BARMAP
	beq	LB2B4	; This jump never taken, LC has 2 bar MAP
;
; This section of code is used for a 2Bar MAP Sensor. Used in LC code
;
	cmpA	KK2ATM33	; = 0xE9 = 1.90 Bar
	bls	LB281	; if (ADMAP < 1.90 Bar) goto LB281 
	
	bset	DIAGMW5,DIAGMW5_TC66 ; Flag overboost detected
	ldaA	KMAPHIDF	; Default ADMAP to 1.96 Bar
	
LB281:	staA	ADMAPN	; Store limited MAP
	ldaB	#$A0	; = 0.625
	subA	#$1C	; A = MAP - 0.22 Bar
	call	MULTAB2	; A = (MAP - 0.22) * 0.625 * 2
	staA	ADMAPN2
;
; Simulate ADMAP1BAR
;	
	ldaA	ADMAPN
	ldaB	#$87	; = 0.527
	mul		; A:B = MAP * 0.527	
	subD	#$0190	; A:B = (MAP * 0.527) - 1.56
	bcc	LB29A
	ldD	#$0000	; zero it if it underflows
;
LB29A:	lslD	
	bcs	LB2A0
	lslD	
	bcc	LB2A2	; A:B = (MAP * 2.108) - 6.24
LB2A0:	ldaA	#$FF	; limit ADMAP1BAR to 255
;
LB2A2:	staA	ADMAP1BAR
;
	ldaB	ADMAPN
	clrA	
	addd	#$000A
	ldX	#$C800
	call	MULT16BY16
	stD	NMAP0
	jr	LB2C5
;
; This section of code is used for a 1Bar MAP Sensor. Not used in LC code
;
LB2B4:	staA	ADMAP1BAR

	clrA	
	ldaB	ADMAP1BAR	; A:B = 0x00:ADMAP1BAR
	ldX	#$02B6	; X = 694 = 2.71
	fdiv		; X = ADMAP1BAR / 2.71		
	pushX	
	popA	
	popB	
	addd	#$0A57    ; A:B = (ADMAP1BAR / 2.71) + 10.33
	stD	NMAP0
	
LB2C5:	ldaB	#$97	; = 0.590
	ldaA	ADMAP1BAR
	subA	#$1A	; A = (ADMAP1BAR - 0.10 Bar)
	call	MULTAB2NC ; A = (ADMAP1BAR - 0.1) * 1.18
	staA	MAP1N
;	
; Read the Barometric pressure
;
	ldaA	#BAROAtoD
	call	ReadAtoD
	staA	ADBARO
	
	tAB	
	clrA	       	; A:B = 0x00:ADBARO	
	ldX	#$02B6	; X = 694 = 2.71
	fdiv		; X = ADBARO / 2.71		
	pushX	
	popA	
	popB	
	addd	#$0A57    ; A:B = (ADBARO / 2.71) + 10.33
	stD	NBARO
	
	ldaA	#$80
	staA	FBLM
	staA	RBLM
	staA	L00F0
	staA	L00EE
	staA	LINT
	staA	RINT
	
	ldD	CNT_EST
	stD	ESTFBCNT
;	
	ldaB	AFRCTS	; A:B = CTS Temperature FA_RATIO enrichment
	clrA
;		
	addB	L85D2	; = 0xDD
	adcA	#$00
;	
	addB	L0158
	adcA	#$00
;	
	stD	FA_RATIO
;	
	ldaA	ADMAPN2
	ldX	#L8587		; This table is all 0's, so...
	call	LOOKUP1DBY16	; A = 0
	tAB	
	clrA			; A:B = 0	
	addd	FA_RATIO
	
	ldX	KFA_STOIC		; 14.7:1
	call	MULT16BY16
	stD	FA_RATIO
	
	ldaA	#$0E
	staA	TIMER_TICK
	
	ldaA	#$27
	staA	L013F
	
	ldaA	KISPKDL
	staA	L00DF
	
	ldaA	#$FF
	staA	CYLINDER
	
	bset	FMDSDI, #%01000000
	
LB337:	ldX	#IOREG4000

	ldaA	ALDL_REG,X

	ldaA	COUNTER, X
	addA	#$02	; interrupt after 60 uS (2 ticks @ 32760 Hz)
	staA	IRQTIME, X

	ldaA	ALDL_RXD,X

	bset	SCI_CTRL,X,#%00100111 ; SCI_EXTIRQ | SCI_RE | SCI_RWU | SCI_RDRF

	jmp	REFRESH_FOREVER
;
;**********************************************************************
;
; ALDL interrupt & periodic timer vector routine
;
LB34A:	bset	NVRAMWD0, #NVRAMWD0_PEI

	ldX	#IOREG4000
	brset	ALDL_REG,X,#ALDL_EXTIRQ,PERIODIC_IRQ
	
	brclr	SCI_CTRL,X,#SCI_RDRF, LB360	; if SCI_RDRF enabled
	brclr	ALDL_REG,X,#ALDL_RDRF,LB37E   ; and ALDL_RDRF occurred
	call	ALDL_RX			; then next ALDL Rx'ed
	reti	
;
LB360:	brclr	SCI_CTRL,X,#SCI_TDRE, LB36C	; if SCI_TDRE enabled
	brclr	ALDL_REG,X,#ALDL_TDRE,LB37E	; and ALDL_TDRE occurred
	call	ALDL_TX			; then Tx next ALDL byte
	reti	
;
LB36C:	brclr	SCI_CTRL,X,#SCI_TC, LB37E	; if SCI_TC enabled
	brclr	ALDL_REG,X,#ALDL_TC,LB37E	; and SCI_TC occurred
	                                        ; then SCI Tx complete occurred
	ldaA	#$27	
	staA	SCI_CTRL,X 		; 0x27 = enable SCI_RDRF & SCI_EXTIRQ & SCI_RE & SCI_RWU 
	
	bclr	ALDLMW,#ALDLMW_TX	; Flag ALDL inactive
	bclr	IOPORTA,X,#SPI_ALDLTX	; Disable the ALDL Tx Output Buffer
	
LB37E:	reti	
;
;**********************************************************************
;
; Periodic timer interrupt. This interrupt appears to occur once every
; 6.25mS, or 160 times per second. TIMER_TICK counts the ticks per second
;
PERIODIC_IRQ:
LB37F:	ldaB	IRQ_TIME
	addB	#$CD      ; Timer clock = 32768 Hz, Divide by 205 = 62.56 mS
	staB	IRQ_TIME	; Set to interrupt again in 205 ticks time (62.56 ms)
;
; If VBATMW_TICK_ERROR is set, then we didn't finish a previous 
; timeslice's code. No point in checking for more incomplete timeslices
; because we can't store more than one failure
;	
	brset	VBATMW,#VBATMW_TICK_ERROR,LB397
;
; If MW3_BUSY is clear, then we finished the previous timeslice's code OK
;	
	brclr	MW3,#MW3_BUSY,LB397
;
; If MW3_BUSY is set, then we didn't finish the previous timeslice's code. 
; Save the TIMER_TICK, of the incomplete timeslice, & flag it's happened
;	
	ldaA	TIMER_TICK
	staA	TIMER_TICK_ERROR
	bset	VBATMW,#VBATMW_TICK_ERROR
;
; Set MW3_BUSY as we are about to start the next timeslice's code
;
LB397:	bset	MW3,#MW3_BUSY      

	ei	                    ; Re-enable interrupts

	ldaA	TIMER_TICK
	incA	
	staA	TIMER_TICK          ; TIMER_TICK++
	cmpA	#$A0
	bne	LB3A7		; Clear TIMER_TICK after 160 ticks
	clr	>TIMER_TICK	; reset after 160 TICKS, i.e 1 second

LB3A7:	brclr	ALDLMW,#ALDLMW_TEST,LB3AE
	jmp	LEB3E		; if (ALDL is in funny mode) goto LEB3E
;
LB3AE:	tSX			; X = old stack	
	ldS	#STACK_TOP	; Reset the stack to the top
;	
; The old stack should be 0x02F7. If it wasn't, something probably went wrong
; in the last timeslice. Flag that we have seen a stack problem
; 
	cmpX	#$02F7
	beq	LB3BA 
	bset	VBATMW,#VBATMW_STACK_ERROR
;	
LB3BA:	brclr	MW3, #%10000000, LB3C7
	bclr	MW3, #%10000000
	bset	DIAGMW2, #%00000100
	bset	MW2, #%00000100

LB3C7:	di	
	call	LED93
	ei	
	staA	SPIDEV8_IN 
	
	di	
	call	LEDB3
	staA	FMD1
	ei
		
	brset	L0066,#L0066_ALDL_AWAKE,LB3DC
	jmp	LB45D
;
LB3DC:	ldaA	ALDL_MODE
	cmpA	#$04
	bne	LB45D	; if (ALDL_MODE != 4) goto LB45D
;	
; We are in ALDL MODE 4
;
	ldD	ALDLMW_T2
	bne	LB45D	; The first time through ALDLMW_T2 will be zero
;
; We get here the first time through the ALDL MODE 4 code	
;
	bset	ALDLMW,#ALDLMW_STARTMD4           
;	
; Move the ALDL MODE 4 parameters to a safe area
;
	ldD	L0227
	stD	ALDLMD_DCW
	ldD	L0229
	stD	ALDLMDEW
	ldD	L022B
	stD	ALDLMD_PWMCW
	ldD	L022D
	stD	ALDLMD_FMCW	; Sets ALDLMD_FMCW & ALDLMD_IACRPM
	ldD	L022F
	stD	ALDLMD_AFRATIO	; Sets ALDLMD_AFRATIO & ALDLMD_SAD
;
; ALDL commanded Clear MALFWD's command MODE 4 code
;	
	ldX	#ALDLMDEW		; Point to the safe area
	brclr	0,X,#ALDLMDEW_CLRMALF,LB427	; Check to see if we've been asked to clear the MALFWD's
;
	brset	ALDLMW,#ALDLMW_MALFWD_CLR,LB42A ; If we've already cleared the MALFWD's, don't do it again
;
	bset	ALDLMW,#ALDLMW_MALFWD_CLR	; Flag that we've cleared the MALFWD's
	ldD	#$0000
	stD	MALFWD1  			; Clear MALFWD1 & MALFWD2
	stD	MALFWD3 	 		; Clear MALFWD3 & MALFWD4
	staA	MALFWD5  			; Clear MALFWD5
	ldD	#$0001
	stD	CSUM_MALFWD 		; Initialise the MALFWD CSUM
	jr	LB42A               
;	
LB427:	bclr	ALDLMW,#ALDLMW_MALFWD_CLR 	; We haven't cleared the MALFWD's, so clear the flag
;
; ALDL commanded Reset IACV command MODE 4 code
;	
LB42A:	brclr	0,X,#ALDLMDEW_IACVRST,LB43E	; Check to see if we've been asked to reset the IAC motor 
;
	brset	ALDLMW,#ALDLMW_IACV_RESET,LB441 ; If we've already reset the IACV, don't do it again 
;
	bset	ALDLMW,#ALDLMW_IACV_RESET	; Flag that we've reset the IACV
	bset	IACMW2,#IACMW2_IACV_RESET
	ldaB	#$FF
	staB	ISSPMP			; IACV = 255
	jr	LB441
;
LB43E:	bclr	ALDLMW,#ALDLMW_IACV_RESET	; We haven't reset the IACV, so clear the flag
;
; ALDL commanded Reset BLM command MODE 4 code
;	
LB441:	brclr	0,X,#ALDLMDEW_BLMRST,LB458	; Check to see if we've been asked to clear the BLM
	brset	ALDLMW,#ALDLMW_BLM_RESET,LB472 ; If we've already reset the BLM, don't do it again
	bset	ALDLMW,#ALDLMW_BLM_RESET	; Flag that we've reset the BLM
	ldaA	#$80			; BLM Rexet value is 0x80
	ldX	#$0020
LB451:	staA	20, X
	decX	
	bne	LB451                         ; [0x0015..0x0034] = 0x80
	jr	LB472
;
LB458:	bclr	ALDLMW,#ALDLMW_BLM_RESET	; We haven't reset the BLM, so clear the flag
	jr	LB472
;
; We get here if ALDL is asleep, or if (ALDL_MODE != 4), or if (ALDLMW_T2 != 0)
;
LB45D:	brclr	ALDLMW,#ALDLMW_STARTMD4,LB472
	ldaA	ALDL_MODE
	bne	LB472			; if (ALDL_MODE != 0) goto LB472
;	
; Cleardown the ALDL test mode variables
;
	bclr	ALDLMW,#%00001111
	bclr	MW3,   #MW3_SPARK_BK
	bclr	DIAGMW1, #%00000001
	clr	TC42B_COUNT       
;
; Test for 1 second tick stuff
;	
LB472:	ldaA	TIMER_TICK
	beq	LB479	; if (TIMER_TICK == 0) goto LB479 - once per second 
	jmp	LB514     ; if (TIMER_TICK != 0) goto LB514
;	
; This stuff is only done when (TIMER_TICK == 0), i.e. once per second
;
LB479:	ldaA	NMPH
	bne	LB489		; if (NMPH != 0) goto LB489
	
	ldX	#$0000
	stX	MOVING_TIME	; set MOVING_TIME = 0
	bclr	MW1,#MW1_MV10MIN	; clear the moving 10 min flag
	jr	LB49A
;
LB489:	ldX	MOVING_TIME
	cmpX	L801C 		; = 0x258 = 600 Sec = 10Min's
	bcc	LB497 		; if (MOVING_TIME >= 600) goto LB497
	
	incX	
	stX	MOVING_TIME	; MOVING_TIME++
	jr	LB49A
;
LB497:	bset	MW1,#MW1_MV10MIN 	; set the moving 10 min flag
;
; Engine Run Time code
;	
LB49A:	brclr	MW1,MW1_ENGRUN,LB4AE ; Jump if Engine not running

	ldX	TIMERUN             ; Get the time
	incX			; Time = Time + 1	
	beq	LB4A5               ; Jump if Time rollover
	stX	TIMERUN             ; Store the new time
	
LB4A5:	ldX	TIMESEC		; Get the time
	incX	                    ; Time = Time + 1
	beq	LB4AE               ; Jump if Time rollover
	stX	TIMESEC             ; Store the new time
;
; ALDL Timeout code
;	
LB4AE:	brclr	L0066,L0066_ALDL_AWAKE,LB4E2 ; If the ALDL is asleep, goto LB4E2

	ldaA	ALDL_AWAKE_TIME
	incA	               	; ALDL_AWAKE_TIME ++
	beq	LB4BF               ; if (ALDL_AWAKE_TIME == 0), then we've been active for 255 seconds !! 
	staA	ALDL_AWAKE_TIME	; Store the new ALDL_AWAKE_TIME
	cmpA	#$05
	bcs	LB4E2		; if we've been active for < 5 sec, goto LB4E2
;
; If we get here, then there have been no ALDL bytes for 5 seconds, so go to sleep
;	
LB4BF:	clr	ALDL_MODE
	bclr	L0066,#L0066_ALDL_AWAKE
	bclr	ALDLMW,#%01001111
	bclr	MW3,  #MW3_SPARK_BK
	bclr	DIAGMW1, #%00000001
	
	ldX	#IO_PORTA
	bclr	0,X,#SPI_ALDLTX	; Disable the ALDL Tx Output Buffer     
	
	ldaA	#$27
	staA	SCI_CTRL_REG	; 0x27 = enable SCI_RDRF & SCI_EXTIRQ & SCI_RE & SCI_RWU

	ldD	#$0000
	stD	ALDL_PTABLE
	stD	ALDL_COUNT	; This clears ALDL_COUNT and ALDL_CSUM
;
LB4E2:	brclr	ALDLMW,#ALDLMW_STARTMD4,LB4FD ; if we aren't starting a MODE4, skip this
	ldX	ALDLMW_T1
	incX	
	stX	ALDLMW_T1			; inc the Mode 4 timer		
	cmpX	L8AA6			; = 0xFFFF
	bcs	LB514			; if we haven't reached the MODE4_TIMEOUT skip		
	
	bclr	ALDLMW,#ALDLMW_STARTMD4	; We are done starting the MODE4
	ldX	#$0001
	stX	ALDLMW_T2			; ALDLMW_T2 = 0x0001
	jr	LB514
;
LB4FD:	ldX	ALDLMW_T2
	beq	LB514			; if (ALDLMW_T2 == 0x0000) skip
	
	incX	
	stX	ALDLMW_T2                     ; ALDLMW_T2++
	cmpX	L8AA8			; = 0x0000
	bcs	LB514
	
	ldD	#$0000
	stD	ALDLMW_T2
	stD	ALDLMW_T1
;
; End of once per second stuff
;
LB514:	call	DOIACV			; Handle the IACV  

	ldX	#KAFOPT2			; = 0x0F
	brclr	0,X,#%00000100,LB522 	; This jump never taken
	brset	TIMER_TICK,#%00000001,LB547	; every other TIMER_TICK, i.e. even 6.25mS
	
LB522:	call	TPSREAD	; Set the TPS Variables
	brclr	DIAGMW1, #%00100100, LB52B ; if ((DIAGMW1_TC21 && DIAGMW1_TC22) == 0) test for ???
	jr	LB541		; else skip
;
LB52B:	ldaA	NTPSLD
	subA	NTPSLDF	; A = NTPSLD - NTPSLD1
	bcc	LB534	; if (NTPSLD >= NTPSLD1) goto LB534
	clrA		; A = 0	

LB534:	cmpA	L8460	; 0x25 = 14.5%
	bls	LB541	; if (DeltaNTPSLD < 14.5%) goto LB541
	
	ldaA	MPH
	bne	LB541	; if (MPH != 0) goto LB541
	
	bset	WGATEMW,#WGATEMW_PULLAWAY

LB541:	ldaA	NTPSLD	; NTPSLDF = NTPSLD
	staA	NTPSLDF
	
LB547:	brset	NVRAMWD2,#NVRAMWD2_FPUMP,LB57A

	ldaA	KAFOPT1	; KAFOPT1 = 0x06
	bitA	#%00010000
	beq	LB56F	; this jump will always be taken

	bset	MALFWD3,MALFWD3_TC46
	
	ldD	L3FC4
	pushB	
	pushA	
	subD	LAST_L3FC4 ; A:B = Delta L3FC4 value
	popX		; X = Current L3FC4 value	
	beq	LB575	; if L3FC4 hasn't changed, goto LB575
	
	stX	LAST_L3FC4 ; Save the Current L3FC4 value
	
	cmpD	L8013	; = 0x0CCD
	bhi	LB575	; if (deltaL3FC4 > 3277) goto LB575
	
	cmpD	L8015	; = 0x0666
	bcs	LB575	; if (deltaL3FC4 < 1638) goto LB575
	
LB56F:	bset	NVRAMWD2,#NVRAMWD2_FPUMP
	bclr	MALFWD3,MALFWD3_TC46
	
LB575:	call	MALFWD_CSUM	; Calculate the new MALFWD Checksum
	stD	CSUM_MALFWD	; Remember it
	
LB57A:	brclr	TIMER_TICK, #%00000001, LB581 ; every other TIMER_TICK, i.e. odd 6.25mS
	jmp	LC742
;
; Test for ALDL invoked fuel backup mode
;
LB581:	bclr	LCCPMW,#LCCPMW_FUEL_BK ; Clear fuel backup
	brclr	ALDLMW,#ALDLMW_STARTMD4,LB595
;
	ldaA	ALDLMDEW
	bpl	LB595		; if ((ALDLMDEW & 0x80) == 0) goto LB595
	
	bset	LCCPMW,#LCCPMW_FUEL_BK ; Flag fuel backup
	bset	MW3,   #MW3_SPARK_BK   ; Flag spark backup
	jr	LB59A
;
LB595:	di	
	call	TOGGLECOP2
	ei
		
LB59A:	jmp	LBC1C
;
;**********************************************************************
;
; External Interrupt Vector
;
LB59D:	bset	NVRAMWD0,#NVRAMWD0_EXI

	ldX	#IO_PORTB
	bset	0, X, #%00000010
	ldD	L3FFA
	bitA	#%00001000
	beq	LB5E0
	brset	ALDLMW,#ALDLMW_TEST,LB5E0
	ldX	L3FC0
	brset	SEQMW1, #%01000000, LB5BB
	ldX	#$FFFF
LB5BB:	stX	NTREV65

	ldX	#NTREV65
	ldaA	KNUMCYL
	bne	LB5C9	; Jump if (KNUMCYL != 0) i.e. NOT a V8
	
	ldD	NTREV65
	jr	LB5DA
;
; We get here if KNUMCYL != 0, i.e. for non 8 cylinder engines (like us !!)
; X->NTREV65, A = KNUMCYL
;
; Do a 16 bit (NTREV65) by 8 bit (KNUMCYL) multiplication to convert NTREV65
; into NTREVCYL65
;	
LB5C9:	pushA		; Save KNUMCYL	
	ldaB	1, X	; B = LSB of NTREV65
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS		; Restore stack	

LB5DA:	stD	NTREVCYL65
	brclr	VBATMW,VBATMW_VLOW, LB5E3
LB5E0:	jmp	LBBFC
;
LB5E3:	bset	MW3, #%10000000
	bset	SEQMW1, #%01000000
;
; CYLINDER = CYLINDER + 1 (limited to KMAXCYL-1)
;
	ldaA	CYLINDER
	incA	
	cmpA	KMAXCYL	; = 0x06
	bcs	LB5F2
	clrA	
LB5F2:	staA	CYLINDER

	brset	MW1,MW1_ENGRUN,LB5FB
	jmp	LB6B0
;
LB5FB:	ldD	#$0000
	brset	MWFA1, #%00000001, LB60B
	ldX	#L8028
	ldaB	CYLINDER	; CYLINDER = [0x00..0x05]
	lslB	
	aBX		; index into the table	
	ldD	0, X
	
LB60B:	brset	MW3, #%00100000, LB613
	addD	SPARKADV
	jr	LB615
;
LB613:	addD	L00C6
;
LB615:	cmpD	L8024	; = 0x0071
	ble	LB61E
	ldD	L8024	; if (A:B <= L8024) then A:B = L8024
;	
LB61E:	cmpD	L8026	; = 0xFF1C
	bge	LB627
	ldD	L8026	; if (A:B >= L8026) then A:B = L8026
;
LB627:	stD	L00C8

	bpl	LB643
	negB	
	tBA	
	ldX	#$00BA
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	jr	LB65C
;
LB643:	tBA	
	ldX	#$00BA
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	2, X
	adcA	#$00
	incS	
	negA	
	negB	
	sbcA	#$00
LB65C:	pushA	
	pushB	  
	
	ldX	#L8038
	ldaB	NTRPMX
	lsrB	
	lsrB	
	lsrB	
	lsrB	
	adcB	#$00
	aBX	
	ldaB	0, X
	
	popA	
	sBA	
	tAB	
	popA	
	sbcA	#$00
	pushB	
	pushA	
	tSX	
	ldD	#$0000
	subD	NTREV65
	lsrD	
	lsrD	
	lsrD	
	lsrD	
	oraA	#%11110000
	addd	L3FF6
	cmpD	0, X
	bmi	LB68A
	stD	0, X
LB68A:	ldD	0, X
	subD	L3FF6
	nop	
	nop	
	nop	
	nop	
	stD	L3FE8
	nop	
	nop	
	nop	
	nop	
	addd	L3FDC
	subD	L00C0
	brn	LB6A4
	stD	L3FE6
LB6A4:	nop	
	nop	
	ldD	L00C0
	stD	L3FDC
	popA	
	popB	
	stD	L3FF6
LB6B0:	brclr	VBATMW, #%00100000, LB6B7
	jmp	LBA35
;
LB6B7:	ldD	NTREV65
	ldX	L84FA	; = 1
	fdiv	          ; X = [A:B] / X
	stX	NTREV

	brset	SEQMW1, #%00010000, LB6CE
	brclr	L0037, #%11111111, LB6E5
	dec	>L0037
	jmp	LBBFC
;
LB6CE:	brset	SEQMW1, #%00100000, LB6D5
	jmp	LB893
;
LB6D5:	ldaA	KMAXCYL
	lslA	
	staA	L015C	; L015C = KMAXCYL * 2
	
	clr	L015D
	clr	L015E
	bclr	SEQMW1, #%00110100

LB6E5:	ldD	#$0667
	ldX	NTREVCYL65
	fdiv	
	stX	L0161
	
	ldaA	L015C
	incA	
	beq	LB6F7
	staA	L015C
	
LB6F7:	ldD	L8011
	ldX	#IOREG4000
	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB
	lslA	
	bpl	LB723
	bset	SEQMW1, #%00001000
LB723:	bclr	IOPORTA, X,SPI_DEV7

	ldaA	L0161
	cmpA	L84F9
	bls	LB75F
	inc	L015E
	ldaA	KMAXCYL
	lslA	
	cmpA	L015E
	bcc	LB742
	clr	>CYLINDER
	bset	SEQMW1, #%00000010
	jr	LB759
;
LB742:	brclr	SEQMW1, #%00001000, LB765
	bclr	SEQMW1, #%00001000
	brset	SEQMW1, #%00000100, LB755
	bset	SEQMW1, #%00000100
	clr	>CYLINDER
	jr	LB765
;
LB755:	ldaA	CYLINDER
	bne	LB762
LB759:	bset	SEQMW1, #%00010000
	jmp	LB893
;
LB75F:	clr	L015E
LB762:	bclr	SEQMW1, #%00001100

LB765:	ldX	#L8534
	
	ldaB	L015C
	decB	
	
	ldaA	KMAXCYL
	lslA	
	decA	A = (KMAXCYL * 2) - 1 = 0x0B
		
	cBA	
	bcs	LB781 
	
	ldaA	CTSSTART
	cmpA	L84FC
	bls	LB792 	; if (CTSSTART < 85.25) goto LB792
	
	ldX	#L8524
	jr	LB792
;
LB781:	ldaB	L015D
	tBA	
	incA	
	cmpA	KMAXCYL
	bcs	LB78C
	clrA	
LB78C:	staA	L015D	; L015D++ limited to KMAXCYL-1

	ldX	#L8544
	
LB792:	aBX	
	ldaA	0, X
	staA	L0163
	ldX	#$007C
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	pushB	
	pushA	
	tSX	
	ldaA	NTREV
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	popX	
	cmpX	#$0000
	beq	LB7EB
	pushB	
	pushA	
	cmpD	#$00A0
	bhi	LB7EA
	subB	#$60
	bcc	LB7D6
	clrB	
LB7D6:	lsrB	
	lsrB	
	ldX	#L8572
	aBX	
	ldaB	0, X
	
	popX	
	aBX
		
	cmpX	MINBPINJ	; Make sure BPINJ is not less than MINBPINJ
	bcc	LB7EB
	ldX	DEFBPINJ
	jr	LB7EB
;
LB7EA:	popX	

LB7EB:	stX	LBPINJ1
	stX	RBPINJ1
	beq	LB7F6
	
	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction
		
LB7F6:	stX	L3FF2
	stX	L0463
	
	ldX	#$0000
	ldaB	KMAXCYL
	aBX		; X = KMAXCYL	       
	
	ldD	L00AB
	addD	LBPINJ1
	addD	LBPINJ1
	addD	LBPINJ1
	addD	LBPINJ1
	
	cmpX	#$0004
	beq	LB81F	; if (we're a 4 cylinder engine) goto LB81F
	
	addD	LBPINJ1
	addD	LBPINJ1
	
	cmpX	#$0006
	beq	LB81F	; if (we're a 6 cylinder engine) goto LB81F

	addD	LBPINJ1
	addD	LBPINJ1

LB81F:	stD	L00AB     ; L00AB = L00AB + (KMAXCYL * LBPINJ1)

	ldD	L3FFC
	oraA	#%00000100
	nop	
	nop	
	brn	LB82D
	stD	L3FFC
LB82D:	andA	#%11111011
	nop	
	nop	
	brn	LB836
	stD	L3FFC
LB836:	ldD	#$0000
	stD	L3FD0
	stD	L3F80
	nop	
	nop	
	nop	
	nop	
	stD	L3F82
	nop	
	nop	
	nop	
	nop	
	stD	L3F84
	nop	
	nop	
	nop	
	nop	
	stD	L3F86
	nop	
	nop	
	nop	
	nop	
	stD	L3F88
	nop	
	nop	
	nop	
	nop	
	stD	L3F8A
	oraA	#%01000000
	ldX	#IOREG4000
	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB
	lslA	
	bpl	LB88D
	bset	SEQMW1, #%00001000
LB88D:	bclr	IOPORTA, X,SPI_DEV7

	jmp	LBBFC
;
LB893:	ldX	#L8DB2
	ldaB	CYLINDER
	lslB	
	aBX		; index into L8DB2[CYLINDER]
		
	ldX	0, X	; X = L8D7A[CYLINDER] this a table of pointers to...

	ldD	0, X	; A:B = [X+0x00], a 16 bit value to send to SPI_DEV7
	
	ldX	#IOREG4000
	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB
	lslA	
	bpl	LB8C7
	bset	SEQMW1, #%00001000
LB8C7:	bclr	IOPORTA, X,SPI_DEV7

	ldD	L007C
	lslD	
	bcc	LB8D2
	ldD	#$FFFF
LB8D2:	stD	L0164
	pushB	
	pushA	
	tSX	
	ldaA	NTREV
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	popX	
	stD	L0166
	ldX	#L8DC2
	ldaB	CYLINDER
	aBX	
	ldaA	0, X
	ldX	#$0166
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	ldX	#$0000
	cmpD	#$0000
	beq	LB945
	pushB	
	pushA	
	cmpD	#$00A0
	bhi	LB936
	subB	#$60
	bcc	LB922
	clrB	
LB922:	lsrB	
	lsrB	
	ldX	#L8572
	aBX	
	ldaB	0, X
	
	popX	
	aBX	                                                     
	
	cmpX	MINBPINJ	; Make sure BPINJ is not less than MINBPINJ
	bcc	LB937
	ldX	DEFBPINJ
	jr	LB937
;
LB936:	popX	
LB937:	pushX	
	tSX	
	ldD	L00AB
	addD	0, X
	stD	L00AB
	popX	
	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction
		
LB945:	stX	L3FF2
	ldD	L3FFC
	oraA	#%00000100
	nop	
	nop	
	nop	
	stD	L3FFC
	andA	#%11111011
	nop	
	nop	
	nop	
	stD	L3FFC
	ldX	#L8DAA
	ldaB	CYLINDER
	aBX	
	ldaA	0, X
	ldX	#$0166
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	ldX	#$0000
	cmpD	#$0000
	beq	LB9C0
	pushB	
	pushA	
	cmpD	#$00A0
	bhi	LB9A1
	subB	#$60
	bcc	LB98D
	clrB	
LB98D:	lsrB	
	lsrB	
	ldX	#L8572
	aBX	
	ldaB	0, X
	
	popX	
	aBX	                                                     
	
	cmpX	MINBPINJ	; Make sure BPINJ is not less than MINBPINJ
	bcc	LB9AA
	ldX	DEFBPINJ
	jr	LB9AA
;
LB9A1:	popX	
	cmpX	#$3FFF
	bls	LB9AA
	ldX	#$3FFF	; if (BPINJ > 0x3FFF) BPINJ = 0x3FFF
	
LB9AA:	pushX	
	tSX	
	ldD	L00AB
	addD	0, X
	stD	L00AB
	popX	
	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction	
	
	cmpX	#$3FFF
	bls	LB9C0
	ldX	#$3FFF	; if (BPINJ > 0x3FFF) BPINJ = 0x3FFF
	
LB9C0:	pushX	
	stX	L0463
	
	ldX	#LEFBB
	ldaB	CYLINDER
	lslB	
	aBX	
	
	popA	
	popB	
	
	ldX	0, X
	cmpX	#IOREG4000
	beq	LB9D8
	stD	0, X
	jr	LBA03
;
LB9D8:	oraA	#%01000000
	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB
	lslA	
	bpl	LBA00
	bset	SEQMW1, #%00001000
LBA00:	bclr	IOPORTA, X,SPI_DEV7

LBA03:	ldX	#L8D9A
	ldaB	CYLINDER
	lslB	
	aBX	
	ldX	0, X
	ldD	L0166
	ldY	#$008E
	pushB	
	ldaB	CYLINDER
	lslB	
	aBY	
	cmpX	#$008C
	bcc	LBA20
	oraA	#%10000000
LBA20:	popB	
	stD	0, Y
	ldaA	KMAXCYL
	decA	
	cmpA	CYLINDER
	bne	LBA32
	bset	SEQMW1, #%00100000
	bset	VBATMW, #%00100000
LBA32:	jmp	LBBFC
;
LBA35:	ldX	#L8D7A
	ldaB	CYLINDER
	lslB	
	aBX		; index into L8D7A[CYLINDER]
		
	ldX	0, X	; X = L8D7A[CYLINDER] this a table of pointers to...

	ldD	0, X	; A:B = [X+0x00], a 16 bit value to send to SPI_DEV7
	
	ldX	#IOREG4000
	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB
	lslA	
	bpl	LBA69
	bset	SEQMW1, #%00001000
LBA69:	bclr	IOPORTA, X,SPI_DEV7

	ldX	#L8D9A
	ldaB	CYLINDER
	lslB	
	aBX	
	ldX	0, X
	brclr	MW2, #%10000000, LBA85
	ldaA	CYLINDER
	cmpA	ALDLMD_PWMDC
	bne	LBA85
	ldD	#$0001
	jr	LBA87
;
LBA85:	ldD	0, X
LBA87:	ldY	#LEFBB
	pushB	
	ldaB	CYLINDER
	lslB	
	aBY	
	popB	
	ldY	0, Y
	cmpY	#IOREG4000
	beq	LBAA0
	stD	0, Y
	jr	LBAD3
;
LBAA0:	oraA	#%01000000
	bset	IOPORTA, Y, #%01000000
	staA	SPI_DATA,Y
	bclr	SPI_CTRL,Y,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,Y
	staB	SPI_DATA,Y
	bclr	SPI_CTRL,Y,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,Y
	staA	SPIDEV7_LSB
	lslA	
	bpl	LBACF
	bset	SEQMW1, #%00001000
LBACF:	bclr	IOPORTA, Y,SPI_DEV7

LBAD3:	cmpX	#$008C
	bcs	LBAE2
	ldD	RBPINJ1
	addD	L00AB
	stD	L00AB
	ldD	RBPINJ1
	jr	LBAEC
;
LBAE2:	ldD	LBPINJ1
	addD	L00AB
	stD	L00AB
	ldD	LBPINJ1
	oraA	#%10000000
LBAEC:	pushB	
	ldX	#$008E
	ldaB	CYLINDER
	lslB	
	aBX	
	popB	
	stD	0, X
	
	ldX	#L8D8A
	ldaB	CYLINDER
	lslB	
	aBX	
	ldX	0, X
	
	ldD	0, X
	
	bmi	LBB0B
	
	pushB	
	pushA	
	tSX	
	ldD	RBPINJ1
	jr	LBB12
;
LBB0B:	andA	#%01111111
	pushB	
	pushA	
	tSX	
	ldD	LBPINJ1
LBB12:	subD	0, X
	popX	
	bcs	LBB21
	cmpD	MINBPINJ
	bcs	LBB21
	stD	L00A8
	jr	LBB2F
;
LBB21:	brclr	CLCCMW, #%00010000, LBB53
	brclr	L00B6, #%11111111, LBB53
	dec	>L00B6
	ldD	L8662
LBB2F:	pushB	
	pushA	
	popX	
	pushB	
	
	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction
		
	stX	L3FF2
	popB	
	addD	L00AB
	stD	L00AB
	ldD	L3FFC
	oraA	#%00000100
	nop	
	nop	
	nop	
	stD	L3FFC
	andA	#%11111011
	nop	
	nop	
	nop	
	stD	L3FFC
LBB53:	brclr	AFRCTS, #%11111111, LBB7C
	ldD	L000A
	beq	LBB62
	subD	#$0001
	stD	L000A
	jr	LBB7C
;
LBB62:	ldaA	L00AD
	beq	LBB6B
	decA	
	staA	L00AD
	jr	LBB7C
;
LBB6B:	ldaA	L00AF
	staA	L00AD
	ldD	AFRCTS
	subB	L00AE
	sbcA	#$00
	bcc	LBB7A
	ldD	#$0000
LBB7A:	stD	AFRCTS
LBB7C:	brset	MW3, #%00100000, LBBC7
	brclr	L000C, #%11111111, LBBB1
	ldD	L000E
	beq	LBB8F
	subD	#$0001
	stD	L000E
	jr	LBBC7
;
LBB8F:	ldaA	L00B0
	beq	LBB98
	decA	
	staA	L00B0
	jr	LBBC7
;
LBB98:	ldaA	L00B3
	staA	L00B0
	ldD	L000C
	bpl	LBBA6
	addD	L00B1
	bcs	LBBAA
	jr	LBBAD
;
LBBA6:	subD	L00B1
	bcc	LBBAD
LBBAA:	ldD	#$0000
LBBAD:	stD	L000C
	jr	LBBC7
;
LBBB1:	clrA	
	brclr	NVRAMWD1, #%00000001, LBBC5
	ldaA	L00AA
	addA	L83E8
	bcs	LBBC2
	cmpA	L83EB
	bls	LBBC5
LBBC2:	ldaA	L83EB
LBBC5:	staA	L00AA
LBBC7:	brclr	SPIDEV7_MSB, #%00000111, LBBCD
	jr	LBBE5
;
LBBCD:	ldaA	#$02
	cmpA	CYLINDER
	beq	LBBD8
	staA	CYLINDER
	bset	SEQMW1, #%00000001
LBBD8:	brset	SEQMW1, #%00001000, LBBDF
	bset	SEQMW1, #%00000010
LBBDF:	bclr	SEQMW1, #%00001000
	bset	SEQMW1, #%10000000
LBBE5:	brclr	MW3, #%00100000, LBBFC
	brset	MWFA1, #%00010000, LBBFC
	ldD	L00C6
	addd	L805F
	stD	L00C6
	cmpD	SPARKADV
	ble	LBBFC
	bclr	MW3, #%00100000

LBBFC:	ldX	#IOREG4000
	bclr	IOPORTB,X,#%00000010
	bset	FMDSDI, #%10000000
	bset	IOPORTA,X,#SPI_DEV3
	ldaA	FMDSDI
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	bclr	IOPORTA,X,#SPI_DEV3
	staA	FMD2
	reti	
;
;**********************************************************************
;
; We get here from LB59A, every other 6.25mS timeslice - i.e every 12.5mS
;
LBC1C:	brclr	MW2, #%00000100, LBC3C
;
	ldD	CNT_EST
	subD	ESTFBCNT	; A:B = delta(CNT_EST)
	tstA	
	bne	LBC2E	; if (A != 0) then > 255 pulses have occurred - must be an error 
	
	cmpB	KK42ESTCT ; = 0x40
	bls	LBC36	; if ( < 64 pulses) things are OK
;
; We get here is more than 64 ESC pulses have occurred in the last 12.5mS
; Increment TC42B_COUNT, and limit to 255
;	
LBC2E:	inc	TC42B_COUNT
	bne	LBC36
	dec	TC42B_COUNT
;
LBC36:	addd	ESTFBCNT
	stD	ESTFBCNT	; add on the delta ESCFBCNT to create a new one
;
LBC3C:	brset	MW1,MW1_ENGRUN,LBC5A
;
	ldX	#L8049	; This table is all 0xA4's, so....
	ldaA	NTPSLD
	call	LOOKUP1DBY16 ; A = 0xA4
;	
	ldaB	#$0F	; B = 0x0F
	mul		; A:B = 0x099C	
	stD	L01AE
;	
	cmpD	NTREVCYL65
	bhi	LBC5A
;
	bclr	MW2, #%00000100
	clrA	
	jr	LBC85
;
LBC5A:	brclr	MW2, #%00000100, LBC92
;
	bclr	MW2, #%00000100
	ldD	L00BE
	lsrD	
	lsrD	
	lsrD	
	comA	
	comB	
	addD	L00BE
	bpl	LBC6F
	ldD	#$0000
;
LBC6F:	stD	L00BE
	clr	>L00CA
	brset	MW1,MW1_ENGRUN,LBCAE
	brclr	MW3, #%01000000, LBC9F
	ldaA	L01B0
	cmpA	L805A
	bcc	LBC8A

	incA	
LBC85:	staA	L01B0
	jr	LBCA8
;
LBC8A:	bset	MW1,MW1_ENGRUN
	bset	NVRAMWD1, #%00001000
	jr	LBCAE
;
LBC92:	ldaA	L00CA
	cmpA	#$17
	bcs	LBCA4
;
	ldX	#$FFFF
	stX	L3FC0
	swi	
;
LBC9F:	bset	MW3, #%01000000
	jr	LBCA8
;
LBCA4:	brset	MW1,MW1_ENGRUN,LBCAB	; if the engine is running, goto LBCAB
LBCA8:	jmp	LC0C3			; else skip the RPM calculation stuff

LBCAB:	incA	
	staA	L00CA
;
; This appears to be RPM calculation code
;
LBCAE:	ldD	NTREVCYL65
	lslD		; A:B = NTREVCYL65 * 2	
	pushB	
	pushA	
	popX		; X = NTREVCYL65 * 2	
	pushX	
	ldD	#$0133    ; A:B = 0x0133 = 307
	fdiv		; X = A:B / X	

	pushX		; Now X = (NTRPMX  << 8) oooh I wonder if its 25.6	
	tSX	          ; X = SP
	ldD	0, X	; A:B = (NTRPMX << 8)
	cmpA	#$60      ; 60 * 25 = 2400 RPM
	bls	LBCCA	; if (NTRPMX < 2400 RPM) goto LBCCA
	
	addd	#$4080	; add on 1651.2 RPM
	bcc	LBCD1
	ldaA	#$FF
	jr	LBCD1     ; if carry, limit RPM to 0xFF
;
LBCCA:	lslD	          ; double the RPM
	subD	#$1F80    ; subtract 286 RPM ?
	bcc	LBCD1
	clrA	          ; if carry, limit RPM to 0

LBCD1:	staA	RPM

	ldD	0, X	; A:B = (NTRPMX << 8)
	addd	#$0080	; round the MSB
	bcc	LBCDC
	ldaA	#$FF	; if rounding causes overflow, limit to 255
LBCDC:	staA	NTRPMX	; store NTRPMX

	ldD	0, X	; A:B = (NTRPMX << 8)
	lslD	          ; A:B = (NTRPMX << 9) A = RPM * 12.8
	bcs	LBCE8
	addd	#$0080	; Round A:B
	bcc	LBCEA
LBCE8:	ldaA	#$FF	; limit A to 255, or 3250 RPM ish 
LBCEA:	clrB
	
	ldX	RPMFILT
	beq	LBCF5
	ldaB	KRPMFILT
	call	LAGFILTER
LBCF5:	stD	RPMFILT

	popX	
	popX	          ; X = NTREVCYL65 * 2
	ldD	#$00F6
	fdiv		; X = (X << 8) / 246	
	pushX	
	popA	
	popB	          ; A:B = X = (X << 8) / 246
	addd	#$0080	; Round up A:B 
	bcc	LBD07
	ldaA	#$FF	; if carry, max out to 255
	
LBD07:	staA	RPM8000

	brclr	NVRAMWD1, #%00000100, LBD12
	bclr	MW3, #%00000011
	jr	LBD63
;
LBD12:	ldaA	RPMFILT
	cmpA	L805B	; = 0x1C 
	bcs	LBD25	; if (RPMFILT < 358 RPM) goto LBD25 
	
	cmpA	L805C	; = 0x2D
	bcc	LBD4A	; if (RPMFILT >= 576 RPM) goto LBD4A 
	
	ldaB	RPMFILT1
	cmpB	L805D	; = 0x64
	bls	LBD4A	; if (RPMFILT1 < 2500 RPM) goto LBD4A
	
LBD25:	brset	MW3, #%00000010, LBD47
	clr	TC42B_COUNT
	ldD	L3FFC
	andB	#%11101111
	nop	
	nop	
	nop	
	stD	L3FFC
	bclr	FMDSDI, #%00000100
	di	
	call	LEDB8
	ei	
	ldD	CNT_EST
	stD	ESTFBCNT
;
	ldaA	RPMFILT
LBD47:	bset	MW3, #%00000011
;
LBD4A:	brclr	MW3, #%00000010, LBD63
	cmpA	L805E	; = 0x1E
	bls	LBD63	; if (RPMFILT < 384 RPM) goto LBD63

	bclr	MW3, #%00000011
	inc	TC42B_COUNT
	ldX	L3FEC
	nop	
	nop	
	nop	
	nop	
	stX	L3FE4
;
LBD63:	ldaA	#$FF
	ldaB	MAP1N
	subB	L00FC
	bcs	LBD6F
	cmpB	#$20
	bcc	LBD7A
LBD6F:	ldD	L00BC
	subD	NTREV65
	lslD	
	subD	L00BE
	bmi	LBD7C
	addD	L00BE
LBD7A:	stD	L00BE
LBD7C:	ldD	MAP1N
	stD	L00FB
	ldD	NTREV65
	lsrD	
	lsrD	
	lsrD	
	cmpD	L00BE
	bcc	LBD8C
	stD	L00BE
LBD8C:	ldD	NTREV65
	stD	L00BC
	lsrD	
	subD	#$00E5
	bcc	LBD9B
	addd	#$0134
	jr	LBDAB
;
LBD9B:	lsrD	
	subD	#$0127
	bcs	LBDA6
	addd	#$017E
	jr	LBDAB
;
LBDA6:	addd	#$05F7
	lsrD	
	lsrD
		
LBDAB:	pushB		; Push B	
	pushA		; Push A	
	ldaA	#$7C	; 0x7C = 12.4V
	subA	ADBAT
	bcc	LBDB5
	clrA		; if (ADBAT < 12.4 V) limit to 12.4V
		
LBDB5:	ldaB	#$04
	mul	          ; A:B = (ADBAT - 12.4V) * 4 (0.4 V per bit)
	tSX	
	addD	0, X	; A:B = [SP] + A:B 
	popX	
	addD	L00BE
	stD	L00C2
	
	ldD	NTREV65
	subD	#$0027
	cmpD	L00C2
	bcs	LBDCC
	ldD	L00C2
	
LBDCC:	stD	L00C0

	ldY	#$0000
	ldX	#KAFOPT2
	brclr	0, X, #%00000010, LBDEE

	ldaA	NTPSLD
	cmpA	#$06
	bcc	LBDEE	; if (NTPSLD >= 6) goto LBDEE

	bset	LCCPMW, #%10000000
	
	ldaA	CTS116MAX
	ldX	#L831C
	call	LOOKUP1DBY16
	jr	LBE2D
;
LBDEE:	bclr	LCCPMW, #%10000000
	ldX	#L8066
	brset	NVRAMWD1,#NVRAMWD1_CTSCOOL,LBE0F
	
	ldaB	CTSFILT
	cmpB	MINCOOL	; MINCOOL = 0
	bcc	LBE0A	; carry will always be clear, so goto LBE0A

	subB	CTSSTART
	bcs	LBE14	; if (CTSFILT < CTSSTART) goto LBE14
	
	cmpB	L8064	; if (Delta CTS < L8064) goto LBE14 
	bcs	LBE14

LBE0A:	bset	LCCPMW, #%01000000
	jr	LBE14
;
LBE0F:	ldaB	ADMAPN2
	jr	LBE16
;
LBE14:	ldaB	#$FF

LBE16:	ldaA	RPM
	cmpA	#$E0	; = 4000 RPM
	bls	LBE29	; if (RPM < 4000 RPM) goto LBE29 
	
	ldaA	RPM8000
	cmpA	#$F0
	bls	LBE24
	ldaA	#$F0	; if (RPM8000 > 7000) limit to 7000
LBE24:	subA	#$80
	ldX	#L8169
	
LBE29:	incX	          ; skip over the first byte in the table header
	call	LOOKUP3D

LBE2D:	staA	L0458
	tAB	
	aBY	

	ldX	#L81F6
	ldaB	ADMAPN2
	cmpB	#$A0
	bls	LBE3F
	ldaB	#$A0
LBE3F:	incX	
	ldaA	CTS116MAX
	call	LOOKUP3D
	staA	L0459
	tAB	
	aBY	
	brset	L0066,L0066_ALDL_DIAG,LBE6E
	brclr	FMDSDI, #%00000100, LBE6E
	brset	L0056, #%00000010, LBE6E
	brset	NVRAMWD1, #%10000000, LBE6E
	brclr	NVRAMWD1, #%00000001, LBE71
	ldaA	CTSFILT
	cmpA	L83E9
	bls	LBE71
	ldaB	L00AA
	aBY	
	jr	LBE71
;
LBE6E:	bclr	NVRAMWD1, #%00000001
LBE71:	ldD	L3FCA
	pushB	
	pushA	
	subD	NOCKCNT
	tstA	
	beq	LBE7D
	ldaB	#$FF
LBE7D:	popX	
	staB	PA3DELTA
	stX	NOCKCNT
	clrA	
	brset	NVRAMWD2, #NVRAMWD2_ESCON, LBEA1
	
	ldaB	CTSFILT
	subB	CTSSTART
	bls	LBE99
	
	cmpB	L8369	; = 0x01 = 0.75Deg
	bls	LBE99
	
	bset	NVRAMWD2, #NVRAMWD2_ESCON
	jr	LBEA1
;
; ESC Retard Enable Criteria - TurboP4.pdf 12.3.1.1
;
LBE99:	ldaB	CTSFILT
	cmpB	KESCOOL	; = 0x70 = 112 DegC
	bcs	LBEEE     ; if (CTSFILT < 112) DegC goto LBEEE
	
LBEA1:	ldaB	RPMFILT
	cmpB	KRPMKNOB	; = 0x50
	bcc	LBEB0     ; if (RPMFILT >= 1024 RPM) goto LBEB0
	
	ldaB	MPH
	cmpB	KMPHKNOB	; = 0x05
	bcs	LBEEE	; if (MPH < 5 MPH) goto LBEEE
;
; If we get here, the ESC Retard enable criterion have been met
;
LBEB0:	ldaA	KK43KRDF	; = 0x14 Default Knock Rtd when TC43 signalled
	brset	LCCPMW, #LCCPMW_TC43, LBEEE
	brset	NVRAMWD1, #%10000000, LBEEE

	ldaB	ADBAT
	cmpB	#$5D
	bcs	LBEEE	; if (ADBAT < 9.3V) goto LBEEE (Use KK43KRDF)
;
; ESC Retard Calculation. TurboP4.pdf 12.3.1.2
;
	ldaA	NTRPMX
	ldX	#F6
	call	LOOKUP1DBY16 ; A = fn(NTRPMX) 
	
	ldaB	PA3DELTA
	mul		; A:B = fn(NTRPMX) * PA3DELTA	
	lslD		; A:B = fn(NTRPMX) * PA3DELTA * 2	
	bcs	LBED4	; if overflow, goto LBED4 (limit to 0xFF)   
	
	addA	NOCKRTD	; A = NOCKRTD + fn(NTRPMX) * PA3DELTA * 2
	bcc	LBED6	; if no overflow, goto LBED6
;	
LBED4:	ldaA	#$FF	; Limit NOCKRTD to 0xFF
;
LBED6:	pushA		; Save the calculated new NOCKRTD
;	
	ldaA	L8367	; = 0x0E
	brclr	L005F, #%00100000, LBEE9
;
	ldX	#L838C	; This table is all 0x1C's
	ldaA	NTRPMX
	lsrA		; A = NTRPMX / 2	
	ldaB	#$10      ; Subtract 800 RPM (Closed Throttle)
	call	LOOKUP1DBY16OFFSET
			; The result in A will be 0x1C       
;			
LBEE9:	popB		; Retreive the calculated new NOCKRTD	

	cBA	
	bls	LBEEE
	tBA	    
	
LBEEE:	staA	NOCKRTD
	lsrA	
	tAB	

	ldX	#$0000
	brclr	VBATMW,#VBATMW_HUD,LBEFD
	brset	L0069, #%00000001, LBEFE
LBEFD:	aBX	

LBEFE:	ldaB	L8065	; = 0x00
	aBX	
	ldaB	L81F5	; = 0x55
	aBX	
	clrB
		
	bclr	L0056, #%00000010
	brset	NVRAMWD1, #%00100000, LBF2B
	
	ldaA	CTSSTART
	cmpA	L8061	; = 0xFF
	bcs	LBF28	; if (CTSSTART < 0xFF) goto LBF28
	
	ldaA	TIMELSB
	cmpA	L8972	; L8972 = 0x00
	bcc	LBF28
	
	ldaB	L8062	; L8062 = 0x00
	beq	LBF2B	; jump always coz L8062 == 0
	
	bset	L0056, #%00000010
	aBX	
	jr	LBF2B
;
LBF28:	bset	NVRAMWD1, #%00100000
;
LBF2B:	staB	L045A
;
	brclr	L005F, #%00000010, LBF36
;
	ldaB	L8319	; = 0x00
	aBX	
;
LBF36:	brset	LCCPMW, #%10000000, LBF3E
	ldaB	L01B6
	aBX	

LBF3E:	ldaA	NMPH
	cmpA	L8954	; = 0x06 = 1.875 mph
	bhi	LBF6C	; if (NMPH > 1.875 mph) goto LBF6C
	
	ldaA	NTPSLD1
	cmpA	L8951	; = 0x03 = 1.175%
	bhi	LBF6C	; if (NTPSLD1 > 1.175%) goto LBF6C
	
	ldaA	CTSFILT
	cmpA	L8310	; = 0x35
	bls	LBF6C	; if (CTSFILT < -0.25 DegC) goto LBF6C
	
	ldaB	RPMFILT
	subB	ISESDD
	bls	LBF6C	; if (RPMFILT < ISESDD) goto LBF6C
	
	decB	
	cmpB	#$07
	bls	LBF63
	ldaB	#$07	; if (RPMerror >= 7) then RPMerror = 7
	
LBF63:	pushX	
	ldX	#L8311	; this table is all zero's
	aBX	
	ldaB	0, X      ; therefore B = 0
	popX	
	aBX                 ; add on the correction for low RPM
		
LBF6C:	pushX
	
	ldaA	MATA
	cmpA	#$C0
	bls	LBF76
	ldaA	#$C0	; Limit MATA to 0xC0 = 152 DegC
	
LBF76:	ldaB	ADMAPN2
	lsrB		; halve ADMAPN2
		
	ldX	#L8277
	brclr	MW1,#MW1_MV10MIN,LBF84
	ldX	#L82BB

LBF84:	call	LOOKUP3D
	tAB		; B = fn(MATA,ADMAPN2)
		
	ldaA	NTRPMX
	ldX	#L82FF
	call	LOOKUP1DBY16 ; A = fn(NTRPMX)

	mul		; A:B = fn(NTRPMX) * fn(MATA,ADMAPN2) 	

	lslD		; A:B = fn(NTRPMX) * fn(MATA,ADMAPN2) * 2	
	bcc	LBF96
	ldaA	#$FF 	; limit A to 0xFF

LBF96:	staA	L01B7

	tAB	
	popX	
	aBX	

	ldaB	L000C
	bpl	LBFA4
	negB	
	aBX	
	jr	LBFA6
;
LBFA4:	aBY	
LBFA6:	brclr	CLCCMW, #%00100000, LBFC2
	ldaB	L01B8
	cmpB	L831A
	bcc	LBFB6
	incB	
	staB	L01B8
LBFB6:	ldaA	KAFOPT1	; KAFOPT1 = 0x06
	bitA	#%10000000
	bne	LBFC1
	aBY	
	jr	LBFC2
;
LBFC1:	aBX	
LBFC2:	pushY	
	popA	
	popB	
	pushX	
	tSX	
	subD	0, X
	popX	

	stD	SPARKADV1	; TurboP4.pdf 11.3.2 System Spark Advance
;	
; At this point A:B = Desired ignition advance angle, excluding the fixed retard,
; and ALDL requested modifications
;
	brclr	VBATMW,#VBATMW_HUD,LBFD4	; HUD is never present, so goto LBFD4
	call	L5803
;	
; At this point A:B = Desired ignition advance angle.
; A:B is signed, +ve = advance, -ve = retard
;
; Check for ALDL Mode 4
;
LBFD4:	brclr	ALDLMW,#ALDLMW_STARTMD4,LC000
	ldX	#ALDLMD_FMCW
;
; Check for ALDL Mode 4 Spark angle modification. if no, goto LC000
;
	brclr	0,X,#ALDL_FMCW_SPKMOD,LC000
;
; if spark modification is absolute, goto BFF2
; 	
	brset	0,X,#ALDL_FMCW_SPKDTA,LBFF2
;
; Spark modification is absolute, pick up the requested value 
; 
	clrA	
	ldaB	3,X	; A:B = 0x00:ABSSPK
;
; If requested angle is retard, make it negative.
;
	brclr	0,X,#ALDL_FMCW_SPKRTD,LBFED
	ldaA	#$FF
	negB	
;
LBFED:	bclr	MW3,#%00100000
	jr	LC000
;
; Spark modification is delta, check to see if advance or retard.   
; If mode is retard, goto LBFFC
;
LBFF2:	brset	0,X,#ALDL_FMCW_SPKRTD,LBFFC
;
; Delta Spark Advance. Add on the requested advance, and round 
;
	addB	3,X
	adcA	#$00
	jr	LC000
;
; Delta Spark Retart. Subtract on the requested retard, and round 
;
LBFFC:	subB	3, X
	sbcA	#$00
;	
; At this point A:B = Desired ignition advance angle, excluding the fixed retard,
; but including any ALDL requested modifications
;
LC000:	subB	KREFANGL	; = 0xBC = 66 Deg / -33 Deg ?
	sbcA	#$00      ; Round the result
	stD	SPARKADV	; TurboP4.pdf 11.3.2 Output Spark Advance
	
	brclr	PA3DELTA, #$FF, LC01E	;if (PA3DELTA == 0) goto LC01E
	brclr	NVRAMWD1, #%00000001, LC014
	bclr	NVRAMWD1, #%00000001
	jr	LC018
;
LC014:	brset	MW3, #%00100000, LC01B
LC018:	bset	NVRAMWD1, #%01000000
LC01B:	bclr	NVRAMWD1, #%10000000
LC01E:	bclr	MWFA1, #%00010000
	brclr	MW3, #%01000000, LC058
	brset	VBATMW,VBATMW_VLOW, LC04E
	
	ldaB	MALFWD3_MASK
	bitB	#MALFWD3_TC42
	beq	LC04E	; if (TC42 not enabled) goto LC04E
	
	brset	MW1, #%01000000, LC04E
	brset	VBATMW, #%01000000, LC043
	ldaB	TC42B_COUNT
	clr	TC42B_COUNT
	cmpB	KK42TIM
	bls	LC04B
LC043:	bset	VBATMW, #%01000000
	ldD	L3FFC
	jr	LC093
;
LC04B:	bset	MW1, #%01000000

LC04E:	ldX	L3FEC
	bclr	MW3, #%01000000
	nop	
	stX	L3FE4
LC058:	nop	
	nop	
	nop	
	nop	
	ldD	L3FFC
	oraB	#%00010000
	brset	FMDSDI, #%00000100, LC073
	ldX	#$0000
	stX	L00C6
	bset	MWFA1, #%00010000
	bset	MW3, #%00100000
	bset	FMDSDI, #%00000100
LC073:	brset	MW3, #%00000010, LC07B
	brclr	NVRAMWD1, #%00000100, LC096

LC07B:	bclr	FMDSDI, #%00000100
	andB	#%11101111

	brclr	MW3,#MW3_SPARK_BK,LC093

	pushB	
	ldaB	TC42B_COUNT
	cmpB	KK42TIM
	popB	
	bls	LC096
	
	bset	NVRAMWD1, #%00000100
	jr	LC096
;
LC093:	bset	MALFDET3,#MALFDET3_TC42
;
; End TC42 Checking
;
LC096:	brclr	ALDLMW,#ALDLMW_STARTMD4, LC0BE
	pushA
		
	ldaA	ALDLMDEW
	bitA	#ALDLMDEW_SPARK
	beq	LC0BD
	
	andB	#%11101111
	bclr	FMDSDI, #%00000100
	di	
	call	LEDB8
	ei	
	popA	
	pushA	
	stD	L3FFC
	clr	TC42B_COUNT
	bset	MW3,#MW3_SPARK_BK
	ldX	CNT_EST
	stX	ESTFBCNT

LC0BD:	popA
	
LC0BE:	stD	L3FFC
	jr	LC135
;
LC0C3:	clrA	                    ; A = 0
	clrB	                    ; B = 0
	stD	RPM
	stD	RPMFILT
	staA	RPM8000
	stD	TIMESEC		; TIMESEC = 0
	brset	NVRAMWD1, #%00001000, LC0D4
	stD	TIMERUN 		; TIMERUN = 0
LC0D4:	staB	L00D8

	brset	IACMW2, IACMW2_IACV_RESET,LC0F6
	brclr	CLCCMW,CLCCMW_BLMINIT,LC0E3
	ldaB	L0036_INI
	staB	L0036		; initialise L0036

LC0E3:	ldaB	KISPKDL
	call	IACVADJUST
	
	ldaA	#$FF
	staA	L00DC
	staA	ISESDD
	ldaA	#$80
	staA	IACMW1
	bclr	IACMW2, #%11111111
LC0F6:	ldD	L3FFC
	andA	#%11111011
	bclr	FMDSDI, #%00000100
	stD	L3FFC
	brset	SEQMW1, #%00010000, LC135
	ldD	#$7FFF
	addd	L3FB6
	nop	
	nop	
	nop	
	nop	
	stD	L3F94
	nop	
	nop	
	nop	
	nop	
	stD	L3F96
	nop	
	nop	
	nop	
	nop	
	stD	L3F98
	nop	
	nop	
	nop	
	nop	
	stD	L3F9A
	nop	
	nop	
	nop	
	nop	
	stD	L3F9C
	nop	
	nop	
	nop	
	nop	
	stD	L3F9E
	
LC135:	ldaA	#$00
	staA	COP_WDOG00	; Tickle the watchdog
	
	brset	L0066,#L0066_ALDL_AWAKE,LC1A0 
	
	ldX	#F90MST		; Normal mode ALDL schedule table
	ldaB	TIMER_TICK

ALDL_MODE7:
LC143:	andB	#%00011111	; Filter off the current frame
	aBX	                    ; Index into F90MST
	ldX	0, X                ; Get the contents of the index
	beq	LC1A0		; if ([F90MST] == 0) goto LC1A0

LC14A:	ldaA	2, X
	beq	LC1A0

	brset	ALDLMW,#ALDLMW_TX,LC193
	bset	ALDLMW,#ALDLMW_TX

	stX	ALDL_PTABLE
	ldaB	ALDL_FLAG_REG
	staA	ALDL_TXD_REG
	staA	ALDL_CSUM		; Set the checksum to the first byte transmitted
	
	ldaB	4, X
	staB	ALDL_BYTES_TODO
	beq	LC17B
	ldY	5, X
LC16B:	pushX	
	ldX	9, X
	ldaA	0, X
	staA	0, Y
	incY	
	popX	
	incX	
	incX	
	decB	
	bne	LC16B
LC17B:	ldaB	#$01
	staB	ALDL_COUNT
	di
		
	ldX	#IO_PORTA
	bset	0,X,#SPI_ALDLTX	; Enable the ALDL Tx Output Buffer

	brset	L0066,#L0066_ALDL_AWAKE,LC18C
	ei	                                                                  
	
LC18C:	ldaA	#$89
	staA	SCI_CTRL_REG	; 0x89 = enable SCI_TDRE & SCI_TE & SCI_EXTIRQ
	jr	LC1A0
;
LC193:	brset	ALDLMW,#%00100000, LC1A0
	bset	ALDLMW,#%00100000
	bset	VBATMW, #%00001000
	staB	ALDL_SCHED
	
LC1A0:	brclr	TIMER_TICK, #%00000010, LC1A7
	jmp	LC2AF
;
LC1A7:	ldaA	SPIDEV8_OUT
	andA	#%00001111
	oraA	L8022	; = 0x00
	staA	SPIDEV8_OUT
	
	ldX	L3FC2
	pushX	
	nop	
	nop	
	ldD	L3FE0
	nop	
	nop	
	nop	
	nop	
	cmpX	L3FC2
	beq	LC1CC
	
	popX	
	ldX	L3FC2
	pushX	
	nop	
	nop	
	ldD	L3FE0

LC1CC:	pushB	
	pushA	
	subD	L0146
	bne	LC1F4
	
	popX	
	popX	
	ldaA	L013F
	incA	
	cmpA	#$27
	bcs	LC1EB
	
	bclr	MW1, #%00010000
	ldD	#$0000
	staA	NMPH
	stD	MPH	; MPH = 0
	ldaA	#$27

LC1EB:	staA	L013F
	ldaA	NMPH
	jmp	LC295
;
LC1F4:	brset	MW1, #%00010000, LC211
	bset	MW1, #%00010000
	ldaB	#$01
	staB	L0148
	popX	
	stX	L0146
	ldD	#$FFFF
	pushB	
	pushA	
	inc	L01AD
	bset	CLCCMW, #%00000001
	jr	LC247
;
LC211:	popX	
	stX	L0146
	staB	L0148
	pushB	
	addB	L01AD
	staB	L01AD
	tSX	
	ldD	1, X
	subD	L0140
	dec	0, X
	incS	
	pushB	
	pushA	
	bne	LC244
	brset	CLCCMW, #%00000001, LC235
	bset	CLCCMW, #%00000001
	jr	LC247
;
LC235:	ldD	L0144
	lsrD	
	pushB	
	pushA	
	tSX	
	ldD	2, X
	lsrD	
	addD	0, X
	popX	
	jr	LC247
;
LC244:	bclr	CLCCMW, #%00000001
LC247:	stD	L0142
	popX	
	stX	L0144
	popX	
	stX	L0140
	ldaA	L013F
	clr	L013F
	cmpA	#$27
	bcs	LC25F
	clrA	
	jr	LC295
;
LC25F:	ldaB	L0148
	ldaA	L8021	; = 0x92 = 146
	mul	          ; A:B = L0148 * 146
	ldX	L0142
	fdiv		; X = (L0148 * 146) / L0142	
	pushX	
	popA	
	popB		; A:B = (L0148 * 146) / L0142	
	lslB		; A:B = ((L0148 * 146) / L0142) * 2	
	adcA	#$00	; round up the MSByte
	bcc	LC274
	ldaA	#$FF	; Limit MPH to 255 !!!
;
; A = Current speed in MPH
;
LC274:	ldX	MPH	; Point to the current filtered MPH
	ldaB	KFILTMPH	; MPH Lag Filter coefficent = 0xFF
	call	LAGFILTER
	stD	MPH
	
	addd	#$0080
	bcc	LC286
	decA		; Round MPH up, and limit to 255
		
LC286:	ldaB	#$CD
	mul		; A:B = MPH * 4/5	
	addd	#$0020	; round the LSBit of the above calculation
	cmpA	#$2F
	bls	LC293
	ldD	#$3000
LC293:	lslD	
	lslD
		
LC295:	brclr	L0067,#L0067_TC24,LC29D ; if (no TC24) use calculated NMPH
	ldaA	L8954	; = 0x06 = 1.875 mph
	incA		; = 0x07	
LC29D:	staA	NMPH

	brset	VBATMW,VBATMW_VLOW, LC2AC
	ldD	NTREVCYL65
	cmpD	#$1000
	bls	LC2AF
LC2AC:	bclr	VBATMW, #%00100000
LC2AF:	bset	MWFA1, #%00100000
	ldaA	DIAGMW1
	bitA	#%00100100
	bne	LC2FA
	brset	L005F, #%00000001, LC2FA
	ldaA	ADMAPN2
	cmpA	L8461     ;L8461 = 0xF0 = ????
	bcs	LC2FA
	ldaA	NTRPMX
	cmpA	L8462	;L8462 = 0xFF = 6375 RPM
	bcs	LC2FA
	
	ldaA	RPM8000
	ldaB	ADMAPN2
	ldX	#L8464
	call	LOOKUP3D
	tAB	
	
	ldaA	NTPSLD
	ldX	#L84D7
	call	LOOKUP1DBY16
	
	mul	
	
	lslD	
	bcc	LC2E6
	ldaA	#$FF
LC2E6:	tAB	
	ldaA	ADBAT
	ldX	#L84E8
	call	LOOKUP1DBY16
	aBA	
	bcc	LC2F5
	
	ldaA	#$FF
LC2F5:	cmpA	L8463	; = 0x00
	bhi	LC2FE
	
LC2FA:	bclr	MWFA1, #%00100000
	clrA	
LC2FE:	staA	L01BD
	brset	IACMW2,#IACMW2_IACV_RESET,LC30D
	brset	NVRAMWD1, #%00010000, LC357
	brclr	VBATMW,VBATMW_VLOW, LC357
LC30D:	ldaA	ISSPMP
	brset	IACMW2, #%00000010, LC31D
	brclr	IACMW2,#IACMW2_IACV_RESET,LC327
	tstA	
	bne	LC32E
	bset	IACMW2, #%00000010
LC31D:	subA	KISPKDL
	negA	
	bpl	LC330
	ldaA	#$7F
	jr	LC330
;
LC327:	bset	IACMW2,#IACMW2_IACV_RESET
	ldaA	#$FF
	staA	ISSPMP
	
LC32E:	ldaA	#$FF
LC330:	staA	ISSPMP_DELTA
	bne	LC35B

	bset	NVRAMWD1, #%00010000
	
	brset	VBATMW,VBATMW_VLOW, LC35B

	brclr	CLCCMW,CLCCMW_BLMINIT, LC344
	ldaB	L0036_INI
	staB	L0036		; Initialise L0036

LC344:	ldaB	KISPKDL
	call	IACVADJUST
	
	ldaA	#$FF
	staA	L00DC
	staA	ISESDD
	ldaA	#$80
	staA	IACMW1
	bclr	IACMW2, #%11111111
LC357:	brset	MW1,MW1_ENGRUN,LC364

LC35B:	clr	L00D9
	bclr	IACMW1, #%00010000
	jmp	LC73B
;
LC364:	ldaA	NTPSLD1
	staA	NTPSLD2
	ldaA	NTPSLD
	tAB		; A = B = NTPSLD	
	subB	NTPSLD1	; B = (NTPSLD - NTPSLD1)
	bcc	LC374
	negB		; make sure B is +ve
;		
LC374:	cmpB	L8952	; = 0x02
	bls	LC37C	; if (B < 0x02) goto LC37C
;	
	staA	NTPSLD1	; NTPSLD1 = new minimum NTPSLD

LC37C:	brclr	DIAGMW1, #%00100100, LC387 ; if ((DIAGMW1_TC21 && DIAGMW1_TC22) == 0) goto LC387

	ldaA	L8951	; = 0x03 = 1.175%
	lslA	
	staA	NTPSLD1

LC387:	ldX	#$8936
	brclr	IACMW2, #%00001000, LC3FA
	brset	FANMW, #FANMW_EFANON, LC396
	brset	FANMW, #%00000100, LC3BD
LC396:	brset	FANMW, #%00001000, LC39E
	brset	FANMW, #%00010000, LC3BD
LC39E:	brset	NVRAMWD1,#NVRAMWD1_CTSCOOL,LC3F0
	brclr	LCCPMW, #%01000000, LC3F0

	ldaA	L893A
	lslA	
	subA	L00E1
	bhi	LC3B9

	bset	NVRAMWD1,#NVRAMWD1_CTSCOOL
	bclr	LCCPMW, #%01000000
	ldaA	L896B
	jr	LC3EE
;
LC3B9:	ldaA	#$82
	jr	LC3D7
;
LC3BD:	ldaA	NTPSLD1
	cmpA	L8951	; = 0x03 = 1.175%
	bcc	LC3E1	; if (NTPSLD1 >= 1.175%) goto LC3E1
	
	ldaA	NMPH
	cmpA	L8954	; = 0x06 = 1.875 mph
	bhi	LC3E1	; if (NMPH > 1.875 mph) goto LC3E1

	ldaA	L8423
	lslA	
	subA	L00E1
	bls	LC3E1

	ldaA	#$02
LC3D7:	staA	ISSPMP_DELTA
	bset	IACMW1, #%00001000
	bclr	IACMW1, #%00010000
	jr	LC3FA
;
LC3E1:	bset	FANMW, #FANMW_EFANON
	brclr	FANMW, #%00010000, LC3EB
	bset	FANMW, #%00001000
LC3EB:	ldaA	L896A
LC3EE:	staA	L00DE
LC3F0:	bclr	IACMW1, #%00001000
	clr	>L00E1
	brclr	IACMW2, #%00100000, LC3FD
LC3FA:	jmp	LC4F5
;
LC3FD:	ldaA	NTPSLD1
	brclr	CLCCMW, #%00010000, LC410

	ldaB	L00E3
	beq	LC410
	decB	
	staB	L00E3
	addA	L8660
	bcs	LC419
	
LC410:	brclr	L005F, #%00000010, LC41B
	addA	L8667
	bcc	LC41B

LC419:	ldaA	#$FF
LC41B:	cmpA	27, X
	bhi	LC436
;
	ldaA	NTPSLD2
	cmpA	27, X
	bls	LC42A
;
	ldaA	51, X
	staA	L00DE
LC42A:	clrA	
	brclr	IACMW1, #%01010000, LC431
	jr	LC444
;
LC431:	tst	>L00D9
	beq	LC4B0
LC436:	ldaB	46, X
	mul	
	lslD	
	bcc	LC43E
	ldaA	#$FF
LC43E:	ldaB	47, X
	cBA	
	bls	LC444
	tBA
		
LC444:	brset	IACMW1, #%10000000, LC463
	ldaB	L0036
	cmpB	L0036_MAX
	bhi	LC454
	cmpB	L0036_MIN
	bcc	LC45C     	; if ((L0036 > L0036_MAX) || (L0036 < L0036_MIN))
LC454:	ldaB	L0036_INI		; then L0036 = L0036_INI;
	staB	L0036
	bset	CLCCMW,CLCCMW_BLMINIT	; Flag we've detected a BLM out of range

LC45C:	aBA	
	bcc	LC46A
	ldaA	#$FF
	jr	LC46A
;
LC463:	brclr	IACMW1, #%01000000, LC46A
	bset	IACMW1, #%00100000
LC46A:	ldaB	NMPH
	cmpB	30, X
	bls	LC478
	addA	L8971
	bcc	LC478
	ldaA	#$FF
LC478:	bset	IACMW1, #%00010000
	subA	L00D9
	bcs	LC485
	bpl	LC494
	ldaA	#$7F
	jr	LC494
;
LC485:	negA	
	bpl	LC48A
	ldaA	#$7F
LC48A:	cmpA	#$03
	bcc	LC492
	ldaB	51, X
	staB	L00DE
LC492:	oraA	#%10000000
LC494:	staA	ISSPMP_DELTA
	lslA	
	beq	LC4A6
	bcs	LC4F5
	ldaA	ISSPMP
	cmpA	56, X
	bcs	LC4F5
	bclr	IACMW1, #%00010000
	jr	LC4B0
;
LC4A6:	bclr	IACMW1, #%00110000
	brclr	IACMW1, #%10000000, LC4B0
	bclr	IACMW1, #%01000001
;
LC4B0:	brclr	ALDLMW,#ALDLMW_STARTMD4, LC4C8
;
	ldaA	ALDLMDEW
	bitA	#%00000010
	beq	LC4C8

	bset	IACMW1, #%00000100
	ldaA	ALDLMDST
	bitA	#%00000010
	bne	LC4F5
;
	bclr	IACMW1, #%00000100
LC4C8:	brset	IACMW1, #%00000100, LC4F5
	ldaA	NMPH
	bne	LC4F2
	ldaA	NTPSLD1
	cmpA	27, X
	bcc	LC4F2
	
	ldaA	RPMFILT
	cmpA	ISESDD
	bls	LC4E5	; if (RPMFILT < ISESDD) goto LC4E5
	
	ldaA	#$82	; open IACV by 2 steps
	bset	IACMW1, #%00000010
	jr	LC4F3
;
LC4E5:	ldaA	#$02	; close IACV by 2 steps
	brclr	IACMW1, #%00000010, LC4F3
	bset	IACMW1, #%00000100
	ldaA	50, X
	staA	L00DE
LC4F2:	clrA
	
LC4F3:	staA	ISSPMP_DELTA

LC4F5:	brclr	TIMER_TICK, #%00000111, LC4FC
	jmp	LC73F
;
LC4FC:	pushX	
	pushX	
	pushX	
	pushX	
	tSY	
	
	ldaA	CTSFILT
	ldX	#L893E		; Desired Idle Table
	call	LOOKUP1DBY16
	
	ldX	#$8936
	bclr	IACMW2, #%00100000
	brset	IACMW1, #%10000000, LC51D
	brset	SPIDEV8_IN, #%00000010, LC51B
	addA	7, X	; [X+0x07] = 0x00
LC51B:	addA	6, X	; [X+0x06] = 0x00
LC51D:	brclr	L0056, #%00000010, LC523
	addA	61, X	; [X+  61] = 0x00 
;
; Check for ALDL Mode 4 RPM control
;
LC523:	brclr	ALDLMW,#ALDLMW_STARTMD4, LC535
	ldaB	ALDLMD_FMCW
	bitB	#ALDL_FMCW_IACMOD
	beq	LC535		; if ALDL isn't requesting IACRPM goto LC535
	bitB	#ALDL_FMCW_IACRPM
	beq	LC535		; if ALDL isn't requesting RPM control goto LC535
	ldaA	ALDLMD_IACRPM
LC535:	staA	ISESDD              ; Store the desired idle

	cmpA	RPMFILT
	bcc	LC53E		; if (ISESDD >= RPMFILT) goto LC53E
	
	bset	IACMW1, #%00000010

LC53E:	ldD	L00D3
	subD	RPMFILT
	rorA	
	rorB	
	asrA	
	rorB	
	asrA	
	rorB	
	asrA	
	rorB	
	callr	LC594
	staB	L00D3
	
	ldD	#$0000
	stD	0, Y
	ldaB	RPMFILT
	stD	4, Y
	ldaB	ISESDD
	subD	4, Y
	callr	LC594
	staB	4, Y
	tBA	
	bpl	LC567
	negA	
LC567:	staA	2, Y
	cmpA	26, X
	bls	LC571
	clrA	
	jr	LC576
;
LC571:	ldaA	L00DA
	incA	
	beq	LC578
LC576:	staA	L00DA

LC578:	ldaA	L00DE
	beq	LC57F
	decA	
	staA	L00DE

LC57F:	ldaA	NTPSLD1
	cmpA	27, X
	bcc	LC58D

	ldaA	NMPH
	cmpA	30, X
	bls	LC5A5

LC58D:	bclr	IACMW1, #%00000001
	tBA	
	jmp	LC5E5
;
LC594:	lslD	
	bcc	LC59E
	incA	
	beq	LC5A3
	clrB	
	sec	
	jr	LC5A3
;
LC59E:	tstA	
	beq	LC5A3
	ldaB	#$FF
LC5A3:	rorB	
	ret	
;
LC5A5:	tst	NMPH
	bne	LC5DC
	ldaA	L00DE
	bne	LC5E4
	pushB	
	ldaA	L00DA
	cmpA	L8446
	bls	LC5DB
	brset	IACMW2, #IACMW2_ALDL_IACV, LC5DB
	brset	L0056, #%00000010, LC5DB
	ldaA	TIMER_TICK
	cmpA	#$30
	bne	LC5DB
	ldaA	L00DC
	ldaB	L00E2
	beq	LC5DB
	bmi	LC5D5
	incA	
	cmpA	L00DF
	bls	LC5D9
	ldaA	L00DF
	jr	LC5D9
;
LC5D5:	decA	
	bne	LC5D9
	incA	
LC5D9:	staA	L00DC
LC5DB:	popB	
LC5DC:	brclr	IACMW1, #%00000100, LC5E8
	brclr	IACMW1, #%00011000, LC627
LC5E4:	tBA	
LC5E5:	tstA	
	bpl	LC617
LC5E8:	clr	>L00DA

	ldaB	NTPSLD1
	cmpB	L8953	; = 3.125%
	bcs	LC614	; if (NTPSLD1 < 3.125%) goto LC614
	
	ldaB	NMPH
	cmpB	30, X
	bls	LC614
	
	ldaB	L00E2
	ble	LC614

	ldaA	TIMER_TICK
	andA	#%00011000
	cmpA	#$18
	bne	LC614

	brset	IACMW1, #%00001000, LC614
	bclr	IACMW1, #%00010000
	ldaB	#$81
	staB	ISSPMP_DELTA
	bset	IACMW2, #%00100000
LC614:	jmp	LC737
;
LC617:	ldaB	58, X
	beq	LC620
	ldaB	NMPH
	bne	LC5E8
LC620:	cmpA	31, X
	bls	LC5E8
	bclr	IACMW1, #%00011000
LC627:	ldaA	25, X
	staA	5, Y
	ldaA	42, X
	ldaB	41, X
	stD	6, Y
	ldaB	4, Y
	ldX	#$8936
	ldaA	2, Y
	cmpA	5, Y
	bls	LC681
LC641:	tstB	
	bmi	LC669
	ldaA	32, X
	tst	4, Y
	bmi	LC672
	pushA	
	ldaA	2, Y
	cmpA	L895E
	popA	
	bls	LC672
	cmpB	34, X
	bls	LC672
	addA	35, X
	bcc	LC672
	pushB	
	mul	
	adcA	#$00
	popB	
	aBA	
	bpl	LC675
	ldaA	#$7F
	jr	LC675
;
LC669:	ldaA	33, X
	negB	
	mul	
	adcA	#$00
	negA	
	jr	LC675
;
LC672:	mul	
	adcA	#$00
LC675:	tAB	
	clrA	
	tstB	
	bpl	LC67B
	comA	
LC67B:	addD	0, Y
	stD	0, Y
LC681:	cmpX	#$893A
	beq	LC699
	ldX	#$893A
	ldaB	L00D3
	tBA	
	bpl	LC68F
	negA	
LC68F:	staA	3, Y
	cmpA	53, X
	bcc	LC641
	ldD	0, Y
LC699:	call	LC594
	staB	0, Y
	bpl	LC6A2
	negB	
LC6A2:	tBA	
	cmpA	45, X
	bcs	LC6B2
	clr	>L00D7
	ldaB	0, Y
	staB	4, Y
	jr	LC6EB
;
LC6B2:	ldaB	3, Y
	cmpB	6, Y
	bls	LC6BD
	jmp	LC731
;
LC6BD:	ldaB	7, Y
	ldaA	2, Y
	cmpA	5, Y
	bhi	LC6CE
	cmpA	51, X
	bls	LC731
	ldaB	50, X
LC6CE:	mul	
	lslD	
	ldaB	4, Y
	bpl	LC6D6
	negA	
LC6D6:	addA	L00D7
	bvc	LC6DF
	ldaA	#$7F
	bcc	LC6DF
	negA	
LC6DF:	staA	4, Y
	staA	L00D7
	bpl	LC6E7
	negA	
LC6E7:	cmpA	45, X
	bcs	LC734
LC6EB:	ldaB	44, X
	mul	
	adcA	#$00
	stD	6, Y
	ldaA	45, X
	mul	
	adcA	#$00
	bpl	LC6FC
	ldaA	#$7F
LC6FC:	staA	5, Y
	ldX	#L8974
	ldaA	CTSFILT
	call	LOOKUP1DBYN
	pushY	
	popX	
	ldaB	#$06
	aBX	
	call	MULT8BY16
	lslB	
	adcA	#$00
	tAB	
	ldaA	4, Y
	rolA	
	ldaA	5, Y
	bcc	LC721
	negA	
	oraB	#%10000000
LC721:	staB	ISSPMP_DELTA
	lslB	
	beq	LC729
	bset	IACMW2, #%00100000
LC729:	ldaB	L00D7
	beq	LC737
	staA	L00D7
	jr	LC737
;
LC731:	clr	>L00D7
LC734:	clr	>ISSPMP_DELTA
LC737:	popX	
	popX	
	popX	
	popX	
LC73B:	ldD	RPMFILT
	stD	L00D3
LC73F:	jmp	LD630
;
LC742:	bclr	MWFA1, #%00000001
	ldaB	NTPSLD
	cmpB	L85E4	; = 0x03
	bhi	LC758     ; if (NTPSLD > 3) goto LC758
	
	ldaB	NMPH
	cmpB	L85E5
	bhi	LC758	; if (NMPH > 0x31) goto LC758
	
	bset	MWFA1, #%00000001
;	  
; Read the MAP
;
LC758:	ldaA	#MAPAtoD
	call	ReadAtoD
	staA	ADMAP
;
; Perform TC34 Checking
;	
	ldaA	ADMAP
	brset	DIAGMW1,DIAGMW1_TC21,LC78E 	; if TC21 set, don't set TC34
	
	cmpA	KKPM34		; 0x0F = 0.20 Bar
	bcc	LC78E		; if (ADMAP > 0.2 Bar) goto LC78E
	
	ldaB	TC34_COUNT
	cmpB	KK34TIM		; = 0x23 = 3.5 Sec
	bcc	LC786		; if (TC34_COUNT >= 3.5 Sec) flag a TC34
	
	ldaB	RPMFILT
	cmpB	KKES34A		; = 0x38 = 1400 RPM
	bcs	LC781		; if (RPMFILT < 1400 RPM) goto LC781
	
	ldaB	NTPSLD
	cmpB	KKTA34		; = 0x33 = 20%
	bls	LC78E		; if (NTPSLD < 20%) goto LC78E
	
LC781:	inc	TC34_COUNT 	; TC34_COUNT++
	jr	LC794
;
LC786:	bset	MALFDET2,MALFDET2_TC34 ; flag a TC34
	bset	DIAGMW4, DIAGMW4_TC34
	jr	LC794
;
LC78E:	clr	TC34_COUNT 	; TC34_COUNT = 0
	bclr	DIAGMW4, DIAGMW4_TC34	; clear TC34 flag
;
; End TC34 Checking
;	
LC794:	brset	DIAGMW5,#DIAGMW5_TC66,LC79C ; If TC66 detected, calculate a MAP from TPS & RPM
	brclr	DIAGMW4,#%00000011, LC7C3  ; If (no TC33 or TC34) goto LC7C3

LC79C:	ldaA	KMAPHIDF	; Default ADMAP to 1.96 Bar
	brclr	VBATMW, #%00100000, LC7C3
	
	ldaA	L83D1	;L83D1 = 0xFF = 255
	ldaB	NTPSLD
	mul		;A:B = NTPSLD * 255	
	lslD	
	bcs	LC7B9
	
	tAB	
	ldaA	RPM8000
	ldX	#L83D2
	call	LOOKUP1DBY16

	aBA	
	bcc	LC7BB

LC7B9:	ldaA	#$FF

LC7BB:	cmpA	KMAPHIDF	; Default ADMAP to 1.96 Bar
	bls	LC7C3
	ldaA	KMAPHIDF	; Default ADMAP to 1.96 Bar
LC7C3:	staA	ADMAPLAG

	ldaA	ADMAPLAG
	ldaB	KFILTMAP	; = 0xF0
	ldX	FILTMAP
	call	LAGFILTER
	stD	FILTMAP
	
	ldX	NMAP1    ;X = NMAP2
	stX	NMAP2    ;NMAP2 = NMAP1
	ldX	NMAP0    ;X = NMAP0
	stX	NMAP1    ;NMAP1 = NMAP0

	ldaB	KAFOPT1	; KAFOPT1 = 0x06
	bitB	#KAFOPT1_2BARMAP
	beq	LC814	; This jump never taken, LC has 2 bar MAP
;
; This section of code is used for a 2Bar MAP Sensor. Used in LC code
;
	staA	ADMAPN	; Store limited MAP
	ldaB	#$A0	; = 0.625
	subA	#$1C	; A = MAP - 0.22 Bar
	call	MULTAB2NC ; A = (MAP - 0.22) * 0.625 * 2
	staA	ADMAPN2
;
; Simulate ADMAP1BAR
;	
	ldaA	ADMAPN
	ldaB	#$87
	mul	
	subD	#$0190
	bcc	LC7FA
	ldD	#$0000
LC7FA:	lslD	
	bcs	LC800
	lslD	
	bcc	LC802
LC800:	ldaA	#$FF

LC802:	staA	ADMAP1BAR

	ldaB	ADMAPN
	clrA	
	addd	#$000A
	ldX	#$C800
	call	MULT16BY16
	stD	NMAP0
	jr	LC825
;
; This section of code is used for a 1Bar MAP Sensor. Not used in LC code
;
LC814:	staA	ADMAP1BAR

	clrA	
	ldaB	ADMAP1BAR	; A:B = 0x00:ADMAP1BAR
	ldX	#$02B6	; X = 694 = 2.71
	fdiv		; X = ADMAP1BAR / 2.71		
	pushX	
	popA	
	popB	
	addd	#$0A57    ; A:B = (ADMAP1BAR / 2.71) + 10.33
	stD	NMAP0

LC825:	ldaB	#$97	; = 0.590
	ldaA	ADMAP1BAR
	subA	#$1C	; A = (ADMAP1BAR - 0.11 Bar)
	call	MULTAB2NC ; A = (ADMAP1BAR - 0.11) * 1.18
	staA	MAP1N
	
	ldaA	MAP1N
	ldaB	KFILTL01D0
	ldX	FILTL01D0
	call	LAGFILTER
	stD	FILTL01D0

	ldX	L01AB
	brclr	VBATMW,VBATMW_VLOW, LC87C
	cmpX	#$0008
	bcs	LC87F
	bclr	SEQMW1, #%11111111
	bclr	NVRAMWD1, #%11101111
	bclr	NVRAMWD2, #%11111111	; NVRAMWD2 = 0
	cmpX	L8017
	bcs	LC859
	swi	
LC859:	brclr	MW1, #%00000101, LC85F	; if (MW1_EWPOFF && MW_FANOFF) are both off goto LC85F
	jr	LC863
;
LC85F:	incX	
	stX	L01AB
LC863:	ldD	#$0000
	stD	TIMERUN		; = 0
	stD	TIMESEC		; = 0
	bclr	MW1,MW1_ENGRUN	; Flag Engine stalled
	clr	L01B0
	clr	L01D6
	bclr	DIAGMW1, #%00000001
	bclr	DIAGMW4, #%10000000
	jr	LC883
;
LC87C:	ldX	#$FFFF
LC87F:	incX	
	stX	L01AB
LC883:	brset	VBATMW, #%00100000, LC8BC
	ldD	#$0000
	brclr	NVRAMWD2, #NVRAMWD2_FPUMP, LC8A3
	
	ldaA	NTPSLD
	ldX	#L850D
	call	LOOKUP1DBYN
	
	ldX	#L0168
	call	MULT8BY16
	
	lslD	
	bcc	LC8A3
	ldD	#$FFFF
LC8A3:	stD	L007C
	brset	SEQMW1, #%01000000, LC8B9
	beq	LC8B6
	pushB	
	pushA	
	popX
		
	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction	

	pushX	
	popA	
	popB	
LC8B6:	stD	L0463
LC8B9:	jmp	LD559
;
LC8BC:	ldaA	CTSFILT
	cmpA	L865E
	bcs	LC8E3

	brset	L0067,#L0067_TC24,LC8D0
	ldaA	MPH
	cmpA	L865F 
	bls	LC928     ; if (MPH < 0x0D) goto C928
	
LC8D0:	brclr	DIAGMW1, #%00100100, LC8D6 ; if ((DIAGMW1_TC21 && DIAGMW1_TC22) == 0) test for ??
	jr	LC8E5		; else skip
;
LC8D6:	ldaA	NTPSLD
	cmpA	L865D
	bls	LC8E5	; if (NTPSLD < 0x0A) goto LC8E5
	
	ldD	#$0000
	stD	L00B4
LC8E3:	jr	LC928
;
LC8E5:	ldaA	RPMFILT1
	subA	RPMFILT
	bcs	LC8F0
	
	cmpA	L865B
	bcc	LC928

LC8F0:	ldaB	L8659
	brclr	L005F, #%00000010, LC8FA
	ldaB	L865A
LC8FA:	cmpB	NMAP0
	bcs	LC928
	ldaB	L8657
	brclr	L005F, #%00000010, LC908
	ldaB	L8658 	; L8658 = 0x28 / 1000 RPM
LC908:	cmpB	NTRPMX
	bcc	LC928
	ldaB	L00B7
	beq	LC913
	decB	
	jr	LC92B
;
LC913:	brset	L005F, #%00000010, LC91E
	ldX	L00B4
	bne	LC928
	bset	L005F, #%00000010
LC91E:	bclr	CLCCMW, #%00010000
	ldX	L8665
	stX	L00B4
	jr	LC96D
;
LC928:	ldaB	L865C
LC92B:	staB	L00B7
	brclr	L005F, #%00000010, LC93E
	bclr	L005F, #%00000010
	ldD	SPARKADV
	stD	L00C6
	bset	MW3, #%00100000
	bset	MWFA1, #%00010000
LC93E:	ldX	L00B4
	bne	LC947
	bclr	CLCCMW, #%00010000
	jr	LC96D
;
LC947:	decX	
	stX	L00B4
	ldaB	NTRPMX
	cmpB	L8658 	; L8658 = 0x28 / 1000 RPM
	bcs	LC95C
	ldaB	RPMFILT1
	subB	RPMFILT
	bcs	LC96D
	cmpB	L865B
	bcs	LC96D
LC95C:	brset	CLCCMW, #%00010000, LC96D
	bset	CLCCMW, #%00010000

	ldaA	L8664
	staA	L00B6

	ldaA	L8661
	staA	L00E3
;
LC96D:	ldX	#L86E8
	ldaA	NTRPMX
	call	LOOKUP1DBY16
;
	brclr	L005F, #%00100000, LC97F
	subA	L86E7
	bcc	LC97F
	clrA	

LC97F:	cmpA	NMAP0
	bls	LC992

	ldaA	L86E5
	brclr	L005F, #%00100000, LC98D
	subA	L86E6

LC98D:	cmpA	NTPSLD
	bhi	LC997
;	
LC992:	bset	L005F, #%00100000
	jr	LC9A0
;
LC997:	bclr	L005F, #%00100000
	ldD	#$0000
	stD	L0156
LC9A0:	clr	L015A
;
; Check for ALDL Mode 4 AFR control
;
	brclr	ALDLMW,#ALDLMW_STARTMD4, LC9CB
	ldaA	ALDLMD_FMCW
	bitA	#ALDL_FMCW_AFMOD
	beq	LC9CB
	ldaB	ALDLMD_AFRATIO
	clrA			; A:B = 0x00:ALDLMD_AFRATIO	
	pushB	
	pushA	
	popX			; X = 0x00:ALDLMD_AFRATIO 	
	ldD	#$FFFF
	idiv			; X = 0xFFFF / 0x00:ALDLMD_AFRATIO	
	stX	FA_RATIO
	
	ldD	#$0000
	stD	L0154
	stD	L0156
	bclr	L005F, #%00100000
	jmp	LCA37
;
LC9CB:	clrA	
	ldaB	AFRCTS
	addB	L85D2
	adcA	#$00
	addB	L0158
	adcA	#$00
	pushB	
	pushA	
	brset	MWFA1, #%10000000, LC9EA
;	
	ldaA	ADMAPN2
	ldX	#L8587		; This table is all 0's
	call	LOOKUP1DBY16
	staA	L015A		; So L015A = 0x00
;	
LC9EA:	popA	
	popB	
	addB	L015A
	adcA	#$00
	ldX	KFA_STOIC		; 14.7:1
	call	MULT16BY16
	stD	L0154
	brclr	L005F, #%00100000, LCA29
	
	ldX	#L86FF	; If we've been moving less than 10 mins, use L86FF
	brclr	MW1,#MW1_MV10MIN,LCA08
	ldX	#L8792	; If we've been moving more than 10 mins, use L8792

LCA08:	ldaA	RPM8000
	cmpA	#$F0
	bls	LCA10
	ldaA	#$F0	; Limit RPM8000 to 0xF0

LCA10:	ldaB	ADMAPN2
	lsrB	

	call	LOOKUP3D
	tAB	

	ldX	#$0080
	aBX	

	ldaB	L0159
	aBX	

	ldD	KFA_STOIC		; 14.7:1
	call	MULT16BY16
	stD	L0156
	
LCA29:	ldX	L0156
	cmpX	L0154
	bhi	LCA34
	ldX	L0154

LCA34:	stX	FA_RATIO

LCA37:	brclr	VBATMW,#VBATMW_HUD,LCA3E
	call	L5800

LCA3E:	ldaA	NMAP0
	cmpA	L83EA	;L83EA = 0x4C = 0.61 BAR ?
	bcc	LCA48
	bclr	NVRAMWD1, #%00000001
LCA48:	ldY	#NMAP0
	bclr	L005F, #%00000100
;
; This section of code checks to see if the current BLMCELL is OK
; based on the current RPM value
;
	ldaB	BLMCELL	; B = Existing BLMCELL
	andB	#BLMCELL_RPMMASK
	ldX	#L8645
	aBX		; index into the L8645 Table	
	tstB	
	beq	LCA6A	; if (BLMCELL rpmfield == 0) already in MIN, so no need to check for change down goto LCA6A
	
	ldaA	0, X	; A = [X+(BLMCELL & BLMCELL_RPMMASK)] 
	subA	L864C     ; L864C = 0x02 - I think this is introducing - 50 RPM hysteresys
	bcs	LCA66     ; check no underflow - should be ok coz all the values in L8645 are > L864C 
	
	cmpA	NTRPMX
	bhi	LCAA4	; if ((BLM_RPM_TABLE_VALUE - 2) > currentRPM) calculate a new BLMCELL

LCA66:	cmpB	#$03
	beq	LCA75	; if (BLMCELL rpmfield == 3) already in MAX, so no need to check for change up goto LCA75

LCA6A:	ldaA	1, X      ; A = [X+(BLMCELL & BLMCELL_RPMMASK)]
	addA	L864C	; L864C = 0x02 - I think this is introducing + 50 RPM hysteresys
	bcs	LCA75     ; check no overflow - should be ok coz all the values in L8645 are < (255 - L864C)
	
	cmpA	NTRPMX
	bcs	LCAA4	; if ((BLM_RPM_TABLE_VALUE + 2) < currentRPM) calculate a new BLMCELL
;	
; This section of code checks to see if the current BLMCELL is OK
; based on the current MAP value
;
LCA75:	ldaB	BLMCELL	; B = Existing BLMCELL
	andB	#BLMCELL_MAPMASK
	lsrB	          ; B = 0,2,4 or 6
	lsrB		; B = 0,1,2 or 3	
	ldX	#L8648	; X->Table of MAP values, NOT 0!!!
	aBX	          ; index into the L8649 Table - NOTE there is no '0' index !!!
	tstB	          ; B = 0 ?
	beq	LCA93	; if (BLMCELL mapfield == 0) already in MIN, so no need to check for change down goto LCA93
	
	ldaA	0, X      ; A = [X+0] = Current BLM MAP lower limit
	subA	L864D	; L864D = 0x02 - I think this is introducing -0.015 Bar hysteresys
	bcs	LCA8F     ; check no underflow - should be ok coz all the values in L8649 are > L864D
	
	cmpA	0, Y
	bhi	LCAA4	; if ((BLM_MAP_TABLE_VALUE - 2) > currentMAP) Calculate a new BLMCELL
	
LCA8F:	cmpB	#$03
	beq	LCA9F	; if (BLMCELL mapfield == 3) already in MAX, so no need to check for change up goto LCA9F

LCA93:	ldaA	1, X      ; A = [X+1] = Current BLM MAP upper limit
	addA	L864D	; L864D = 0x02 - I think this is introducing +0.015 Bar hysteresys
	bcs	LCA9F     ; check no overflow - should be ok coz all the values in L8649 are < (255 - L864D)
	
	cmpA	0, Y
	bcs	LCAA4	; if ((BLM_MAP_TABLE_VALUE + 2) < currentMAP) calculate a new BLMCELL

LCA9F:	ldaB	BLMCELL	; B = Existing BLMCELL
	jr	LCAD4     ; Use the existing BLMCELL
;
; This section of code calculates the new BLMCELL from RPM and MAP
; BLMCELL is an index into a 4*4 array of BLM Values
;
LCAA4:	clrB	          ;B = 0
	bset	L005F, #%00001100
	ldaA	NTRPMX    ;A = RPM
	cmpA	L8646	;L8646 = 0x20 = 800 RPM
	bcs	LCABC     ;if (RPM < 800) goto LCABC
	incB	          ;B = 1
	cmpA	L8647	;L8647 = 0x3C = 1500 RPM
	bcs	LCABC     ;if (800 <= RPM < 1500) goto LCABC
	incB	          ;B = 2
	cmpA	L8648	;L8648 = 0x50 = 2000 RPM
	bcs	LCABC     ;if (1500 <= RPM < 2000) goto LCABC
	incB	          ;B = 3

LCABC:	ldaA	0, Y      ;A = [Y+0] = MAP
	cmpA	L8649	;L8649 = 0x28 = 0.32 BAR
	bcs	LCAD4     ;if (MAP < 0.32) goto LCAD4
	addB	#$04	;B = B + 4
	cmpA	L864A	;L864A = 0x46 = 0.55 BAR
	bcs	LCAD4     ;if ( 0.32 <= MAP < 0.55) goto LCAD4
	addB	#$04	;B = B + 4
	cmpA	L864B	;L864B = 0x64 = 0.78 BAR
	bcs	LCAD4     ;if ( 0.55 <= MAP < 0.78) goto LCAD4
	addB	#$04	;B = B + 4
LCAD4:	staB	BLMCELL   ;Save the calculated BLMCELL value
;
;We now have a BLMCELL value, so time to get the BLM Value from the 
;BLM Array. There are two 4*4 BLM arrays, one for the front part of
;the engine and another for the rear.
;
	ldX	#FBLMTABLE ;X = &FBLMTABLE
	aBX	          ;X = &FBLMTABLE[BLMCELL]
	ldaA	0, X      ;A = [X+0] = Front BLM value
	cmpA	KBLMMAX	;  = 0xA0
	bhi	LCB11	;Jump if FBLM > 0xA0 to CB11
	cmpA	KBLMMIN    ;  = 0x5A
	bcs	LCB11     ;Jump if FBLM < 0x5A to CB11
	staA	FBLM      ;Save the validated FBLM
	bmi	LCAED
	ldaA	#$80      ;May need to force FBLM to 0x80
LCAED:	brclr	L005F, #%00100000, LCAF3
	staA	FBLM      ;Save the forced FBLM = 0x80  
	
LCAF3:	ldX	#RBLMTABLE    ;X = &RBLMTABLE
	aBX	          ;X = &RBLMTABLE[BLMCELL]
	ldaA	0, X      ;A = [X+0] = Rear BLM value
	cmpA	KBLMMAX	;  = 0xA0
	bhi	LCB11     ;Jump if RBLM > 0xA0 to CB11
	cmpA	KBLMMIN    ;  = 0x5A
	bcs	LCB11     ;Jump if RBLM > 0xA0 to CB11
	staA	RBLM      ;Save the validated RBLM
	bmi	LCB09
	ldaA	#$80      ;May need to force RBLM to 0x80
LCB09:	brclr	L005F, #%00100000, LCB23
	staA	RBLM      ;Save the forced RBLM = 0x80
	jr	LCB23     ;Skip the following BLM out of range code 
;
;We get here if either RBLM or FBLM tables contain a value that is
;greater than KBLMMAX or less than KBLMMIN. This code sets both RBLM
;and FBLM tables to 0x80, and then forces the current RBLM & FBLM
;to 0x80 as well
;
LCB11:	bset	CLCCMW,CLCCMW_BLMINIT
	ldaA	#$80	;A = 0x80, the value to initialise with
	clrB	          ;B = 0
	ldX	#$0020    ;X = 0x0020
LCB1A:	staA	20, X     ;[X+0x14] = A = 0x80
	decX	
	bne	LCB1A     ;for X = [0x0015..0x0034] = 0x80
	staA	FBLM      ;FBLM = 0x80
	staA	RBLM      ;RBLM = 0x80
;
;When we get here, BLMCELL, FBLM and RBLM have all been set.
;
LCB23:	clrA	          ; A = 0
	brset	MWFA1, #%00000001, LCB66
	ldaA	RPMFILT

	ldaB	MPH	; B = MPH
	cmpB	L85E6 	; L85E6 = 0x2C = 44 MPH
	bcs	LCB3C	; if (MPH < 44 MPH) goto LCB3C

	cmpA	L85E8	; = 0x80 = 1600 RPM
	bcs	LCB44
	ldaA	L85E8 	; if (RPMFILT > 1600 RPM) then A = 1600 RPM
	jr	LCB44
;
LCB3C:	cmpA	L85E7	; = 0x50 = 1000 RPM
	bcs	LCB44
	ldaA	L85E7	; if (RPMFILT < 1000 RPM) then A = 1024 RPM

LCB44:	ldaB	MAP1N
	cmpB	#$80
	bcs	LCB4C
	ldaB	#$80	; if (B >= 0x80) then B = 0x80

LCB4C:	mul	
	adcA	#$00
	ldaB	L85E9
	mul	
	lslD	
	bcc	LCB58
	ldaA	#$FF

LCB58:	cmpA	L85EA
	bcc	LCB60
	ldaA	L85EA 	; if (A < 0x10) then A = 0x10

LCB60:	cmpA	#$40
	bls	LCB66
	ldaA	#$40	; if (A >= 0x40) then A = 40

LCB66:	staA	L013A

	ldaA	L013A
	ldX	#L85FA
	call	LOOKUP1DBY16
	staA	L012D

	ldaA	L013A
	ldX	#L85FF
	call	LOOKUP1DBY16
	staA	L012E

	ldaA	L013A
	ldX	#L8604
	call	LOOKUP1DBY16
	staA	L012C

	ldaA	L013A
	ldX	#L8609
	call	LOOKUP1DBY16
	staA	L0133

	ldaA	L013A
	ldX	#L860E
	call	LOOKUP1DBY16
	staA	L012F

	ldaA	L013A
	ldX	#L8613
	call	LOOKUP1DBY16
	staA	L0130  
	;
	; Read ADC #10 & #48, the ADLO2 and ADRO2 values
	;
	ldX	#IOREG4000	; X = 0x4000
	ldaA	#L02AtoD            ; A = ADC #10
	di			; Disable Interrupts	
	bclr	IOPORTA, X,#SPI_ADC	; Enable SPI ADC
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X 
	staA	SPI_JUNK
	mul	
	mul
		
	ldaA	#RO2AtoD
	ldaB	KAFOPT1 		; KAFOPT1 = 0x06
	bitB	#KAFOPT1_SINGLE_O2
	beq	LCBD6		; This jump always taken
	ldaA	#L02AtoD
	
LCBD6:	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staA	ADLO2
	nop	
	mul	
	mul	
	ldaA	#ENDAtoD
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staA	ADRO2
	bset	IOPORTA,X,#SPI_ADC	; Disable SPI ADC
	ei	                    ; Enable Interrupts
	
	ldaA	ADLO2
	ldX	ADLO2FILT
	ldaB	KADO2AF
	call	LAGFILTER
	stD	ADLO2FILT
	
	ldX	ADRO2FILT
	ldaA	ADRO2
	ldaB	KADO2AF
	call	LAGFILTER
	stD	ADRO2FILT
	
	ldX	ADLO2AFSC
	ldaA	ADLO2
	ldaB	L012F
	call	LAGFILTER
	stD	ADLO2AFSC
	
	ldX	ADRO2AFSC
	ldaA	ADRO2
	ldaB	L012F
	call	LAGFILTER
	stD	ADRO2AFSC

	ldD	KO2MAXMIN	; A:B = 0x6C:0x5F
	cmpA	ADLO2
	bcs	LCC46     ; if (ADLO2 > 0x6C) goto LCC46
	
	cmpB	ADLO2
	bls	LCC4C	; if (ADLO2 < 0x5F) goto LCC4C

LCC46:	clr	L0125
	bset	LHFLMW,#LHFLMW_RDY
	
LCC4C:	bclr	LHFLMW,#LHFLMW_RICH
	ldaA	ADLO2
	cmpA	L012C
	bls	LCC5A
	bset	LHFLMW,#LHFLMW_RICH

LCC5A:	brset	LHFLMW, #%00000110, LCC68
	brclr	LHFLMW, #%00000110, LCC68
	bset	LHFLMW, #%00100000
	inc	L012B 
	
LCC68:	ldD	KO2MAXMIN	; A:B = 0x6C:0x5F
	cmpA	ADRO2
	bcs	LCC75     ; if (ADRO2 > 0x6C) goto LCC75
	
	cmpB	ADRO2
	bls	LCC7B     ; if (ADRO2 < 0x5F) goto LCC7B

LCC75:	clr	L0124
	bset	RHFLMW,#RHFLMW_RDY
	
LCC7B:	bclr	RHFLMW, #RHFLMW_RICH
	ldaA	ADRO2
	cmpA	L012C
	bls	LCC89
	bset	RHFLMW, #RHFLMW_RICH
	
LCC89:	brset	RHFLMW, #%00000110, LCC97
	brclr	RHFLMW, #%00000110, LCC97
	bset	RHFLMW, #%00100000
	inc	L012A
	
LCC97:	ldaA	LHFLMW
	andA	#%11111011
	bitA	#LHFLMW_RICH
	beq	LCCA1
	oraA	#%00000100
LCCA1:	staA	LHFLMW

	ldaA	RHFLMW
	andA	#%11111011
	bitA	#RHFLMW_RICH
	beq	LCCAD
	oraA	#%00000100
LCCAD:	staA	RHFLMW

	brclr	ALDLMW,#ALDLMW_STARTMD4,LCCC0
	ldX	#ALDLMDEW
	brclr	0,X,#ALDLMDEW_FCL,LCCC0
	brset	1,X,#ALDLMDST_FCL,LCCFF
	jr	LCCDF
;
LCCC0:	brclr	MWFA1, #%10000000, LCCDF
	brclr	L005F, #%00100010, LCCCA
	jr	LCCDF
;
LCCCA:	brclr	L005F, #%10000000, LCCDA
	bclr	L005F, #%10000000
	ldaA	KAFOPT3
	bitA	#%00000010
	beq	LCCFF
	jr	LCCDF
;
LCCDA:	ldaA	L01D6
	beq	LCCFF
LCCDF:	ldD	#$8000
	stD	LINT
	stD	RINT
	stD	L00F0
	stD	L00EE
	staB	L0127
	staB	L0126
	staB	L0122
	staB	L0120
	bclr	L005F, #%00000100
	bset	DIAGMW3,DIAGMW3_INTRST
	jmp	LCE81
;
LCCFF:	ldaA	ADLO2AFSC
	subA	L012E
	bhi	LCD14	; if (ADLO2AFSC > L012E) goto LCD14
	
	ldaA	L012D
	subA	ADLO2AFSC
	bhi	LCD1F	; if (L012E > ADLO2AFSC) goto LCD1F

	clr	L0138
	jr	LCD2B
;
LCD14:	bset	LHFLMW, #%01000000
	ldaB	L85EC	; = 0xFF
	mul	
	adcA	#$00
	jr	LCD22
;
LCD1F:	bclr	LHFLMW, #%01000000
LCD22:	cmpA	#$58
	bls	LCD28
	ldaA	#$58
LCD28:	staA	L0138

LCD2B:	ldaA	L0138
	lslA	
	ldX	#L8618
	call	LOOKUP1DBY16
	staA	L0131

	ldaB	L0130
	mul	
	adcA	#$00
	ldaB	L85ED	; = 0xFF
	mul	
	stD	L0122
	
	ldaA	L0138
	cmpA	L85EB	; = 0x01
	bcs	LCD55	; if (L0138 < 0x01) goto LCD55
	
	brset	LHFLMW, #%01000010, LCD5A
	brclr	LHFLMW, #%01000010, LCD5A
LCD55:	clr	L0127
	jr	LCDA6
;
LCD5A:	lslA	
	ldX	#L8624	; This table is all 0x20's, so...
	call	LOOKUP1DBY16
	staA	L0134	; L0134 = A = 0x20
	
	ldaB	L0133
	mul	
	adcA	#$00
	staA	L0137
	
	cmpA	L0127
	bls	LCD77
	
	inc	L0127
	jr	LCDA6
;
LCD77:	clr	L0127

	ldD	LINT
	brclr	LHFLMW, #%01000000, LCD93
;
	subD	KO2INTDEC	; LINT = LINT - 0x00C8
	bcc	LCD88
	ldD	#$0000	; if (LINT < 0) then LINT = 0x0000
;	
LCD88:	cmpD	KO2INTMIN	; = 0x4000
	bcc	LCDA4
	ldD	KO2INTMIN	; if (LINT < KO2INTMIN) then LINT = KO2INTMIN
	jr	LCDA4
;
LCD93:	addd	KO2INTINC	; LINT = LINT + 0x00F0
	bcc	LCD9B
	ldD	#$FFFF	; if (LINT > 0xFFFF) then LINT = 0xFFFF
	
LCD9B:	cmpD	KO2INTMAX	; = 0xC000
	bls	LCDA4
	ldD	KO2INTMAX	; if (LINT > KO2INTMAX) then LINT = KO2INTMAX
;	
LCDA4:	stD	LINT	; Store the new LINT Value
;
LCDA6:	ldD	LINT
	brclr	LHFLMW, #LHFLMW_RICH, LCDB6
	subD	L0122
	bcc	LCDBE
	ldD	#$0000
	jr	LCDBE
;
LCDB6:	addd	L0122
	bcc	LCDBE
	ldD	#$FFFF
LCDBE:	stD	L00F0

	ldaA	ADRO2AFSC
	subA	L012E
	bhi	LCDD5

	ldaA	L012D
	subA	ADRO2AFSC
	bhi	LCDE0

	clr	L0139
	jr	LCDEC
;
LCDD5:	bset	RHFLMW, #%01000000
	ldaB	L85EC	; = 0xFF
	mul	
	adcA	#$00
	jr	LCDE3
;
LCDE0:	bclr	RHFLMW, #%01000000
LCDE3:	cmpA	#$58
	bls	LCDE9
	ldaA	#$58
LCDE9:	staA	L0139

LCDEC:	ldaA	L0139
	lslA	
	ldX	#L8618
	call	LOOKUP1DBY16
	staA	L0132

	ldaB	L0130
	mul	
	adcA	#$00
	ldaB	L85ED	; = 0xFF
	mul	
	stD	L0120
	
	ldaA	L0139
	cmpA	L85EB	; = 0x01
	bcs	LCE16	; if (L0138 < 0x01) goto LCE16
	
	brset	RHFLMW, #%01000010, LCE1B
	brclr	RHFLMW, #%01000010, LCE1B
LCE16:	clr	L0126
	jr	LCE67
;
LCE1B:	lslA	
	ldX	#L8624	; This table is all 0x20's, so...
	call	LOOKUP1DBY16
	staA	L0135	; L0135 = A = 0x20
	
	ldaB	L0133
	mul	
	adcA	#$00
	staA	L0136
	cmpA	L0126
	bls	LCE38
	inc	L0126
	jr	LCE67
;
LCE38:	clr	L0126
;
	ldD	RINT
	brclr	RHFLMW, #%01000000, LCE54
;
	subD	KO2INTDEC	; RINT = RINT - 0x00C8
	bcc	LCE49
	ldD	#$0000	; if (RINT < 0) then RINT = 0x0000
;	
LCE49:	cmpD	KO2INTMIN	; = 0x4000
	bcc	LCE65
	ldD	KO2INTMIN	; if (RINT < KO2INTMIN) then RINT = KO2INTMIN
	jr	LCE65
;
LCE54:	addd	KO2INTINC	; RINT = RINT + 0x00F0
	bcc	LCE5C
	ldD	#$FFFF	; if (RINT > 0xFFFF) then RINT = 0xFFFF
;	
LCE5C:	cmpD	KO2INTMAX	; = 0xC000
	bls	LCE65
	ldD	KO2INTMAX	; if (RINT > KO2INTMIN) then RINT = KO2INTMIN
;	
LCE65:	stD	RINT	; Store the new RINT Value	
;
LCE67:	ldD	RINT
	brclr	RHFLMW, #RHFLMW_RICH, LCE77
	subD	L0120
	bcc	LCE7F
	ldD	#$0000
	jr	LCE7F
;
LCE77:	addd	L0120
	bcc	LCE7F
	ldD	#$FFFF
LCE7F:	stD	L00EE

LCE81:	bclr	L005F, #%00000001
	brclr	NVRAMWD2, #NVRAMWD2_FPUMP, LCEE7
	brset	VBATMW,VBATMW_VLOW, LCEE7
	brset	L005F, #%00000010, LCEE7

	ldaA	KOVBSTMAPON
	brclr	WGATEMW,#WGATEMW_OVBSTTM,LCE9A
	ldaA	KOVBSTMAPOF
	
LCE9A:	cmpA	NMAP0
	bcc	LCEBA	; if (NMAP0 < KOVBSTMAPON/OFF) goto LCEBA

	ldD	OVBSTTM
	cmpD	KOVBSTTM	; = 0x00A0
	bcc	LCEAF	; if (OVBSTTM > KOVBSTTM) goto LCEAF
	
	addd	#$0001	; else (OVBSTTM++)
	stD	OVBSTTM
	jr	LCEC0
;
LCEAF:	bset	WGATEMW,#WGATEMW_OVBSTTM
	bset	DIAGMW5,#DIAGMW5_OVBSTTM
	clr	M33CNT
	jr	LCEE7
;
LCEBA:	ldD	#$0000	; (NMAP0 < KOVBSTMAPON/OFF) , so...
	stD	OVBSTTM	; (OVBSTTM = 0)
;	
LCEC0:	bclr	WGATEMW,#WGATEMW_OVBSTTM
;
	ldX	#L8557
	ldaA	MPH
	brclr	L005F, #%01000000, LCED0
	ldX	#L855C

LCED0:	cmpA	0, X
	bhi	LCEE4

	ldD	NTREV65
	brclr	FMDSDI, #%00000100, LCEDF
	cmpD	1, X
	jr	LCEE2
;
LCEDF:	cmpD	3, X
LCEE2:	bcc	LCF08
LCEE4:	bset	L005F, #%01000000

LCEE7:	bset	L005F, #%00000001
	ldD	#$0001
	ldX	#$0000
	staA	L01D5
	stX	L007C
	stX	L007E
	stX	L0080
	stX	LBPINJ1
	stD	LBPINJ	; = 0x0001
	stX	L0086
	stX	L0088
	stX	RBPINJ1	; = 0x0000
	stD	RBPINJ    ; = 0x0001
	jmp	LD233
;
LCF08:	brclr	L005F, #%01000000, LCF24
	bclr	L005F, #%01000000
	brset	SPARKADV, #%10000000, LCF24

	ldX	#SPARKADV
	ldaA	L831B	; ugg - this is zero
	call	MULT8BY16
	stD	L00C6
	
	bset	MW3, #%00100000
	bset	MWFA1, #%00010000  
	
LCF24:	ldaA	NMPH
	cmpA	L85E5
	bls	LCF62	; if (NMPH < 15 MPH) goto LCF62

	ldaA	NMAP0
	cmpA	L8AAE
	bcc	LCF62

	ldD	NMAP2
	subD	NMAP0
	bls	LCF62
	
	ldX	#$0666	; = 6.398
	fdiv	
	pushX	
	
	ldaB	NTREV65LSB
	ldaA	L8AAD
	mul	
	pushB	
	pushA	
	ldaB	NTREV65
	ldaA	L8AAD
	mul	
	tBA	
	clrB	
	tSX	
	addD	0, X
	bcc	LCF57
	ldD	#$FFFF

LCF57:	popX	
	popX	
	call	LEEB1
	cmpD	L8AAB
	bhi	LCF65
LCF62:	ldD	#$0000
LCF65:	stD	L0103
	ldD	NMAP0
	subD	L0103
	bcc	LCF72
	ldD	#$0F00
LCF72:	ldX	NMAP0
	fdiv	
	pushX	
	popA	
	incS	
	pushA	

	ldaB	MAP1N
	mul	
	adcA	#$00
	staA	L0105

	popA	
	ldaB	ADMAPN2
	mul	
	adcA	#$00
	staA	L0107
;	
	ldaB	L0107
	cmpB	#$70
	bcc	LCFC6
;	
	ldaB	L0105
	ldaA	NTRPMX
	cmpA	#$50
	bcc	LCFAB	; if (NTRPMX >= 2000 RPM) goto LCFAB
;	
	ldX	#L8B63
	ldY	L8B61	; Y = 0x0000
	subA	#$10	; A = (NTRPMX - 0x10) = NTRPMX-400
	bcc	LCFA7
	clrA                ; if (A < 0) then A = 0
LCFA7:	lslA	
	lslA		; A = (NTRPMX - 0x10) << 2	
	jr	LCFCF
;
; We get here if RPM >= 2000
;
LCFAB:	ldX	#L8C89
	ldY	L8C87	; Y = 0x0000
	ldaA	RPM	; A = RPM
	subA	#$80	; A = (RPM - 0x80) = RPM - 2000
	cmpA	#$60
	bls	LCFCF	; if (2000 <= RPM < 3500) goto LCFCF
;
; We get here if RPM >= 3500
;
	ldaA	RPM8000	; A = RPM8000
	subA	#$20	; A = (RPM8000 - 0x20) = RPM - 1000
	cmpA	#$C0
	bls	LCFCF
	ldaA	#$C0	; if (A > 0xC0) then A = 0xC0
	jr	LCFCF
;
LCFC6:	ldX	#L8AB4
	ldY	L8AB2	; Y = 0x0000
	ldaA	RPM8000
;
LCFCF:	call	LOOKUP3D
;
	brclr	VBATMW,#VBATMW_HUD,LCFD9
	call	L580C

LCFD9:	tAB	
	clrA	
	lslD	
	stD	L00A0
	pushY	
	tSX	
	addD	0, X
	brclr	MW1,#MW1_ECPVSHUT,LCFF1
	pushB	
	pushA	
	tSX	
	ldaA	L8AAF
	call	MULT8BY16
	popX	
LCFF1:	bpl	LCFF6
	ldD	#$0000
LCFF6:	stD	L00A2
	popX	
	ldD	NMAP0
	subD	L0103
	bcc	LD003
	ldD	#$0F00
	
LD003:	ldX	AIR_DENSITY
	call	MULT16BY16
	stD	L009E

	ldX	L00A2
	call	MULT16BY16
	stD	L0078

	ldD	L0078
	ldX	NTREV65
	idiv	
	pushX	
	ldX	NTREV65
	fdiv	
	pushX	
	popB	
	incS	
	popA	
	tstA	
	popA	
	bne	LD026
	lslD	
	bcc	LD029
LD026:	ldD	#$FFFF
LD029:	stD	L00A4

	ldD	L0078
	ldX	FA_RATIO
	call	MULT16BY16

	ldX	L8585
	call	LEEB1
	rolB	
	rolA	
	stD	L007A
	brset	L005F, #%10000000, LD04A
	ldaA	L01D6
	beq	LD047
	decA	
LD047:	staA	L01D6

LD04A:	ldaA	NTPSLD
	subA	NTPSLDFILT
	ldaB	L01C9
	bne	LD05E

	bcs	LD0A6

	cmpA	L8669
	bls	LD0A6
	jr	LD065
;
LD05E:	bcs	LD082
	cmpA	L01C8
	bls	LD08D
LD065:	staA	L01C8
	ldX	#$866E
	call	LOOKUP1DBY16
	ldaB	L01CC
	mul	
	lslD	
	bcc	LD077
	ldaA	#$FF
LD077:	ldaB	L01CE
	mul	
	lslD	
	bcc	LD09D
	ldaA	#$FF
	jr	LD09D
;
LD082:	negA	
	cmpA	L866A
	bcs	LD08D
	clr	L01C9
	jr	LD0A6
;
LD08D:	ldaA	L01CB
	beq	LD097
	dec	L01CB
	jr	LD0A6
;
LD097:	ldaA	L01C9
	ldaB	#$A2
	mul	
LD09D:	staA	L01C9
	ldaA	L01CA
	staA	L01CB
LD0A6:	bclr	MW2, #%00000001
	ldaA	L01C9
	beq	LD0B1
	bset	MW2, #%00000001
LD0B1:	ldaA	MAP1N
	subA	FILTL01D0
	ldaB	L01D3
	bne	LD0C4
	bcs	LD117
	cmpA	L866C
	bls	LD117
	jr	LD0CB
;
LD0C4:	bcs	LD0ED
	cmpA	L01D2
	bls	LD0FE
LD0CB:	staA	L01D2
	lslA	
	bcc	LD0D3
	ldaA	#$FF
LD0D3:	ldX	#$86D4
	call	LOOKUP1DBY16
	ldaB	L01CD
	mul	
	lslD	
	bcc	LD0E2
	ldaA	#$FF
LD0E2:	ldaB	L01CF
	mul	
	lslD	
	bcc	LD10E
	ldaA	#$FF
	jr	LD10E
;
LD0ED:	negA	
	staA	L01D2
	cmpA	L866D
	bcs	LD0FE
	clr	L01D3
	clr	L01D2
	jr	LD117
;
LD0FE:	ldaA	L01D4
	beq	LD108
	dec	L01D4
	jr	LD117
;
LD108:	ldaA	L01D3
	ldaB	#$A2
	mul	
LD10E:	staA	L01D3
	ldaA	L01CA
	staA	L01D4
LD117:	bclr	MW2, #%00000010
	ldaA	L01D3
	beq	LD122
	bset	MW2, #%00000010
LD122:	bclr	L005F, #%10000000
	ldaA	L01D3
	addA	L01C9
	staA	L01D5
	beq	LD144
	bset	L005F, #%10000000
	ldaA	L01D2
	ldX	#L8635
	call	LOOKUP1DBY16
	cmpA	L01D6
	bcs	LD144
	staA	L01D6
LD144:	ldaA	L01D5
	ldX	#$007A
	call	MULT8BY16
	pushB	
	pushA	
	tSX	
	lslD	
	addD	0, X
	popX	
	bcs	LD15A
	addD	L007A
	bcc	LD15D
LD15A:	ldD	#$FFFF
LD15D:	stD	L007C

	ldX	#$007C
	ldaA	FBLM
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	lslD	
	bcc	LD17B
	ldD	#$FFFF
LD17B:	stD	L007E 

	ldX	#$007C
	ldaA	RBLM
	pushA	
	ldaB	1, X
	mul	
	adcA	#$00
	popB	
	pushA	
	ldaA	0, X
	mul	
	tSX	
	addB	0, X
	adcA	#$00
	incS	
	lslD	
	bcc	LD199
	ldD	#$FFFF
LD199:	stD	L0086

	addB	L00EE
	adcA	#$00
	subD	#$0080
	bcc	LD1A7
	ldD	#$0000	; if ((A:B) < 0x0080) then (A:B) = 0
LD1A7:	stD	L0088

	ldD	L007E
	addB	L00F0
	adcA	#$00
	subD	#$0080
	bcc	LD1B7
	ldD	#$0000	; if ((A:B) < 0x0080) then (A:B) = 0
LD1B7:	stD	L0080

	ldX	L0080
	cmpX	#$00A0
	bhi	LD1DD
	pushX	
	incS	
	popB	
	subB	#$60
	bcc	LD1C8
	clrB	
LD1C8:	lsrB	
	lsrB	
	ldX	#L8572
	aBX	
	ldaB	0, X
	
	ldX	L0080
	aBX
		
	cmpX	MINBPINJ	; Make sure BPINJ is not less than MINBPINJ
	bhi	LD1E5
	ldX	DEFBPINJ
	jr	LD1E5
;
LD1DD:	cmpX	#$3FFF
	bls	LD1E5
	ldX	#$3FFF	; if (newLBPINJ > 0x3FFF) newLBPINJ = 0x3FFF

LD1E5:	stX	LBPINJ1

	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction
		
	cmpX	#$3FFF
	bls	LD1F4
	ldX	#$3FFF	; if (newLBPINJ > 0x3FFF) newLBPINJ = 0x3FFF

LD1F4:	stX	LBPINJ	; store the final LBPINJ

	ldX	L0088
	cmpX	#$00A0
	bhi	LD21A	; if (L0088 > 0x00A0) goto LD21A
	
	pushX	
	incS	
	popB	
	subB	#$60
	bcc	LD205
	clrB	

LD205:	lsrB	
	lsrB	
	ldX	#L8572
	aBX	
	ldaB	0, X

	ldX	L0088
	aBX	                                                     
	
	cmpX	MINBPINJ	; Make sure BPINJ is not less than MINBPINJ
	bhi	LD222
	ldX	DEFBPINJ
	jr	LD222
;
LD21A:	cmpX	#$3FFF
	bls	LD222
	ldX	#$3FFF	; if (newRBPINJ > 0x3FFF) newRBPINJ = 0x3FFF

LD222:	stX	RBPINJ1     

	ldaB	F33BVC
	aBX	
	aBX		; Add on double the Battery Voltage Correction	
	
	cmpX	#$3FFF
	bls	LD231
	ldX	#$3FFF	; if (newRBPINJ > 0x3FFF) newRBPINJ = 0x3FFF 
	
LD231:	stX	RBPINJ	; store the final RBPINJ

LD233:	brclr	TIMER_TICK, #%00000010, LD23A
	jmp	LD559
;
; This section of code is executed every 12.5uS. It deals with the
; calculation of the Turbo Wastegate Solenoid Duty Cycle
;
LD23A:	brset	WGATEMW,#WGATEMW_ENABLE,LD250

	bclr	WGATEMW, #%00001010 ; clear WGATEMW_LAUNCH &&
	bclr	L0065, #%00000011
	ldX	#$0000
	stX	TBOTIME		; TBOTIME = 0x0000
	ldaA	L8859		; WGATEDC = 0x00
	jmp	LD47C
;
LD250:	brset	WGATEMW,#WGATEMW_LAUNCH,LD26C
	ldaA	NTRPMX
	cmpA	MINTBORPM		; MINTBORPM = 0x6C = 2700 RPM
	bls	LD28B		; if (RPM < MINTBORPM) goto LD28B
	
	brset	L0067,#L0067_TC24,LD28B ; make sure the VSS sensor is working
	ldaA	MPH
	cmpA	MINTBOMPH 	; MINTBOMPH = 0x02 = 2 MPH
	bcc	LD28B		; if (MPH >= 2 MPH) goto LD28B
	
; We get here if (RPM >= MINTBORPM) && (MPH < 2 MPH) - Get ready for lift off !!
	bset	WGATEMW,#WGATEMW_LAUNCH
	jr	LD28B
;
LD26C:	ldX	TBOTIME
	cmpX	MAXTBOTIME	; MAXTBOTIME = 0x320 = 800 = 10 Sec
	bhi	LD282		; if (TBOTIME > 10 Sec) goto LD282
	
	ldaA	MPH
	cmpA	MAXTBOMPH		; MAXTBOMPH = 0x87 = 135 MPH
	bhi	LD282		; if (MPH > 135) goto LD282 !!!!
				; How the hell do we get to 135MPH in 10 Seconds ??

; We get here if ((TBOTIME < 10 Sec) && (MPH < 135))
	incX	
	stX	TBOTIME		; TBOTIME++
	jr	LD28B
;
; Clear the launch detection after 10 seconds or once MPH > 135
;
LD282:	bclr	WGATEMW,#WGATEMW_LAUNCH
	ldX	#$0000
	stX	TBOTIME		; Reset the TBOTIME counter  
;	
; Check for knock detection before allowing turbo boost
;
LD28B:	ldaA	L884A		; = 0x10
	brclr	WGATEMW,#WGATEMW_NOCK,LD295
	ldaA	L884B		; = 0x08
LD295:	cmpA	NOCKRTD
	bhi	LD2D1		; if (NOCKRTD < L884A/L884B) goto LD2D2
;
; We get here if the current NOCKRTD is greater than the L884A/L884B limits
; Time the duration, and if the duration is excessive, limit future turbo boost
;	
	ldaA	WGATE_NOCKT
	cmpA	L884C		; = 0x32 = 50 = 0.625 Sec
	bcc	LD2A6     	; if (WGATE_NOCKT >= 0.625 Sec) goto LD2A6
	inc	WGATE_NOCKT     	; else [WGATE_NOCKT]++
	jr	LD2FC     	; goto LD2FC
;
; We get here if the KS has been active (NOCKRTD > L884A/L884B)
; for more than L884C Counts (0.625 Sec). If this happens, limit the 
; amount of boost to be used in the future by setting MW1_MV10MIN
;
LD2A6:	bset	WGATEMW,#WGATEMW_NOCK
	bset	MW1,    #MW1_MV10MIN
	clr	L019B
	ldaA	L019A
	cmpA	L884D	; = 0x04
	bcc	LD2C2
	
	brclr	TIMER_TICK, #%00001100, LD2BD
	jr	LD2FC
;
LD2BD:	inc	L019A
	jr	LD2FC
;
LD2C2:	clr	L019A
	ldaA	L01A0
	addA	L884F	; = 0x10
	bcc	LD2F9
	ldaA	#$FF
	jr	LD2F9
;
LD2D1:	bclr	WGATEMW,#WGATEMW_NOCK
	clr	WGATE_NOCKT
	clr	L019A
	ldaA	L019B
	cmpA	L884E	; = 0x01
	bcc	LD2ED
	brclr	TIMER_TICK, #%00001100, LD2E8
	jr	LD2FC
;
LD2E8:	inc	L019B
	jr	LD2FC
;
LD2ED:	clr	L019B
	ldaA	L01A0
	subA	L8850	; = 0x02
	bcc	LD2F9
	clrA	
LD2F9:	staA	L01A0
;
LD2FC:	bclr	WGATEMW, #%00001000
;
	brset	WGATEMW,WGATEMW_TC66,LD307
;
	brclr	DIAGMW5,DIAGMW5_TC16,LD31C
;
; Clear the Turbo WGATEBLM table
;
LD307:	ldD	#$0000
	stD	WGBLMTABLE
	stD	WGBLMTABLE2
	stD	WGBLMTABLE4
	stD	WGBLMTABLE6
	stD	WGBLMTABLE8
	stD	WGBLMTABLEA
	stD	WGBLMTABLEC
	stD	WGBLMTABLEE
	jr	LD330
;
LD31C:	brset	WGATEMW,#WGATEMW_LAUNCH,LD330
	ldaA	L01A0
	bne	LD330
;
	ldaA	MPH
	cmpA	L885B	; L885B = 0xFF = 255 MPH
	bhi	LD330	; if (MPH > 255) goto LD330
;
	bset	WGATEMW, #%00001000
;
LD330:	ldaA	NTRPMX
	cmpA	#$A0	; 0xA0 = 4000 RPM
	bls	LD342	; if (NTRPMX < 4000 RPM) goto LD342
;
	ldaA	RPM8000
	cmpA	#$E0
	bhi	LD340
	addA	#$20
	bcc	LD342
LD340:	ldaA	#$FF	; A = (RPM8000+0x20) limited to 255
;
; if (NTRPMX < 4000)
;   A = NTRPMX
; else
;   A = RPM8000+0x20
;
LD342:	ldaB	NTPSLD
	lsrB		; B = NTPSLD / 2	
	ldX	#L8883
	call	LOOKUP3D
	staA	L0196	; L0196 = fnL8883(NTPSLD,RPM)

	beq	LD355 
	cmpA	#$FF
	bne	LD358
LD355:	jmp	LD479	; if fnL8883(NTPSLD,RPM) == (0 or 0xFF) goto LD479
;
LD358:	brclr	CLCCMW, #%00100000, LD371
;
	ldaB	L885A	; = 0x00
	ldX	#KAFOPT2	; = 0x0F
	brset	0,X,#%00001000,LD36C ; This jump always taken
	
	sBA	     	; A = fnL8883(NTPSLD,RPM) - L885A
	bcc	LD371
	clrA	
	jr	LD371     ; if (A < 0) then A = 0
;
LD36C:	aBA	    	; A = fnL8883(NTPSLD,RPM) + L885A
	bcc	LD371
	ldaA	#$FF	; if (A > 0xFF) then A = 0xFF

LD371:	clrB	
	pushA		; save fnL8883(NTPSLD,RPM) on the stack
		
	ldaA	MPH
	subA	L885B	; L885B = 0xFF = 255 MPH
	bcs	LD382	; if (MPH < 255) goto LD382 always !!!
	                    ; A = (MPH - L885B) = 0
	ldaB	L885C	; B = 0xE0
	mul		; A:B = 0x0000	
	adcA	#$00
	tAB		; B = 0x00
		
LD382:	popA		; get fnL8883(NTPSLD,RPM) from the stack	
	sBA		; B = 0	
	bcc	LD387
	clrA		; if (A < 0) then A = 0	
;
LD387:	subA	L01A0
	bcc	LD390
	clrA	
	jmp	LD479
;
LD390:	cmpA	#$FF
	bne	LD397
	jmp	LD479
;
LD397:	staA	fnL8883
;
; Adjust fnL8883 for the current Atmospheric (NBARO) pressure
;
	ldaA	NBARO
	cmpA	#$68
	bls	LD3A3
	ldaA	#$68	; A = min(NBARO,0x68)
;	
LD3A3:	subA	#$40	; A = min(NBARO,0x68) - 0x40
	bcc	LD3A8
	clrA	    	; A = max((min(NBARO,0x68)-0x40),0)
;
LD3A8:	lslA		; A = max((min(NBARO,0x68)-0x40),0) << 1
	ldX	#$891F
	call	LOOKUP1DBY16
;	
	subA	#$80	; 0x80 = 1 Bar Atmospheric ?
	bcc	LD3BE 	; if (BARO > 1Bar) add it to fnL8883 
;	
	negA		; A = |(fnL891F - 0x80)|	
	tAB		; B = |(fnL891F - 0x80)|	
	ldaA	fnL8883	; A = fnL8883
	sBA		; A = fnL8883 - |(fnL891F - 0x80)|	
	bcc	LD3C5
	clrA	     	; if (A < 0) then A = 0
	jr	LD3C5	; WGATE_BLMDC = fnL8883 - |(fnL891F - 0x80)|
;
LD3BE:	addA	fnL8883
	bcc	LD3C5
	ldaA	#$FF 	; WGATE_BLMDC = fnL8883 + |(fnL891F - 0x80)|
;
LD3C5:	staA	WGATE_BLMDC
;
	brclr	WGATEMW,#WGATEMW_LAUNCH,LD3CF
	jmp	LD46B
;
;We get here if WGATEMW_LAUNCH is clear
;
LD3CF:	ldX	#WGBLMTABLE
	ldaB	RPM8000
	lsrB	
	lsrB	
	lsrB	
	lsrB	
	staB	WGBLMCELL
	cmpB	WGBLMCELL1
	beq	LD3EC		; if cell is unchanged, goto LD3EC
	
	bset	L0065,#L0065_WGNEWCELL ; flag a new WGBLMCELL being used
	staB	WGBLMCELL1	; save the new WGBLMCELL for next time

	ldaA	L885F		; 0x01
	staA	WGBLMCELLCT

LD3EC:	aBX			; Index into the WGBLMTABLE	
	ldaA	0, X		; Pick up the BLM value
	ldY	#KAFOPT1 		; KAFOPT1 = 0x06
	brclr	0,Y,#%00000010,LD452 ; This jump never taken
	
	brset	L0065, #%00000010, LD402

	bset	L0065, #%00000010
	bclr	L0065,#L0065_WGNEWCELL

LD402:	brclr	L0065,#L0065_WGNEWCELL,LD452
	ldaB	WGBLMCELLCT
	beq	LD410
	dec	WGBLMCELLCT
	jr	LD44F
;
LD410:	cmpA	WGATEBLM
	beq	LD452	; if WGATEBLM value unchanged, goto LD452

	blt	LD430	; if (newWGATEBLM < currentWGATEBLM) goto LD430
;
; newWGATEBLM > currentWGATEBLM, so oldWGATEBLM += 0x0C
; WGATEBLM is signed, -0x80..+0x7F
;	
	ldaA	WGATEBLM	; A = signed WGATEBLM (-0x80..+0x7F)
	addA	#$80	; A = unsigned WGATEBLM (0x00..0xFF)
	addA	L885D	; A = unsigned WGATEBLM + 0x0C
	bcc	LD423
	ldaA	#$FF      ; if (A > 255) then A = 255
LD423:	subA	#$80      ; A = signed WGATEBLM + 0x0C

	cmpA	0, X	; compare with the BLMTABLE
	blt	LD446	; if (A < BLMTABLE) goto LD446
	ldaA	0, X      ; else A = BLMTABLE
	bclr	L0065,#L0065_WGNEWCELL
	jr	LD446
;
; newWGATEBLM < currentWGATEBLM, so oldWGATEBLM -= 0x0C
; WGATEBLM is signed, -0x80..+0x7F
;	
LD430:	ldaA	WGATEBLM	; A = signed WGATEBLM (-0x80..+0x7F)
	addA	#$80	; A = unsigned WGATEBLM (0x00..0xFF)
	subA	L885E	; A = unsigned WGATEBLM - 0x0C
	bcc	LD43B
	clrA	          ; if (A < 0) then A = 0
LD43B:	subA	#$80      ; A = signed WGATEBLM - 0x0C

	cmpA	0, X	; compare with the BLMTABLE
	bgt	LD446	; if (A > BLMTABLE) goto LD446
	ldaA	0, X      ; else A = BLMTABLE
	bclr	L0065,#L0065_WGNEWCELL
;	
LD446:	staA	WGATEBLM
	ldaB	L885F	; 0x01
	staB	WGBLMCELLCT
;
LD44F:	ldaA	WGATEBLM
;
LD452:	staA	WGATEBLM
	bpl	LD462	; if (WGATEBLM is +ve) goto LD462
;
; WGATEBLM is -ve, so subtract WGATEBLM from WGATE_BLMDC
;	
	negA		; WGATEBLM is -ve, make it +ve	
	tAB	
	ldaA	WGATE_BLMDC
	sBA		; A = WGATE_BLMDC - WGATEBLM	
	bcc	LD47C
	clrA	          ; if (A < 0) then A = 0
	jr	LD47C     ; WGATEDC = WGATE_BLMDC - WGATEBLM
;
; WGATEBLM is +ve, so add WGATEBLM to WGATE_BLMDC
;	
LD462:	addA	WGATE_BLMDC ; A = WGATE_BLMDC + WGATEBLM
	bcc	LD47C
	ldaA	#$FF
	jr	LD47C	; if (A > 255) then A = 255
;
;We get here if WGATEMW_LAUNCH is set, meaning high RPM and zero MPH for 
;up to 10 seconds
; A = WGATE_BLMDC, derived from the WGATEBLM table
;
LD46B:	tAB		; B = WGATE_BLMDC

	ldaA	RPM8000
	ldX	#L8925
	call	LOOKUP1DBY16 ; A = EPROM WGATEDC value

	aBA		; Add the L8925 value to WGATE_BLMDC
		
	bcc	LD479
	ldaA	#$FF	; if (WGATEDC > 255) then WGATEDC = 255
;
LD479:	bclr	L0065, #%00000010
;
LD47C:	staA	WGATEDC

	brclr	TIMER_TICK, #%00001100, LD486
	jmp	LD559
;
; This section of code is executed every 50uS ?.
; This is the start of the Turbo WGATE BLM LEARN code 
;
LD486:	bclr	WGATEMW,#WGATEMW_BLMNEW
	bset	WGATEMW,#WGATEMW_ENABLE
	clr	MAPDELTADES
	
	brclr	FMD1, #%00001000, LD4AF
	
	ldaA	RPM8000
	cmpA	L883E	; = 0xE0 = 7000 RPM
	bhi	LD4AF	; if (RPM8000 > 7000) goto LD4AF
	
	brset	WGATEMW,#WGATEMW_OVBSTTM,LD4AF
	brset	LCCPMW, #%00000010, LD4AF
	
	ldaA	CTSFILT
	cmpA	L883F	; = 74.75 DegC
	bls	LD4AF	; if (CTSFILT < 74.75 DegC) goto LD4AF
	
	cmpA	L8840	; = 114.5 DegC
	bcs	LD4BA	; if (CTSFILT < 114.5 DegC) goto LD4BA
;
; Disable the wastegate solenoid.
;
LD4AF:	bclr	WGATEMW,#WGATEMW_ENABLE
	ldaA	#$FF
	staA	L01A0
	jmp	LD553	; Skip the Turbo BLM learn code
;
; We are happy with the CTS, RPM etc, so we can use the wastegate solenoid
;
LD4BA:	brset	CLCCMW, #%00100000, LD4D4 

	ldaA	NTPSLD
	cmpA	L8841	; = 94%
	bls	LD4D4	; if (NTPSLD < 94%) Skip the Turbo BLM learn code  
;
; We are happy with CTS & RPM, and we're giving it some TPS wellie
;
	ldaA	ADMAPN2
	subA	WGATEMAPN2
	bcc	LD4CF
	negA		; A = delta(ADMAPN2)
LD4CF:	cmpA	L8842	; = 0x02
	bcs	LD4D7	; if (delta(ADMAP2) < 2) goto LD4D7
;
; We are happy with CTS & RPM, and giving it some TPS wellie, 
; but MAP's changing, so we can't 'learn' TurboBLM corrections
;
LD4D4:	jmp	LD553	; Skip the Turbo BLM learn code
;
; We are happy with CTS & RPM, and giving it some TPS wellie, 
; MAP is stable, so we can 'learn' TurboBLM corrections
;
LD4D7:	brclr	WGATEMW, #%00001000, LD553
;
; WGATEBLM Learn.We may want to 'learn' new WGATEBLM values if we get here.
;	
	ldaA	NBARO
	cmpA	L8860	; = 0x50
	bcs	LD553	; if (NBARO < 0x50) Skip the Turbo BLM learn code
;	
	ldaA	RPM8000
	cmpA	L8843	; = 2312 RPM
	bcs	LD553	; if (RPM8000 < 2312) Skip the Turbo BLM learn code
;
; WGATEBLM Learn. Baro is OK, and (RPM > 2300) ish
;	
	ldX	#L8861	; If we've been moving less than 10 mins, use L8861
	brclr	MW1,#MW1_MV10MIN,LD4F4
	ldX	#L8872	; If we've been moving more than 10 mins, use L8872
;	
LD4F4:	ldaA	RPM8000
	call	LOOKUP1DBY16
	staA	MAPDES	; Store the desired MAP for this RPM
;
	subA	ADMAPN
	staA	MAPDELTADES ; Store the MAPDELTA for this RPM
	
	bcc	LD504	; if MAPDELTA is -ve
	negA		; get |MAPDELTA|	     
	
LD504:	cmpA	L8844	; 0x04 = 0.03125 Bar
	bls	LD553	; if  |MAPDELTA| < 0.03125 Bar, no need to tweak the BLM
;
; If we get here, we need to tweak the WGATEBLM table coz the MAP isn't what 
; it should be for this RPM. WGATEBLM is a sined 8 bit value.
;
; WGATEBLM values from 0x01-0x7F increase the DC to increase the boost
; WGATEBLM values from 0xFF-0x80 decrease the DC to decrease the boost
;	
	bset	WGATEMW,#WGATEMW_BLMNEW
	ldX	#WGBLMTABLE
	ldaB	RPM8000
	lsrB	
	lsrB	
	lsrB	
	lsrB	
	aBX		; Index into the WGATEBLM Table	
	ldaA	0, X	; A = Current WGATEBLMTABLE Value
;
	ldaB	MAPDELTADES ; -ve means MAP is too high, +ve means MAP is too low
	bpl	LD538	; if MAP is too low, goto LD538
;
; The MAP is too high, so adjust the BLM down a bit
;	
	subA	KKMAPBLMDN ; KKMAPBLMDN = 1
	bvc	LD524	; if (WGATEBLM < 0x80) goto LD524 (OK)
	ldaA	#$80	; default WGATEBLM to -50%
	
LD524:	cmpA	KKMAPBLMLO ; WGATEBLM = 0x81 = -49.6%
	bgt	LD551	 ; if (WGATEBLM > -49.6%) goto LD551 (OK)

	ldaA	KKMAPBLMLO ; default WGATEBLM to -49.6%

	ldaB	NTRPMX
	cmpB	KK66RPM	; KK66RPM = 0x6C = 2700 RPM
	bls	LD551	; if (RPM < 2700) goto D551 (OK)
;
	bset	WGATEMW,#WGATEMW_TC66 ; flag a TC66
	jr	LD551
;
; The MAP is too low, so adjust the BLM up a bit
;	
LD538:	addA	KKMAPBLMUP ; KKMAPBLMUP = 1
	bvc	LD53F	; if (WGATEBLM < 0x7F) goto LD524 (OK)
	ldaA	#$7F	; default WGATEBLM to +49.6%

LD53F:	cmpA	KKMAPBLMHI ; WGATEBLM = 0x7F = +49.6%
	blt	LD551	 ; if (WGATEBLM < +49.6%) goto LD551 (OK)

	ldaA	KKMAPBLMHI ; default WGATEBLM to +49.6%

	ldaB	NTRPMX
	cmpB	KK66RPM	; KK66RPM = 0x6C = 2700 RPM
	bls	LD551	; if (RPM < 2700) goto D551 (OK)

	bset	WGATEMW,#WGATEMW_TC66 ; flag a TC66

LD551:	staA	0, X	; Store the updated WGATEBLM value in the table
;
; End of Turbo BLM Learn Code
;
LD553:	ldaA	ADMAPN2
	staA	WGATEMAPN2 ; Store ADMAPN2 for use in 12.5uS time
;
; End of Turbo WGATEDC & BLM Learn Code
;
LD559:	brclr	TIMER_TICK, #%00000110, LD560
	jmp	LD62B
;
LD560:	brclr	MWFA1, #%00000010, LD568
	brclr	L005F, #%00001000, LD56B
LD568:	jmp	LD61E
;
LD56B:	ldaA	LINT
	cmpA	#$80
	beq	LD5C5	; if (LINT == 0x80) then LFuel is spot on, so skip this

	ldaB	LINTCNT
	incB	
	bne	LD578
	decB	
LD578:	staB	LINTCNT	; increment LINTCNT, limit to 0xFF

	cmpB	KBLMCNT
	bcs	LD5C5	; if (LINTCNT < KBLMCNT) goto LD5C5
	
	ldX	#FBLMTABLE
	ldaB	BLMCELL
	aBX	
	ldaA	0, X
	ldaB	LINT
	subB	#$80
	bcs	LD5A7
	cmpB	L8655
	bls	LD5C5
	brset	LHFLMW, #LHFLMW_RICH, LD5C5
	addA	L8652
	bcs	LD5A2
	cmpA	KBLMMAX	;  = 0xA0
	bls	LD5BE
LD5A2:	ldaA	KBLMMAX	;  = 0xA0
	jr	LD5BE
;
LD5A7:	negB	
	cmpB	L8656
	bls	LD5C5
	brclr	LHFLMW, #LHFLMW_RICH, LD5C5
	subA	L8652
	bcs	LD5BB
	cmpA	KBLMMIN    ;  = 0x5A
	bhi	LD5BE
LD5BB:	ldaA	KBLMMIN    ;  = 0x5A
LD5BE:	staA	0, X
	staA	FBLM
	clr	LINTCNT
;
LD5C5:	ldaA	RINT
	cmpA	#$80
	beq	LD621	; if (RINT == 0x80) then RFuel is spot on, so skip this

	ldaB	RINTCNT
	incB	
	bne	LD5D2
	decB	
LD5D2:	staB	RINTCNT	; increment RINTCNT, limit to 0xFF

	cmpB	KBLMCNT
	bcs	LD624	; if (LINTCNT < KBLMCNT) goto LD624
	
	ldX	#RBLMTABLE
	ldaB	BLMCELL
	aBX	
	ldaA	0, X
	ldaB	RINT
	subB	#$80
	bcs	LD601
	cmpB	L8655
	bls	LD624
	brset	RHFLMW,#RHFLMW_RICH,LD624
	addA	L8652
	bcs	LD5FC
	cmpA	KBLMMAX	;  = 0xA0
	bls	LD618
LD5FC:	ldaA	KBLMMAX	;  = 0xA0
	jr	LD618
;
LD601:	negB	
	cmpB	L8656
	bls	LD624
	brclr	RHFLMW,#RHFLMW_RICH,LD624
	subA	L8652
	bcs	LD615
	cmpA	KBLMMIN    ;  = 0x5A
	bhi	LD618
LD615:	ldaA	KBLMMIN    ;  = 0x5A
LD618:	staA	0, X
	staA	RBLM
	jr	LD621
;
LD61E:	clr	LINTCNT
LD621:	clr	RINTCNT
LD624:	bclr	L005F, #%00001000

	ldaA	RPMFILT
	staA	RPMFILT1
	
LD62B:	ldaA	#$FF
	staA	COP_WDOGFF	; Tickle the watchdog

LD630:	ldaB	TIMER_TICK
	andB	#%00001111
	ldX	#$D658
	lslB	
	aBX	
	ldX	0, X
	call	0, X
;
; Flag that timeslice processing is complete
;
	bclr	MW3,#MW3_BUSY
;
; We've finished this time slices processing. Fill the rest of the
; time slice (until the next interrupt) refreshing the RAM.
;
REFRESH_FOREVER:
LD640:	ei	
	ldX	REFRESH_ADDR
	beq	LD653	; if (REFRESH_ADDR == 0), reset it

LD646:	decX	
	decX	

LD648:	di	
	ldD	0, X
	stD	0, X
	ei	
	stX	REFRESH_ADDR
	bne	LD646

LD653:	ldX	#RAM_TOP_WORD_ADDR
	jr	LD648
;
;**********************************************************************
; This is a call table used by code at about LD63B. A different function
; is called per 6.25mS timer tick. The 4 ls bits of TIMER_TICK are used
; as an index into this table to get the address of the function to be called 
;
LD658:	dw	$D679,$D681,$D8C8,$D8E0,$D8ED,$D9DD,$DB59,$DBFB
	dw	$DC3E,$DC84,$DCAC,$DD04,$DE76,$E177,$E1A0,$E6B7 
;
;**********************************************************************
;
LD678:	db	$39
;
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x00
LD679:	brclr	VBATMW,#VBATMW_HUD,LD680
	call	L580F
LD680:	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x01
LD681:	ldaA	ADBAT
	cmpA	#$AB
	bcs	LD699	; if (ADBAT <= 17.1 V) goto LD699 
	
	brclr	MW2,#MW2_TC53,LD694
	bset	MALFDET4,MALFDET4_TC53
	bset	DIAGMW3, DIAGMW3_TC53
	jr	LD6AA
;
LD694:	bset	MW2,#MW2_TC53
	jr	LD69F
;
LD699:	bclr	MW2,#MW2_TC53
	bclr	DIAGMW3,#DIAGMW3_TC53
	
LD69F:	brclr	MW1,#MW1_ENGRUN,LD6A6
	jmp	LD77B
;
LD6A6:	brset	DIAGMW3,#%10000000, LD6AF
LD6AA:	ldX	#$D000
	jr	LD6B2
;
LD6AF:	ldX	#$DFFF
LD6B2:	stX	L3FD8   

	mul	
	stX	PWM_PURGE
	stX	L3F92
	nop	
	stX	PWM_WGATE
	stX	PWM_ACCLUTCH
	nop	
	stX	L3FCC

	brset	DIAGMW3,#DIAGMW3_TC53,LD6CF
	brclr	DIAGMW3, #%10000000, LD6DD

LD6CF:	nop	
	stX	PWM_EFAN
	stX	L3FDA
	nop	
	stX	PWM_EWP
	jmp	LD8A1
;
LD6DD:	ldaA	TIMER_TICK
	cmpA	#$01	; Do this once per second, when tick = 1
	beq	LD6E6
	jmp	LD8A1
;
LD6E6:	ldX	FANRUNON
	cmpX	KFANRUNON
	bhi	LD724	; if FAN's been on for KEWPRUNON seconds, turn it off
	incX	
	stX	FANRUNON
	
	ldaA	KCTSFANON
	brclr	MW1,#MW1_FANON,LD6FC ; if FAN already on, use KCTSFANOFF
	ldaA	KCTSFANOFF

LD6FC:	cmpA	CTSFILT
	bcs	LD710	; if (CTSFILT > KCTSFAN??) turn FAN on 
	
	ldaA	KMATFANON
	brclr	MW1,#MW1_FANON, LD70B ; if FAN already on, use KMATFANOFF
	ldaA	KMATFANOFF
	
LD70B:	cmpA	MATA
	bcc	LD724	; if (MATA <= KMATFANON/OFF) turn FAN off
;
; This is where we turn the FAN on
;
LD710:	bset	MW1,#MW1_FANON
	ldX	#$0008
	stX	L01AB
	ldX	#$DFFF
	stX	PWM_EFAN
	stX	L3FDA
	jr	LD730
;
; This is where we turn the FAN off
;
LD724:	bclr	MW1,#MW1_FANON
	ldX	#$D000
	stX	PWM_EFAN
	stX	L3FDA          
;	
LD730:	brset	MW1,#MW1_FANON,LD75E ; if the fan is on, turn the EWP on also

	ldX	EWPRUNON
	cmpX	KEWPRUNON
	bhi	LD76F		; if EWP's been on for KEWPRUNON seconds, turn it off
	incX	
	stX	EWPRUNON
	
	ldaA	KCTSEWPON
	brclr	MW1,#MW1_EWPON,LD74A ; if EWP already on, use KCTSEWPOFF
	ldaA	KCTSEWPOFF
	
LD74A:	cmpA	CTSFILT
	bcs	LD75E		; if (CTSFILT > KCTSEWPON/OFF) turn EWP on
	
	ldaA	KMATEWPON
	brclr	MW1,#MW1_EWPON,LD759 ; if EWP already on, use KMATEWPOFF
	ldaA	KMATEWPOFF
	
LD759:	cmpA	MATA
	bcc	LD76F                ; if (MATA <= KMATEWPON/OFF) turn EWP off
;
; This is where we turn the EWP on
;
LD75E:	bset	MW1,#MW1_EWPON
	ldX	#$0008
	stX	L01AB
	ldX	#$DFFF
	stX	PWM_EWP
	jr	LD778
;
; This is where we turn the EWP off
;
LD76F:	bclr	MW1,#MW1_EWPON
	ldX	#$D000
	stX	PWM_EWP
LD778:	jmp	LD8A1
;
LD77B:	bclr	MW1,#%00000101 ; (MW1_EWPOFF && MW1_FANOFF)
	ldX	#$0000
	stX	FANRUNON
	stX	EWPRUNON
	ldX	#$D000
	stX	PWM_EWP

	clrA	
	brclr	ALDLMW,#ALDLMW_STARTMD4,LD795
	ldaA	ALDLMD_PWMCW
LD795:	staA	PWMCW

	clrA	
	brclr	ALDLMW,#ALDLMW_STARTMD4,LD79F
	ldaA	ALDLMD_DCW
LD79F:	staA	DOECW
;
; This is where we activate the cannister purge valve                                  
;
; This first bit of code is for 0% or 100% duty cycles - i.e. constant discrete outputs	
	brclr	DOECW, #DOECW_PURGE, LD7B1
	clrB	
	ldaA	ALDLMD_DSTW
	bitA	#%00001000
	beq	LD7BD
	ldaB	#$FF
	jr	LD7BD
;
; This second bit of code is for variable PWM duty cycles	
LD7B1:	brclr	PWMCW, #%00001000, LD7BA
	ldaB	ALDLMD_PWMDC
	jr	LD7BD
LD7BA:	ldaB	PURGEDC
;
; At this stage, B = desired duty cycle
;
LD7BD:	ldaA	KAFOPT3	; = 0x80
	bitA	#%10000000
	bne	LD7C5	; this jump always taken, coz KAFOPT3 = 0x80
	comB	

LD7C5:	ldaA	#$34
	lslD	
	lslD	
	oraB	#%00000011
	stD	PWM_PURGE
;
; This is where we activate the exhaust counterpressure valve
;	
	ldD	#$D000
	brclr	PWMCW,#PWMCW_EXCPVDC,LD7E0
	ldaB	ALDLMD_PWMDC
	ldaA	#$34
	lslD	
	lslD	
	oraB	#%00000011
	jr	LD7E7
LD7E0:	brclr	MW1,#MW1_ECPVSHUT,LD7E7
	ldD	#$DFFF
LD7E7:	stD	PWM_EXCPV
;
; This is where we activate the electric cooling fan
;	
	ldaB	ALDLMD_DSTW
	ldX	#$D000
	brclr	DOECW,#DOECW_FAN,LD7FA
	bitB	#ALDLMD_DSTW_FAN
	beq	LD801
	jr	LD7FE
;
LD7FA:	brclr	FANMW,#FANMW_EFANON,LD801
LD7FE:	ldX	#$DFFF
LD801:	stX	PWM_EFAN
;
; This is where we activate the A/C clutch
;	
	ldX	#$D000
	brclr	DOECW,#DOECW_AC,LD811
	bitB	#ALDLMD_DSTW_AC
	beq	LD818
	jr	LD815
;
LD811:	brset	MW1,#MW1_ACCUTOFF,LD818
LD815:	ldX	#$DFFF
LD818:	stX	PWM_ACCLUTCH
;
; This is where we activate the ?????
;	
	ldX	#$D000
	brclr	DOECW, #%00000100, LD828
	bitB	#%00000100
	beq	LD82F
	jr	LD82C
;
LD828:	brclr	MW2,#MW2_MAPVACUUM,LD82F
LD82C:	ldX	#$DFFF
LD82F:	stX	L3F92
;
; This is where we activate the ?????
;	
	ldX	#$D000
	brclr	DOECW, #%00010000, LD83F
	bitB	#%00010000
	beq	LD846
	jr	LD843
;
LD83F:	brclr	L0058, #%00000010, LD846
LD843:	ldX	#$DFFF
LD846:	stX	L3FD8
;
; This is where we activate the ?????
;	
	ldX	#$D000
	brclr	DOECW, #%10000000, LD856
	bitB	#%10000000
	beq	LD85D
	jr	LD85A
;
LD856:	brclr	FANMW, #%00001000, LD85D
LD85A:	ldX	#$DFFF
LD85D:	stX	L3FDA
;
; Set the Waste Gate Duty Cycle PWM controller
;
	clrA	
	ldaB	WGATEDC		; A:B = 0x00:WGATEDC
	brclr	PWMCW,#PWMCW_WGATEDC,LD86B
	ldaB	ALDLMD_PWMDC	; A:B = 0x00:ALDL_PWMDC
LD86B:	lslD	
	lslD	
	oraA	#%11010000	; A:B = 0xD000 | (WGATEDC << 2)
	stD	PWM_WGATE
;
; Set the ????? PWM controller
;
	ldaA	#$F0
	ldaB	L01BD
	brclr	PWMCW, #%10000000, LD87E
	ldaB	ALDLMD_PWMDC
LD87E:	stD	L3FCC
;
; Set the ????? PWM controller
;
	brclr	ALDLMW,#ALDLMW_STARTMD4,LD891
	ldaA	ALDLMD_FMCW
	bitA	#%01000000
	beq	LD891
	bset	MW2, #%10000000
	jr	LD894
LD891:	bclr	MW2, #%10000000
;
; Set the Check Engine Lamp (CEL)
;
LD894:	brclr	DOECW,#DOECW_CEL,LD8A1
	ldaB	ALDLMD_DSTW
	bitB	#ALDLMD_DSTW_CEL
	beq	LD8B0
	jr	LD8A5
LD8A1:	brclr	L0066, #L0066_CELON, LD8B0
;
; This is where we turn the CEL Lamp on
;
LD8A5:	ldD	L3FFC
	oraA	#%11111011
	oraB	#%00000010
	andB	#%11110111
	jr	LD8B7
;
; This is where we turn the CEL Lamp off
;
LD8B0:	ldD	L3FFC
	oraA	#%11111011
	oraB	#%00001010

LD8B7:	nop	
	nop	
	stD	L3FFC
	
	andB	#%11110111
	brclr	DIAGMW4, #%10000000, LD8C4
	oraB	#%00001000
LD8C4:	stD	L3DFC

	ret	
;**********************************************************************
;
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x02
;
LD8C8:	ldaA	#BAROAtoD
	call	ReadAtoD
	staA	ADBARO
	tAB	
	clrA	       	; A:B = 0x00:ADBARO
	ldX	#$02B6	; X = 694 = 2.71
	fdiv		; X = ADBARO / 2.71	
	pushX	
	popA	
	popB	
	addd	#$0A57    ; A:B = (ADBARO / 2.71) + 10.33
	stD	NBARO
	ret
;	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x03
;
LD8E0:	brclr	VBATMW,#VBATMW_HUD,LD8E7
	call	L5812
LD8E7:	ldaA	#$F7
	staA	L5000
	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x04
;
; This code checks the ALDL pin to determine the ECU operating mode
; If the ALDL pin is < 0.78 V, then enter diagnostic mode
;
LD8ED:	bclr	L0066,L0066_ALDL_DIAG ; Assume we aren't in ALDL_DIAG

	ldaA	#ALDLAtoD
	call	ReadAtoD		; Read the voltage on the ALDL pin
	cmpA	#$28		; 0.78V
	bcc	LD8FC		; if (ALDL > 0.78V) we don't want ALDL_DIAG
	
	bset	L0066,L0066_ALDL_DIAG ; if (ALDL < 0.78V) we DO want ALDL_DIAG
	
LD8FC:	ldaA	L025D
	beq	LD904
	bset	VBATMW, #%00000100

LD904:	ldD	L3FBC
	oraA	#%01111011
	oraB	#%10000010
	nop	
	nop	
	stD	L3FBC
	
	ldD	#$7FFF
	staB	DDR_PORTB		; DDR_PORTB = 0xFF
	stD	L3FAC

	ldD	#$0040
	stD	L3FCE
	stD	L3FAE
	nop	
	nop	
	nop	
	nop	
	stD	L3FB0
	nop	
	nop	
	nop	
	nop	
	stD	L3FB2
	nop	
	nop	
	nop	
	nop	
	stD	L3FB4
	oraA	#%10000000

	ldX	#IOREG4000
	di	
	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB
	lslA	
	bpl	LD963
	bset	SEQMW1, #%00001000
LD963:	bclr	IOPORTA, X,SPI_DEV7

	ei	
	brset	MW1,#MW1_ENGRUN,LD99E
	bclr	L005F, #%00101010
	ldaA	CTSFILT
	staA	CTSSTART

	brset	NVRAMWD1,#NVRAMWD1_CTSCOOL,LD980
	cmpA	MINCOOL
	bcs	LD980
	bset	NVRAMWD1,#NVRAMWD1_CTSCOOL
	
LD980:	clrB	
	ldaA	KO2FFO
	stD	ADRO2FILT
	stD	RO2FILT
	staA	ADRO2AFSC
	staA	ADRO2
	stD	ADLO2FILT
	stD	LO2FILT
	stD	ADLO2AFSC
	staA	ADLO2
	jr	LD9BF
;
LD99E:	bclr	NVRAMWD1, #%00010000
	
	ldX	LO2FILT
	ldaA	ADLO2FILT
	ldaB	KADO2FILT
	call	LAGFILTER
	stD	LO2FILT
	
	ldX	RO2FILT
	ldaA	ADRO2FILT
	ldaB	KADO2FILT
	call	LAGFILTER
	stD	RO2FILT
	
LD9BF:	ldaA	NBARO
	brset	MW2,#MW2_MAPVACUUM,LD9D2
;
; We get here if in the last pass through, (NBARO + L801A/B) < NMAP0
;	
	addA	L801B	; = 0x00
	cmpA	NMAP0
	bls	LD9DC	; if ((NBARO + L801B) < NMAP0) leave MW2_MAPVACUUM clear
;
; We get here if (in the last pass through (NBARO + L801A/B) < NMAP0)
;            AND ((NBARO + L801B) >= NMAP0) 
;	
	bset	MW2,#MW2_MAPVACUUM ; set MW2_MAPVACUUM
	jr	LD9DC
;
; We get here if in the last pass through,  (NBARO + L801A/B) > NMAP0
;	
LD9D2:	addA	L801A	; = 0x00
	cmpA	NMAP0
	bcc	LD9DC	; if ((NBARO + L801A) > NMAP0) leave MW2_MAPVACUUM set  
;
; We get here if (in the last pass through (NBARO + L801A/B) > NMAP0)
;            AND ((NBARO + L801A) < NMAP0) 
;	
	bclr	MW2,#MW2_MAPVACUUM
;
LD9DC:	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x05
;
LD9DD:	brset	L005F, #%00000010, LDA46
	brset	VBATMW, #%00010000, LDA40

	ldaA	NBARO
	subA	NMAP0
	bcs	LDA46	; if (NMAP0 > NBARO) goto LDA46
;
; At this point A = (NBARO - NMAP0), and is +ve
;
	cmpA	L8400	; = 0x0A
	bls	LDA46	; if there is less vacuum than 0.05 Bar goto LDA46
	
	ldD	TIMERUN
	cmpD	L83FE	; = 0x00E6 = 230 Seconds
	bcs	LDA46	; if (RUNTIME < 230 Sec) goto LDA46 

	ldaA	CTSFILT
	cmpA	L840B	; = 0x9E = 78.5 DegC
	bls	LDA46	; if (CTSFILT < 78.5 C) goto LDA46
	
	ldX	#L840C
	brclr	LCCPMW, #%00000001, LDA0B
	ldX	#L840E
	
LDA0B:	ldaB	NMPH
	ldaA	PURGEDC
	cmpB	0, X
	bls	LDA40
	
	ldaB	NTPSLD
	cmpB	1, X
	bcc	LDA49
	
	ldaB	KAFOPT1
	bitB	#%00001000
	bne	LDA40
	
	brset	L0067,#L0067_TC24,LDA40
	ldaB	NMPH
	cmpB	L8408	; = 0xFF = 79 MPH
	bls	LDA40	; if (NMPH < 79 MPH) goto LDA40

	ldaB	FBLM
	cmpB	RBLM
	bcs	LDA37
	ldaB	RBLM	; B = Larger of FBLM,RBLM

LDA37:	cmpB	L840A	; = 0x78
	bls	LDA40	; if (max(FBLM,RBLM) < 0x78) goto LDA40 

	brset	L0056, #%00000100, LDA46
LDA40:	bclr	L0056, #%00000100
	clr	L0193
LDA46:	jmp	LDAE1
;
LDA49:	brclr	L0056, #%00000100, LDA53
	ldaA	L0193
	staA	PURGEDC

LDA53:	ldaB	NMAP0
	cmpB	L8401
	bhi	LDA89

	ldaB	L0194
	cmpB	L8402
	bcc	LDA68

	inc	L0194
	jmp	LDAE5
;
LDA68:	ldaB	LINT
	cmpB	RINT
	bcs	LDA70
	ldaB	RINT
	
LDA70:	cmpB	L8403
	bcc	LDA82
	
	cmpB	L8404
	bcc	LDA89
	
	subA	L8406
	bcc	LDA89
	clrA	
	jr	LDA89
;
LDA82:	addA	L8405
	bcc	LDA89
	ldaA	#$FF
LDA89:	clrB	
	staB	L0194
	brset	MWFA1, #%10000000, LDA9B
	bclr	L0056, #%00000100
	ldaB	KAFOPT1
	bitB	#%00100000
	beq	LDAE1

LDA9B:	pushA	

	ldaA	PURGEDC
	cmpA	L8407	; = 60%
	bls	LDAC2	; if (PURGEDC < 60%) goto LDAC2
;
	ldaB	NMPH
	cmpB	L8408	; NMPH = 0xFF = 79 MPH
	bls	LDAC2	; if (NMPH < 79 MPH) goto LDA40
;	
	ldaB	FBLM
	cmpB	RBLM
	bcs	LDAB4
	ldaB	RBLM	; B = Larger of FBLM,RBLM
	
LDAB4:	cmpB	L8409	; = 0x7F
	bls	LDAC2	; if (max(FBLM,RBLM) < 0x7F) goto LDAC2
	
	bset	L0056, #%00000100
	popA	
	staA	L0193
	jr	LDAE5
;
LDAC2:	bclr	L0056, #%00000100
	clr	L0193
	ldD	L00A4
	cmpA	#$20
	bcs	LDAD1
	ldD	#$FFFF
LDAD1:	lslD	
	lslD	
	lslD	
	ldX	#L8410
	call	LOOKUP1DBYN

	popB	
	cBA	
	bcs	LDAE5
	tBA	
	jr	LDAE5
;
LDAE1:	clrA	
	clr	L0194
LDAE5:	bclr	LCCPMW, #%00000001
	staA	PURGEDC
	beq	LDAF0
	bset	LCCPMW, #%00000001
;
; Guess - Read the Fuel injector Supply Voltage ?
;
LDAF0:	ldaA	#INJAtoD
	call	ReadAtoD
	staA	ADINJ
	
	brset	DIAGMW2, #%00010000, LDB35
	brclr	DIAGMW2, #%00001000, LDB3B
	
	ldaB	ADBAT
	cmpB	L83FB	; = 0xAF = 17.5V
	bcs	LDB3B	; if (ADBAT < 17.5V) goto LDB3B
	
	brclr	DIAGMW2, #%01000000, LDB17
	brclr	MW1,#MW1_ENGRUN,LDB3B
	
	cmpA	L83FA	; = 0x00 = 0V
	bcc	LDB2D
	jr	LDB35
;
LDB17:	ldaB	TC54_COUNT
	incB	
	beq	LDB20
	staB	TC54_COUNT
	
LDB20:	cmpB	KK54TIM	; = 0x0F
	bcc	LDB32
	
	cmpA	L83F9	; = 0x00
	bcs	LDB3B
	
	bset	DIAGMW2, #%01000000
LDB2D:	bclr	DIAGMW2,#DIAGMW2_TC54
	jr	LDB3B
;
LDB32:	bset	DIAGMW2, #%00010000 
;
LDB35:	bset	MALFDET4,#MALFDET4_TC54
	bset	DIAGMW2,#DIAGMW2_TC54
	
LDB3B:	bclr	DIAGMW2, #%00001000

	brclr	DIAGMW2, #%00000100, LDB45
	bset	DIAGMW2, #%00001000

LDB45:	bclr	DIAGMW2, #%00000100

	brclr	DIAGMW2,#DIAGMW2_TC54,LDB4F

	ldaA	ADBAT
	
LDB4F:	ldX	#F33
	call	LOOKUP1DBY16
	staA	F33BVC

	ret	
;
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x06
; Called during initialisation
;
; Read the CTS Temperature
;
CTSREAD:	
LDB59:	ldX	L5800
	cmpX	#$7E58
	bne	LDB64
	call	L5B70
;
;Read CTS, and linearise. See TurboP4.pdf section 2.4.1
LDB64:	ldaA	#CTSAtoD
	call	ReadAtoD
	staA	ADCTS
	
	ldX	#FCTL4K
	brset	L0056, #%10000000, LDB7C
	brclr	FMDSDI,FMDSDI_CTSGT50, LDB7C
			; if (COOLDEGA was < 39.5 degC) goto LDB7C
	ldX	#FCTL348
	jr	LDB82
;
LDB7C:	addA	#$0A 	; A = ADCTS + 10
	bcc	LDB82     
	ldaA	#$FF      ; if (A > 255) then A = 255

LDB82:	call	LOOKUP1DBY16 ; Linearise CTS
	staA	COOLDEGA 
	
	cmpA	#$78	; (0x78 * 0.75) - 40 = 50 deg C
	bhi	LDB95     ; if (COOLDEGA > 50 deg C) goto LDB95
	
	cmpA	#$6A	; (0x6A * 0.75) - 40 = 39.5 deg C
	bhi	LDB98	; if (COOLDEGA > 39.5 deg C) goto LDB98

	bclr	FMDSDI,FMDSDI_CTSGT50 ; COOLDEG < 39.5C
	jr	LDB98
;
LDB95:	bset	FMDSDI,FMDSDI_CTSGT50 ; COOLDEG > 50C

LDB98:	bclr	L0056, #%10000000
	ldaA	ADCTS
	bclr	DIAGMW1,#DIAGMW1_DEFCTS
	bclr	L0066,#L0066_DEFCTS
	bclr	L0067,#L0067_DEFCTS

	brset	LCCPMW,#LCCPMW_FUEL_BK,LDBD5

	ldaB	#MALFDET1_TC15
	cmpA	KKETMPLO		; = 0xF0
	bhi	LDBBC               ; if (ADCTS > KKETMPLO) goto LDBBC
	
	ldaA	COOLDEGA
	ldaB	#MALFDET1_TC14
	cmpA	KKCTMPHI            ; KKCTMPHI = 130.25 C
	bcs	LDBD8               ; if (COOLDEGA < 130.25C) goto LDBD8

	;We get here if either (CTS > KKETMPLO) || (COOLDEGA > KKCTMPHI)
LDBBC:	ldX	TIMERUN
	cmpX	KKETMPT		; KKETMPT = 0x0005
	bls	LDBCD		; if (TIMERUN < 0x0005) goto LDBCD

	;Allow 5 seconds before flagging errors
	bset	L0066,#L0066_DEFCTS
	bset	L0067,#L0067_DEFCTS
	oraB	MALFDET1
	staB	MALFDET1
	
LDBCD:	ldaA	KKTCDF		; Use te default CTS
	bset	DIAGMW1,#DIAGMW1_DEFCTS ; Flag we're using default CTS
	jr	LDBED
;
LDBD5:	ldaA	COOLDEGA
LDBD8:	brclr	LCCPMW,#LCCPMW_CTFIRST,LDBE7 ; On first pass, set CTSSTART

	ldaB	KCTSFILT		; Lag filter CTSFILT after first pass
	ldX	CTSFILT
	call	LAGFILTER
	jr	LDBEE
;
LDBE7:	staA	CTSSTART		; on first pass set CTSSTART
	bset	LCCPMW,#LCCPMW_CTFIRST ; Flag we've done the first pass

LDBED:	clrB
LDBEE:	stD	CTSFILT	; Store the latest CTSFILT

	cmpA	#$D0	; 116 Deg C 
	bls	LDBF7     ; if (COOLDEGA < 116C) goto LDBF7
	ldaA	#$D0      ; else limit CTS116MAX to 116 C
	
LDBF7:	staA	CTS116MAX	; Store the limited CTS116MAX

	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x07
;
; Perform the lookup table calculations based on temperatures gathered
; in step 0x06
;
LDBFB:	ldaA	CTS116MAX
	ldX	#L84FF
	call	LOOKUP1DBY16

	ldX	#L84FD	; = 0x1300
	call	MULT8BY16

	stD	L0168

	ldaA	CTSFILT
	ldX	#L86F9
	call	LOOKUP1DBYN
	staA	L0159

	ldaA	CTSFILT
	ldX	#L867F
	call	LOOKUP1DBY16
	staA	L01CC

	ldaA	CTSFILT
	ldX	#L8690
	call	LOOKUP1DBY16
	staA	L01CD

	ldaA	CTSFILT
	ldX	#L86C3
	call	LOOKUP1DBY16
	staA	L01CA

	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x08
;
LDC3E:	bclr	DIAGMW1,#DIAGMW1_OILTEMP

	ldaA	#OILAtoD
	call	ReadAtoD
	staA	ADOIL

	ldX	#FCTL348
	call	LOOKUP1DBY16
	
	ldaB	KOILFILT
	ldX	OILTEMP
	call	LAGFILTER
	staA	OILTEMP

	ldaA	ADOIL
	bclr	L0066,#L0066_OILTEMP
	ldaB	#MALFDET4_TC52
	cmpA	KK52OTHI		; = 140 Deg C
	bhi	LDC72		; if (ADOIL > 140C) flag TC52

	ldaA	OILTEMP
	ldaB	#MALFDET4_TC62
	cmpA	KK62OTLO		; = 140 Deg C
	bcs	LDC83		; if (ADOIL < 140C) flag TC62

LDC72:	ldX	TIMERUN
	cmpX	KK52TIM	; = 0x0708
	bls	LDC83	; if (TIMERUN < 30 mins) bounce to return

	bset	L0066,#L0066_OILTEMP
	bset	DIAGMW1,#DIAGMW1_OILTEMP
	oraB	MALFDET4
	staB	MALFDET4
	
LDC83:	ret
;	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x09
;
LDC84:	brset	LCCPMW, #%00000100, LDCA8

	ldaA	CTSFILT
	cmpA	L8447	; = 0xFF = 151.25C
	bls	LDCA8	; if (CTSFILT < 151.25) 
	
	brset	MWFA1, #%10000000, LDCA8
	
	ldX	L8449	; = 0x0050 = 80 Sec
	cmpA	L8448	; = 0xFF = 151.25C
	bls	LDC9F     ; if (CTSFILT < 151.25) TIMERUN = 80, else 25
	ldX	L844B	; = 0x0019 = 25 Sec

LDC9F:	cmpX	TIMERUN
	bcs	LDCA8	; if (TIMERUN < 80/25) goto LDCA8

	bset	L0058, #%00000010
	jr	LDCAB
;
LDCA8:	bclr	L0058, #%00000010
LDCAB:	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x0A
; This code operates the exhaust counterpressure valve in an attempt
; to warm up the catalytic converters quicker.
; 
; See KTA1567 Checking Procedures (TECH 1) Page 20 (in update 1 - 04/91)
;
LDCAC:	ldaA	NTPSLD
	cmpA	L845B	; = 0x66 = 40%
	bhi	LDD00	; if (NTPSLD > 40%) open the ECPV
	
	ldD	TIMERUN
	cmpD	L8454 	; = 0x0000
	bcs	LDD00	; if (TIMERUN < 0) open the ECPV
	
	cmpD	L8456	; = 0x009E = 158 seconds
	bcc	LDD00	; if (TIMERUN >= 158) open the ECPV
	
	ldaA	CTSSTART
	cmpA	L8458	; = 0x4D = 17.75 Deg
	bls	LDD00	; if (CTSSTART < 17.75C) open the ECPV
	
	cmpA	L8459	; = 0x5D = 29.75 Deg
	bhi	LDD00	; if (CTSSTART > 29.75C) open the ECPV
	
	ldaA	COOLDEGA
	cmpA	L845A	; = 0x93 = 70.25 Deg
	bcc	LDD00	; if (COOLDEGA >= 70.25C) open the ECPV
	
	ldaA	NTRPMX
	cmpA	L845C	; = 0x74 = 2900 RPM
	bcc	LDD00	; if (NTRPMX >= 2900 RPM) open the ECPV
	
	cmpA	L845D	; = 0x68 = 2600 RPM
	bcs	LDCE7	; if (NTRPMX < 2600 RPM) goto LDCE7
			; Keep the ECPV open till RPM drops below 2600
			; If RPM has dropped below 2600, check the MAP
	
	brclr	MW1,#MW1_ECPVSHUT,LDD00 ; if ECPV already open,open the EXCPV
	
LDCE7:	ldaA	ADMAPN
	cmpA	L845E	; = 0x69 = 0.90 Bar
	bcc	LDD00	; if (ADMAPN >= 0.90 Bar) open the EXCPV 
	
	cmpA	L845F	; = 0x62 = 0.85 Bar
	bcs	LDCF7	; if (ADMAPN < 0.85 Bar) close the EXCPV

	brclr	MW1,#MW1_ECPVSHUT,LDD00 ; if ECPV already open,open the EXCPV
;
; This is where we may close the ECPV	
LDCF7:	brset	WGATEMW,#WGATEMW_PULLAWAY,LDD00 ; Dont close ECPV if we are about to pull away
;
; This is where we close the ECPV	
	bset	MW1,#MW1_ECPVSHUT
	jr	LDD03
;
; This is where we open the ECPV	
LDD00:	bclr	MW1,#MW1_ECPVSHUT
;
LDD03:	ret	
;
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x0B
;
LDD04:	brset	TIMER_TICK, #%00010000,LDD21
;
; This code is performed every 200mS, on the 0 100ms multiple
;
; ESC Knock Retard Decay - TurboP4.pdf 12.3.1.3
;
	ldaA	NTRPMX
	ldX	#F7
	call	LOOKUP1DBY16 ; A = fn(NTRPMX)
	
	ldaB	NOCKRTD
	mul		; A = fn(NTRPMX) * NOCKRTD	
	adcA	#$00	; Round A up/down
	
	negA		; A = 0 - A	
	bne	LDD1A	
	ldaA	#$FF      ; if A = 0, then A = 0xFF
	
LDD1A:	addA	NOCKRTD	; A = NOCKRTD - (fn(NTRPMX) * NOCKRTD)
	bcs	LDD1F
	clrA		; if NOCKRTD carries, limit it to zero
;		
LDD1F:	staA	NOCKRTD   ; Store the new (retarded) value of NOCKRTD  
;
; Check to see if TC43 (Knock Sensor failed) is enabled
;
LDD21:	ldaA	MALFWD3_MASK
	bitA	#MALFWD3_TC43
	beq	MATREAD	; if TC43 disabled, goto MATREAD

	ldaB	TIMER_TICK
	cmpB	#$1B
	bne	LDD63	; check for the 1 100ms multiple
;
; This code is performed every 200mS, on the 1 100ms multiple
;
	brset	NVRAMWD1, #%01000000, LDD63
	brset	NVRAMWD1, #%00000001, LDD56
	brset	VBATMW, #%00010000, LDD63
	brclr	MW1,#MW1_ENGRUN,LDD63
	
	ldaB	NMAP0
	cmpB	L83EA
	bcs	LDD63
	
	brset	MW3, #%00100000, LDD63
	ldaB	CTSFILT
	cmpB	L83E9
	bls	LDD63
	
	bset	NVRAMWD1, #%00000001
	jr	LDD63
;
LDD56:	ldaB	L00AA
	cmpB	L83EB
	bne	LDD63

	bclr	NVRAMWD1, #%00000001
	bset	NVRAMWD1, #%11000000
	
LDD63:	ldaA	#KNOCKAtoD
	call	ReadAtoD
	staA	ADKNOCK
	
	cmpA	KKM43ATH	; = 4.51 V
	bhi	LDD74	; if (ADKNOCK > 4.51V) goto LDD74
	
	cmpA	KKM43ATL	; = 0.65 V
	bcc	LDD86	; if (ADKNOCK > 0.65V) goto LDD86
	
LDD74:	ldaA	TC43_COUNT
	cmpA	KK43ATIM	; = 0x20 , or 2 seconds ?
	bhi	LDD81
	inc	TC43_COUNT
	jr	MATREAD
;
; ((ADKNOCK > KKM43ATH) or (ADKNOCK < KKM43ATL)) for more than KK43ATIM samples
; so flag the KS voltage is out of range (potentially, KS has failed)
;
LDD81:	bset	LCCPMW, #LCCPMW_TC43
	jr	MATREAD
;
; KS voltage is within range so clear down associated variables
;
LDD86:	bclr	LCCPMW, #LCCPMW_TC43
	clr	TC43_COUNT
;
;Read the Manifold air temperature
;
MATREAD:
LDD8C:	ldaA	#MATAtoD
	call	ReadAtoD	; A = ReadAtoD()
	comA		; A = 255 - A	
	staA	ADMAT
	staA	ADMATFILT
	cmpA	KKMATMPLO	; KKMATMPLO = 0x04 = Cold ?
	bcc	LDDC8     ; if (MAT > 4) goto DDC8

	ldaA	TC23_COUNT
	cmpA	KK23TIME
	bhi	LDDD0

	brset	MW1,MW1_ENGRUN,LDDB7
	brset	DIAGMW1,DIAGMW1_DEFCTS,LDDCB
	ldaA	CTSFILT
	cmpA	KKETCH
	bhi	LDDD0

	jr	LDDCB
;
LDDB7:	ldX	TIMERUN
	cmpX	KKETMPTL	; = 240 Seconds
	bls	LDDD3
	
	ldaA	MPH
	bne	LDDC8
	
	inc	TC23_COUNT
	jr	LDDD3
;
LDDC8:	clr	TC23_COUNT
LDDCB:	bclr	L005F, #%00010000
	jr	LDDD3
;
LDDD0:	bset	L005F, #%00010000

LDDD3:	ldaA	NMAP0
	cmpA	NBARO
	bcc	LDE05

	ldaA	ADMAT
	cmpA	KKETMPHI
	bcs	LDE05	; if (ADMAT < 0xF3) goto LDE05

	ldaA	TC25_COUNT
	cmpA	KK25TIME	; = 0x1E
	bhi	LDE0D     ; if (TC25_COUNT > 0x1E) goto LDE0D

	ldaA	MPH
	bne	LDDFB	; if (MPH != 0) goto LDDFB

	ldX	TIMERUN
	cmpX	KKETMPTH	; TIME = 60 Seconds
	bls	LDE10
	
	inc	TC25_COUNT
	jr	LDE10
;
LDDFB:	cmpA	KK25MPH	; 5 MPH
	bls	LDE05	; if (MPH < 5 MPH) goto DE05

	inc	TC25_COUNT
	jr	LDE10
;
LDE05:	bclr	DIAGMW2,#DIAGMW2_MATDF
	clr	TC25_COUNT
	jr	LDE10
;
LDE0D:	bset	DIAGMW2,#DIAGMW2_MATDF
LDE10:	brset	L005F, #%00010000, LDE1D
	brclr	DIAGMW2,#DIAGMW2_MATDF,LDE26
	bset	MALFDET2,#MALFDET2_TC25
	jr	LDE20
;
LDE1D:	bset	MALFDET1,#MALFDET1_TC23

LDE20:	ldaA	KKMATDF
	staA	ADMATFILT

LDE26:	ldaA	ADMATFILT
	ldX	#L8266		; This table is all 0x00's
	call	LOOKUP1DBY16
	staA	L01B6		; So L01B6 == 0x00
	
	ldaA	ADMATFILT
	comA	
	subA	#$0C
	bcc	LDE3B
	clrA	
LDE3B:	ldX	#LEF7E
	call	LOOKUP1DBY16
	staA	MATA		; Linearised MAT
	
	ldaA	ADMATFILT
	ldX	#L8D69
	call	LOOKUP1DBY16	; 200C A = 0x89, -40C A = 0x28

	ldaB	#$80		; = 0.5
	mul	          	; 200C A:B = 0x4480, -40C A:B = 0x1400

	addd	#$7480		; = 116.5 ???
				; 200C A:B = 0xB900, -40C A:B = 0x8880
	pushB	
	pushA	
	popX	                    ; 200C X = 0xB900, -40C X = 0x8880
	ldD	L8AB0		; = 0x0043 (67 Dec)
	fdiv	
	stX	AIR_DENSITY	; 200C X = 0x5CB6  (1.3 g/l ?), -40C X = 0x7DA7 (1.8 g/l ?)
	
	ldaA	ADMATFILT
	ldX	#L86A1		; This table is all 0x80's
	call	LOOKUP1DBY16
	staA	L01CE		; So L01CE == 0x80
	
	ldaA	ADMATFILT
	ldX	#L86B2		; This table is all 0x80's
	call	LOOKUP1DBY16
	staA	L01CF		; So L01CF == 0x80
	
	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x0C
;
LDE76:	brclr	FMD1,#FMD1_ACREQ,LDED0 ; if (ACREQ is off) goto LDED0
;
	brset	IACMW2,#IACMW2_IACV_RESET,LDED0
	
	ldaA	L8439	; = 0xFE
	brclr	MW1,#MW1_ACCUTOFF,LDE87
	subA	#$10

LDE87:	cmpA	NTPSLD1
	bcs	LDED0

	ldaA	L843A	; A = 0xC8 = 110 DegC
	brclr	MW1,#MW1_ACCUTOFF,LDE95
	subA	#$07	; A = 0xC1 = 104.75 DegC

LDE95:	cmpA	CTSFILT
	bls	LDED0	; if (CTSFILT > 110/104 DegC) goto LDED0
	
	ldaA	L843B	; A = 0xDE = 126.5 DegC
	brclr	MW1,#MW1_ACCUTOFF,LDEA4
	subA	L843C	; A = 0xCE = 114.5 DegC

LDEA4:	cmpA	OILTEMP
	bls	LDEFB	; if (OILTEMP > 126/114 DegC) goto LDEFB

	ldaA	MPH
	cmpA	L843D	; = 0x84 = 132 MPH
	bcs	LDED7	; if (MPH < 132) goto LDED7
	
	brset	MW3,#%00001000,LDEC0
	bset	MW3,#%00001000
	ldD	TIMERUN
	addd	L843E	; A:B += 180 seconds
	stD	L01BE
	
LDEC0:	ldX	TIMERUN
	cmpX	L01BE
	bcs	LDED2

	bset	MW3,#%00010000
	ldaA	L8440	; = 0x1E
	staA	L01C0
;
LDED0:	jr	LDEFB
;
LDED2:	bclr	MW3, #%00010000
	jr	LDEE8
;
LDED7:	brclr	MW3, #%00010000, LDEE5
	ldaA	L01C0
	beq	LDEE5
	dec	L01C0
	jr	LDEFB
;
LDEE5:	bclr	MW3, #%00001000
LDEE8:	brclr	MW1,#MW1_ACCUTOFF,LDEF3
;
	ldaA	NTRPMX
	cmpA	L8441	; = 5000 RPM
	bcc	LDEFB	; if (NTRPMX >= 5000) goto LDEFB
;	
LDEF3:	bclr	MW3, #%00010000
	bclr	MW1,#MW1_ACCUTOFF	; turn on the A/C clutch
	jr	LDEFE
;
LDEFB:	bset	MW1,#MW1_ACCUTOFF	; turn off the A/C clutch
;
LDEFE:	brset	FMD1,#FMD1_ACREQ,LDF0E
	bclr	IACMW1, #%00000001
	brset	IACMW1, #%10000000, LDF5B
	bset	IACMW1, #%00100000
	jr	LDF2B
;
LDF0E:	bclr	IACMW1, #%00100000
	bset	IACMW1, #%01000000
	brclr	IACMW1, #%10000001, LDF5B
	ldaA	L00DA
	cmpA	L8446
	bcs	LDF5B
	ldaA	IACMW1
	xorA	#%00000001
	staA	IACMW1
	bpl	LDF30
	ldaA	ISSPMP
	staA	L00DB
LDF2B:	clr	>L00DA
	jr	LDF5B
;
LDF30:	ldaA	ISSPMP
	subA	L00DB
	bcc	LDF37
	clrA	
LDF37:	ldaB	L0036_MAX
	cBA	
	bls	LDF3E
	tBA	
LDF3E:	ldaB	L0036_MIN
	cBA	
	bhi	LDF45
	tBA	
LDF45:	tAB	
	subA	L0036
	bcs	LDF55
	cmpA	L8445
	bls	LDF55
	ldaB	L8445
	tBA	
	addB	L0036
LDF55:	staB	L0036
	addA	L00D9
	staA	L00D9
LDF5B:	bset	IACMW1, #%10000000
	brclr	FMD1,#FMD1_ACREQ,LDF65
	bclr	IACMW1, #%10000000
LDF65:	brset	TIMER_TICK, #%00010000, LDF6C
	jmp	LE176
;
LDF6C:	brset	MW1,#MW1_ENGRUN,LDF74
	brclr	NVRAMWD1, #%00001000, LDF82
	
LDF74:	brset	DIAGMW3,DIAGMW3_TC44,LDF7C

	brclr	DIAGMW4,DIAGMW4_TC64,LDF85
	
LDF7C:	clr	L0124
	clr	L0125
LDF82:	jmp	LE00C
;
LDF85:	brclr	ALDLMW,#ALDLMW_STARTMD4,LDF97
	ldX	#ALDLMDEW
	brclr	0,X,#ALDLMDEW_FCL,LDF97
	brclr	1,X,#ALDLMDST_FCL,LE00C
	jmp	LE01D
;
LDF97:	brset	NVRAMWD2,#%00000010,LDFB7
	ldD	TIMERUN
	lsrD	
	ldX	#L8632
	ldaA	CTSSTART
	cmpA	L8631
	bls	LDFB0
	incX	
	cmpA	L8630
	bls	LDFB0
	incX	
LDFB0:	cmpB	0, X
	bcs	LE00C
	bset	NVRAMWD2,#%00000010
	
LDFB7:	ldaA	L85E2	; CTSFILT = 74.75 Deg C

	ldaB	MATA
	cmpB	L85E3	; = 19 DegC
	bcs	LDFC5	; if (MATA < 19 DegC) goto LDFC5

	ldaA	L85E1	; CTSFILT = 17.75 Deg C

LDFC5:	cmpA	CTSFILT
	bhi	LE00C
	
	brclr	VBATMW,#VBATMW_HUD,LDFD4
	brclr	L0069, #%01100000, LDFD4
	jr	LE00C
;
LDFD4:	ldaA	L0125
	cmpA	L85F9
	bcc	LDFE2
	incA	
	staA	L0125
	jr	LDFE5
;
LDFE2:	bclr	LHFLMW,#LHFLMW_RDY
LDFE5:	bclr	LHFLMW, #%00010000
	brclr	LHFLMW,#LHFLMW_RDY,LDFEF
	bset	LHFLMW, #%00010000

LDFEF:	ldaA	L0124
	cmpA	L85F9
	bcc	LDFFD
	incA	
	staA	L0124
	jr	LE000
;
LDFFD:	bclr	RHFLMW,#RHFLMW_RDY
LE000:	bclr	RHFLMW, #%00010000
	brclr	RHFLMW,#RHFLMW_RDY,LE012
	bset	RHFLMW, #%00010000
	jr	LE012
;
LE00C:	bclr	LHFLMW, #%00010000
	bclr	RHFLMW, #%00010000
LE012:	bclr	MWFA1, #%10000000
	brclr	LHFLMW, #%00010000, LE043
	brclr	RHFLMW, #%00010000, LE043
LE01D:	bset	MWFA1, #%10000000
	brclr	MWFA1, #%10000000, LE043
	bset	MWFA1, #%00000010

	ldaA	CTSFILT
	cmpA	L864E	; = 75.5 Deg C
	bls	LE043	; if (CTSFILT < 75.5 C) goto LE043 

	cmpA	L864F	; = 140 DegC
	bhi	LE043	; if (CTSFILT > 140 C) goto LE043

	ldX	FA_RATIO
	cmpX	KFA_STOIC	; 14.7:1
	bne	LE043	; if (FA_RATIO != 14.7:1) goto LE043

	ldaA	NMAP0
	cmpA	L8650	; = 0.24 Bar
	bcc	LE046	; if (NMAP0 >= 0.24 Bar) goto LE046

LE043:	bclr	MWFA1, #%00000010

LE046:	brset	LCCPMW, #%00000010, LE067

	ldaA	KAFOPT2
	bitA	#%00010000
	beq	LE05B 
	
	brclr	FMD1, #%00100000, LE05B

	bset	FANMW,#FANMW_HICTS
	jmp	LE0EC
;
LE05B:	brset	MW1,#MW1_ACCUTOFF,LE06A
	ldaA	MPH
	cmpA	L842C
	bcc	LE06A
LE067:	jmp	LE0EC
;
LE06A:	ldaA	NTRPMX
	cmpA	L8427	; = 0xFF = 6350 RPM
	bcs	LE086	; if (NTRPMX < 6350) goto LE086
	
	ldaA	NTRPMX_COUNT
	cmpA	L8428	; = 0xFF
	bcc	LE07E	; if (NTRPMX_COUNT >= L8428) flag a ??
	inc	NTRPMX_COUNT
	jr	LE089
;
LE07E:	bset	FANMW,#FANMW_HIRPM
	ldaA	L8425	; = 0xFF
	jr	LE08F
;
LE086:	clr	NTRPMX_COUNT
;
LE089:	bclr	FANMW,#FANMW_HIRPM

	ldaA	L8424		; = 0xFF 

LE08F:	brclr	FANMW,#FANMW_HIOIL,LE096
	subA	L8426		; = 0x00
	
LE096:	cmpA	OILTEMP
	bhi	LE0A0
	
	bset	FANMW,#FANMW_HIOIL
	jr	LE0EC
;
LE0A0:	bclr	FANMW,#FANMW_HIOIL

	ldaA	L841A		; = 0xB9 = 98.75 DegC
	brclr	MW1,#MW1_ACCUTOFF,LE0B5
	
	ldaB	MPH
	cmpB	L841E		; = 0x0C = 12 MPH
	bls	LE0B5		; if (MPH < 12 MPH) goto LE0B5                                
	
	ldaA	L841B		; = 0xB9 = 98.75 DegC

LE0B5:	brset	FANMW,#FANMW_EFANON,LE0C0
	cmpA	CTSFILT
	bcs	LE0EC		; if (CTSFILT > 98.75C) goto LEOEC
	jr	LE0F5
;
LE0C0:	brset	FANMW,#FANMW_HICTS,LE0D0
	ldaB	L841F		; = 0x06
;
	cmpA	L841A		; = 0xB9 = 98.75 DegC
	beq	LE0CF
	ldaB	L8420		; = 0x06
;
LE0CF:	sBA			; Subtract fan off hysteresys
;	
LE0D0:	cmpA	CTSFILT
	bhi	LE0DA
	bclr	FANMW,#FANMW_HICTS
	jr	LE0F5
;
LE0DA:	ldaA	L0174
	beq	LE0E4
	dec	L0174
	jr	LE0F5
;
LE0E4:	bclr	FANMW, #%00100111 ; clear (FANMW_HIOIL,FANMW_HICTS,FANMW_EFANON,
	clr	L0176
	jr	LE0F5
;
LE0EC:	bset	FANMW, #%00000100
	ldaA	L8421		; = 0x96 = 150
	staA	L0174
	
LE0F5:	brclr	FANMW,#FANMW_EFANON,LE104
	ldaA	L0176
	cmpA	L8422
	bcc	LE107
	inc	L0176
LE104:	jmp	LE168
;
LE107:	brclr	LCCPMW, #%00000010, LE10D
	jr	LE16D
;
LE10D:	brclr	FANMW,#FANMW_HICTS,LE119
	ldaA	MPH
	cmpA	L842A		; = 0x00
	bcs	LE16D
	
LE119:	brclr	FANMW,#FANMW_HIOIL,LE130
	brset	FANMW,#FANMW_HIRPM,LE16D

	ldaA	L8429
	brclr	FANMW, #%00001000, LE12B
	subA	L8426

LE12B:	cmpA	OILTEMP
	bls	LE16D

LE130:	ldaA	L841C
	brclr	MW1,#MW1_ACCUTOFF,LE142

	ldaB	MPH
	cmpB	L841E
	bls	LE142

	ldaA	L841D
LE142:	brset	FANMW, #%00001000, LE14D
	cmpA	CTSFILT
	bcs	LE16D

	jr	LE176
;
LE14D:	ldaB	L841F
	cmpA	L841C
	beq	LE158

	ldaB	L8420
LE158:	sBA	
	cmpA	CTSFILT
	bls	LE176

	ldaA	L0175
	beq	LE168
	dec	L0175
	jr	LE176
;
LE168:	bclr	FANMW, #%00011000
	jr	LE176
;
LE16D:	bset	FANMW, #%00010000
	ldaA	L842B	; = 0x00
	staA	L0175
;
LE176:	ret	
;
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x0D
; Called during initialisation
;
; Read the Battery Voltage
BATREAD:	
LE177:	ldaA	#VBATAtoD
	call	ReadAtoD	; A = ReadAtoD(0x08)
	staA	ADBAT     ; Save the Battery voltage
	cmpA	#$28      ; 0x28 = 4.0V
	bcs	LE19C     ; if (ADBAT < 4.0V) goto LE19C
	cmpA	#$5A      ; 0x5A = 9.0V
	bcs	LE19F     ; if (4.0V <= ADBAT < 9.0V) goto LE19F 
	ldD	#$0000    ; A:B = 0
	brclr	VBATMW,VBATMW_VLOW,LE197
			; if no previous VLOW detected, goto LE197
			
;This section is run only on the first time ADBAT is detected > 9.0V
	ldX	CNT_EST ; Read the hardware located at CNT_EST 
	stX	ESTFBCNT	  ; Store the value at ESTFBCNT
	staA	TC42B_COUNT ; TC42B_COUNT = 0
	
LE197:	bclr	VBATMW,VBATMW_VLOW 	; Clear the VBATLOW bit
	jr	LE19F     ; return
;
LE19C:	bset	VBATMW,VBATMW_VLOW	; Set the VBATLOW bit
LE19F:	ret	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x0E
;
LE1A0:	bclr	DIAGMW1, #%00011000	; clear %00001000 && 
	ldaB	TIMER_TICK
	andB	#%11110000
	bne	LE1B3
;
; Only do the following once per second, on the 0'th tick	
;
	bset	DIAGMW1,#%00001000
	brclr	TIMELSB, #%00000001, LE1B3
	bset	DIAGMW1, #%00010000
;
LE1B3:	brset	DIAGMW1, #%00000010, LE1DA
	bset	DIAGMW1, #%00000010
	inc	>STARTTIMES
	ldaA	STARTTIMES
	cmpA	L8399		; = 0x32 = 50. 50 Trouble free starts clears the trouble codes.
	bls	LE1DA
;
; We get here if the engine has been started 50 times without any TC's being detected. Therefore, the ECU can
; Assume that whatever the fault was, it has now been cured, and it's safe to clear the memory
;
 	clrA			; Clear [MALFWD1..MALFWD5]  = 0	
	ldX	#MALFWD1
	ldaB	#$05
LE1CA:	staA	0, X
	incX	
	decB	
	bne	LE1CA

	staA	STARTTIMES
	staA	BLINKMW
	staA	BLINK_INDEX
	incB	
	stD	CSUM_MALFWD	; Initialise the MALFWD checksum to 1 
	
LE1DA:	brclr	L0066, #%00010000, LE1F8
	bset	DIAGMW3, #%10000000
;
; If the engine isn't running, flash out BLINK codes
;
	brclr	MW1,#MW1_ENGRUN,LE1F0
;
;
;	
	call	LE372
;
; Initialise the blinkcode variables
;
	clrA	
	staA	BLINKMW
	staA	BLINK_INDEX
	jr	LE24D
;
; Decode the TC's into BLINK CODES
;
LE1F0:	bclr	L0056, #%00011000
	call	LE25A
	jr	LE24D
;
;
;
LE1F8:	bclr	DIAGMW3, #%10000000
	clrA	
	staA	BLINKMW
	staA	BLINK_INDEX
	bclr	L0056, #%00011000
	brclr	MALFDET3,#MALFDET3_TC51,LE219
	brclr	L0073, #%00000001, LE219
	bset	MALFWD3,#MALFWD3_TC51
	
	call	MALFWD_CSUM
	stD	CSUM_MALFWD
	
	bset	L0066, #L0066_CELON
	jr	LE24D
;
; if the engine isn't running, goto LE23E
;
LE219:	brclr	MW1,#MW1_ENGRUN,LE23E
;
	call	LE3C8

	ldY	#MALFWD5_MASK
	ldX	#$0005
	bclr	LCCPMW, #%00000010
LE22A:	ldaA	107, X
	andA	0, Y
	beq	LE234

	bset	LCCPMW, #%00000010
LE234:	decY	
	decX	
	bne	LE22A

	call	LE2DF	; Check for trouble and set codes
;
	jr	LE24D
;
; Turn the CEL lamp on
;
LE23E:	bset	L0066, #L0066_CELON
;
; Clear the MALFWD detected counts from [TC21_COUNT..TC31_COUNT]
;
	ldaB	#$0D
	clrA	
	ldX	#TC21_COUNT
LE247:	staA	0, X
	incX	
	decB	
	bne	LE247 
;
; Clear the MALFWD detected variables from [MALFDET1..MALFDET5]
;	
LE24D:	ldaB	#$05	
	clrA	
	ldX	#MALFDET1
LE253:	staA	0, X
	incX	
	decB	
	bne	LE253

	ret	
;
;********************************************************************************************************************
;
; This subroutine decodes any stored TC's, and controls L0066_CELON to blink these codes out on the CEL lamp
;
LE25A:	brclr	BLINKMW,#BLINKMW_MORE,LE2BD	; if this is the first pass, goto LE2BD

	dec	BLINK_TIMER
	bne	LE2DE			; if (BLINKTIMER != 0) bounce to return

	ldaB	#$04
	brset	L0066, #L0066_CELON, LE2D8	; if (we are blink on) goto LE2D8 with another 400mS blink off in B

	ldX	#BCDBLINK_CODE
	brclr	BLINKMW,#BLINKMW_LSBLINK,LE271
	incX				; if we are doing the LSChar then X++
		
LE271:	dec	0, X			; dec the blinks left to do
	bmi	LE27F			; if it's gone negative, we're done, goto LE27F
	
	bset	L0066, #L0066_CELON		; flag an blink on
	ldaB	#$04
	staB	BLINK_TIMER             	; blink-on time of 400 mS
	jr	LE2DE      		; bounce to return
;
; We get here once we've blinked out all of one of the characters - find out which one
;
LE27F:	brset	BLINKMW,#BLINKMW_LSBLINK,LE28A ; if we've just finished the LSChar, we're done, goto LE28A
					; else....
	bset	BLINKMW,#BLINKMW_LSBLINK	; switch to the LSChar
	ldaB	#$08			; blink-off time of 800mS
	jr	LE2D8			; bounce to flag blink-off and return
;
; We get here once we've blinked out both characters
;
LE28A:	bclr	BLINKMW,#BLINKMW_LSBLINK
	brclr	BLINKMW,#%00000011,LE296	; test to see if there are more repeats to go. If not goto LE296
	dec	>BLINKMW                	; Each TC is blinked out 3 times - decrement the counts to go
	jr	LE2C0                         ; reset the BLINK_INDEX and BCDBLINK_CODE
;
; We get here once we've blinked out both characters 3 times.
;
LE296:	ldaB	BLINK_INDEX
	cmpB	#$27		; there are only 0x27 (39) possible TC's
	bls	LE2A5		; if (BLINK_INDEX < 27), check for the next one 
	
	clr	BLINK_INDEX	; if (BLINK_INDEX >= 27), start again next time at zero 
	bclr	BLINKMW,#BLINKMW_MORE ; clear the more to do
	jr	LE2DB		; bounce to flag blink-off and return
;
LE2A5:	bitB	#%00000111
	bne	LE2B5		; if ((B & 0x7) != 0) then BLINK_MALFWD contains more bits to do
	                              
	lsrB			; if ((B & 0x7) == 0) then pick up the next MALFWD					
	lsrB	
	lsrB                          ; B = MALFWD number
	ldX	#MALFWD1		; X = &MALFWD1
	aBX			; index into the MALFWD's	
	ldaB	0, X		; pickup the current value of the chosen MALFWD
	staB	BLINK_MALFWD	; Store the chosen MALFWD
	
LE2B5:	inc	BLINK_INDEX	; Step to the next possible blinkcode
	lsl	BLINK_MALFWD	; shift the next possible trouble code into the carry bit
	bcc	LE296               ; if no carry, then this TC is not set, so goto LE296, and try again
	
LE2BD:	bset	BLINKMW,#%00000010	; Set the blink repeat count to 2 - causes the codes to be blinked out 3 times

LE2C0:	ldaB	BLINK_INDEX	; B = Current blinkcode index
	ldX	#LEF97		; Blink code BCD table
	aBX			; Add on the blinkcode index	
	ldaA	0, X		; A = BCD code for current blinkcode
	tAB			; B = A	
	andB	#%00001111 	; B = LSChar of blinkcode
	lsrA	
	lsrA	
	lsrA	
	lsrA			; A = MSChar of blinkcode	
	stD	BCDBLINK_CODE	; Save the LSchar and MSchar
	
	ldaB	#$1C		; inter blinkcode gap = 2800 mS ?
	bset	BLINKMW,#BLINKMW_MORE ; set the more to do bit

LE2D8:	staB	BLINK_TIMER

LE2DB:	bclr	L0066,#L0066_CELON	; flag an blink off

LE2DE:	ret	
;
;********************************************************************************************************************
;
LE2DF:	ldY	#MALFWD5_MASK
	clrA	
	ldX	#$0005
LE2E7:	oraA	112, X
	decX	
	bne	LE2E7
	tstA	
	bne	LE310
	ldX	#$0005
LE2F2:	ldaA	107, X
	andA	0, Y
	staA	112, X
	decY	
	decX	
	bne	LE2F2
	ldaA	L018E
	beq	LE308
	dec	L018E
	jr	LE371
;
LE308:	bclr	L0066, #L0066_CELON
	bclr	LCCPMW, #%00000100
	jr	LE371
;
LE310:	ldX	#$0005
	clrA	
LE314:	ldaB	107, X
	andB	112, X
	andB	0, Y
	staB	112, X
	oraA	112, X
	decY	
	decX	
	bne	LE314
	inc	L018E
	ldX	#L839A
	brclr	L0066, #L0066_CELON, LE330
	incX	
	incX	
LE330:	tstA	
	beq	LE334
	incX	
LE334:	ldaB	0, X
	cmpB	L018E
	bcc	LE371
	staB	L018E
	tstA	
	beq	LE371
	ldaA	L839C
	staA	L018E

	clrB
	ldY	#$0173
	ldX	#$0005
LE34F:	ldaA	2, X	; A = [0x0002..0x0007] 
	oraA	112, X    ; A = A | [0x006C..0x0070]
	staA	2, X      ; [0x0002..0x0007] = A

	ldaA	0, Y	; A = [0x016F..0x0173]
	oraA	112, X    ; A = A | [0x006C..0x0070]
	staA	0, Y	; [0x016F..0x0173] = A
	staB	112, X    ; [0x006C..0x0070] = 0
	
	decY	
	decX	
	bne	LE34F
	
	staB	STARTTIMES
	
	call	MALFWD_CSUM
	stD	CSUM_MALFWD
	
	bset	L0066, #L0066_CELON
	bset	LCCPMW, #%00000100
LE371:	ret	
;
LE372:	brclr	MWFA1, #%10000000, LE37E
	brset	L0056, #%00001000, LE38C
	brset	DIAGMW1,#%00001000,LE3A5
LE37E:	ldaA	L0056
	andA	#%11110111
	xorA	#%01000000
	staA	L0056
	brclr	L0056, #%01000000, LE3B8
	jr	LE3C4
;
LE38C:	brclr	DIAGMW1,#%00001000,LE3C4
	brset	LHFLMW, #%00100000, LE399
	bclr	RHFLMW, #%00100000
	jr	LE3A8
;
LE399:	bclr	LHFLMW, #%00100000
	brclr	RHFLMW, #%00100000, LE3A8
	bclr	RHFLMW, #%00100000
	jr	LE3B8
;
LE3A5:	bset	L0056, #%00001000
LE3A8:	brset	LHFLMW,#LHFLMW_RICH,LE3B2
	brclr	RHFLMW,#RHFLMW_RICH,LE3BC
	jr	LE3C4
;
LE3B2:	brset	RHFLMW,#RHFLMW_RICH,LE3C1
	jr	LE3C4
;
LE3B8:	brclr	L0066, #L0066_CELON, LE3C1
LE3BC:	bclr	L0066, #L0066_CELON
	jr	LE3C4
;
LE3C1:	bset	L0066, #L0066_CELON
LE3C4:	bclr	BLINKMW, #%11111111
	ret	
;
LE3C8:	brclr	DIAGMW1, #%00100100, LE3CE ; if ((DIAGMW1_TC21 && DIAGMW1_TC22) == 0) test for lambda sensor errors
	jr	LE407		; else skip
;
; Begin TC13 Checking (Front O2 Sensor Failed)
;
LE3CE:	ldX	TIMERUN
	cmpX	KKO2MPTI		; = 0x0078 = 120 seconds
	bcs	LE407		; if (TIMERUN < 120 sec) goto E407
	
	ldaA	TC13_COUNT
	
	ldaB	ADLO2FILT
	cmpB	KKO2HIGH		; = 0x7C = 0.55V
	bhi	LE407		; if (ADLO2FILT > 0.55V) goto E407
	
	cmpB	KKO2LOW		; = 0x4F = 0.35V
	bls	LE407		; if (ADLO2FILT < 0.35V) goto E407
	
	cmpA	KKO2OLTM		; = 0x0F
	bhi	LE40A		; if (TC13_COUNT > 15) log a TC13 
	
	brclr	DIAGMW1, #%00010000, LE410
	
	ldaB	CTSFILT
	cmpB	KKO2CT		; = 0x99 = 74.75 DegC
	bls	LE410		; if (CTSFILT < 74.75C) goto LE410
	
	ldaB	NTPSLD
	cmpB	KKO2LOD		; = 0x0D = 5%
	bhi	LE404		; if (NTPSLD > 5%) goto LE404
	
	tstA	
	beq	LE410		; if (TC13_COUNT == 0) don't decrement it !
	decA			; TC13_COUNT--	
	jr	LE410
;
LE404:	incA			; TC13_COUNT++	
	jr	LE410
;
LE407:	clrA	
	jr	LE410
;
LE40A:	bset	MALFDET1,#MALFDET1_TC13
	bset	DIAGMW3,DIAGMW3_TC13

LE410:	staA	TC13_COUNT	; store new TC13_COUNT
;
; Begin TC16 Checking (Wastegate Overboost)
;
	brclr	DIAGMW5,#DIAGMW5_OVBSTTM,LE43A

	brset	DIAGMW5,DIAGMW5_TC16,LE42F ; if (overboost already detected) goto LE42F
	
	ldaA	TC16_COUNT
	cmpA	KK16TIME		; = 0x1E = 30
	bhi	LE428		; if (TC16_COUNT > 30) goto LE428
	
	inc	TC16_COUNT	; TC16_COUNT++
	jr	LE44D
;
LE428:	ldaA	ADMAPLAG
	cmpA	KK2ATM33		; = 0xE9 = 1.9 Bar
	bhi	LE437               ; if (ADMAPLAG > 1.9 Bar) flag TC33
	                              ; else..
LE42F:	bset	MALFDET1,#MALFDET1_TC16 ; flag TC16
	bset	DIAGMW5,#DIAGMW5_TC16
	jr	LE43A
;
LE437:	bset	MALFDET2,#MALFDET2_TC33

LE43A:	ldaA	M33CNT
	cmpA	KKM33CNT
	bhi	LE447
	
	inc	M33CNT
	jr	LE44D
;
LE447:	clr	TC16_COUNT
	bclr	DIAGMW5, #%00000011	; clear DIAGMW5_TC16 && DIAGMW5_OVBSTTM
;
; Begin TC21 Checking (TPS Voltage High)
;
LE44D:	ldaA	TC21_COUNT

	ldaB	ADTHROT
	cmpB	KKTA21	; 0x80 = 2.5V
	bls	LE467	; if (ADTHROT < 2.5V) goto LE467

	cmpA	KK21TIM	; = 0x32 = 50
	bhi	LE46D	; if (ADTHROT > 2.5V) for more than 50 counts, set MALFDET_TC21

	ldaB	L00A4
	cmpB	KKRM21
	bcc	LE46A

	incA		; TC21_COUNT++	
	jr	LE473	; store TC21_COUNT
;
LE467:	bclr	DIAGMW1,DIAGMW1_TC21
;
LE46A:	clrA		; TC21_COUNT = 0	
	jr	LE473
;
LE46D:	bset	MALFDET1,MALFDET1_TC21
	bset	DIAGMW1,DIAGMW1_TC21

LE473:	staA	TC21_COUNT
;
; Begin TC24 (No Vehicle Speed Signal)
;
	bclr	L0067,#L0067_TC24	; clear L0067_TC24
	ldaA	TC24_COUNT

	ldaB	MPH
	cmpB	KKVSPD		; = 3 MPH
	bhi	LE4AA		; if (MPH > 3) goto LE4AA (all ok)

	cmpA	KKVST		; = 0.3 Seconds
	bhi	LE4B4		; if (TC24_COUNT > 0.3 Sec) flag TC24
	
	ldaB	NMAP0
	cmpB	KK24MAP		; = 0.18 Bar
	bcc	LE4AA		; if (NMAP0 > 0,18Bar) goto LE4AA
	
	brclr	DIAGMW1, #%00100100, LE496  ; if ((DIAGMW1_TC21 && DIAGMW1_TC22) == 0) test for ???
	jr	LE4AA		; else skip
;
LE496:	ldaB	NTPSLD
	cmpB	KK24TPS		; = 0.2%
	bcc	LE4AA		; if (NTPSLD > 0.2%) goto LE4AA
	
	ldaB	RPM
	cmpB	KKVRPMLA		; = 1000 RPM
	bls	LE4AA		; if (RPM < 1000) goto LE4AA
	
	cmpB	KKVRPMH		; = 6000 RPM
	bls	LE4AD               ; if (RPM < 6000) count up

LE4AA:	clrA			; TC24_COUNT = 0	
	jr	LE4BA
;
LE4AD:	brclr	DIAGMW1, #%00001000, LE4BA
	incA			; TC24_COUNT++	
	jr	LE4BA
;
LE4B4:	bset	MALFDET2,#MALFDET2_TC24 ; flag TC24
	bset	L0067,#L0067_TC24
;
LE4BA:	staA	TC24_COUNT
;
; Begin TC31 Checking (Cam/Crank sensor error)
;
	brclr	VBATMW, #%00100000, LE513
	ldX	TC31_COUNT
	brset	DIAGMW4, #%10000000, LE501
	brclr	SEQMW1, #%00000010, LE4E4
	brset	DIAGMW4, #%00100000, LE4D5
	bset	DIAGMW4, #%01100000
	jr	LE501
;
LE4D5:	brset	DIAGMW4, #%01000000, LE501
	cmpX	L83C3
	bhi	LE501
	bclr	SEQMW1, #%10000010
	incX	
	jr	LE510
;
LE4E4:	bset	DIAGMW4, #%00100000
	brclr	SEQMW1, #%00000001, LE506
	cmpX	L83C5
	bhi	LE4F6
	bclr	SEQMW1, #%10000001
	incX	
	jr	LE510
;
LE4F6:	ldD	L3DFC
	oraB	#%00001000
	bset	DIAGMW4, #%10000000
	stD	L3DFC
LE501:	bset	MALFDET2,#MALFDET2_TC31
	jr	LE513
;
LE506:	brclr	SEQMW1, #%10000000, LE513
	bclr	SEQMW1, #%10000000
	ldX	#$0000
LE510:	stX	TC31_COUNT
;
; Begin TC33 (High MAP Sensor Voltage/Pressure)
;
LE513:	brset	DIAGMW5,DIAGMW5_TC66,LE54C ; If TC66 detected, don't set TC33

	ldaA	DIAGMW1
	bitA	#%00100100
	bne	LE547		; if TC21 or TC22 detected, don't set TC33 
	
	brset	DIAGMW5,DIAGMW5_TC16,LE547

	ldaA	KKPM33		; 0xEC = 1.90 Bar
	brset	MW1,#MW1_ACCUTOFF,LE52B
	ldaA	KKPMAC33		; 0xEC = 1.90 Bar

LE52B:	cmpA	ADMAP
	bhi	LE544		; if (ADMAP < 1.9 Bar) goto LE544

	ldaA	TC33_COUNT
	cmpA	KK33TIME		; 0x04 = 0.4 Seconds
	bcc	LE54C		; if (TC33_COUNT >= 0x04) set TC33
	
	ldaA	NTPSLD
	cmpA	KKTA33		; = 0x08 = 3.125%
	bcc	LE547		; if (NTPSLD > 3.125%) goto LE547
	
	inc	TC33_COUNT 	; TC33_COUNT ++ 
	jr	LE552
;
LE544:	bclr	DIAGMW4,DIAGMW4_TC33	; clear TC33

LE547:	clr	TC33_COUNT 	; TC33_COUNT = 0
	jr	LE552
;
LE54C:	bset	MALFDET2,MALFDET2_TC33 ; flag TC33
	bset	DIAGMW4, DIAGMW4_TC33
;
; Start TC41
;
LE552:	bclr	DIAGMW2,DIAGMW2_TC41

	ldaB	FMD2
	andB	#FMD2_CYLSEL
	cmpB	KK41CYLSEL
	beq	LE564

	bset	MALFDET3,MALFDET3_TC41
	bset	DIAGMW2, DIAGMW2_TC41
;
; Start TC42
;
LE564:	brset	MW3,#MW3_SPARK_BK,LE590
	brset	TIMER_TICK, #%00010000, LE590
	brclr	MW1, #%01000000, LE590

	ldaA	RPM
	cmpA	KK42RM
	bls	LE58A

	ldaA	TC42B_COUNT
	bne	LE58A

	brset	DIAGMW1, #%00000001, LE585
	bset	DIAGMW1, #%00000001
	jr	LE58D
;
LE585:	bset	NVRAMWD1, #%00000100
	jr	LE58D
;
LE58A:	bclr	DIAGMW1, #%00000001
;
LE58D:	clr	TC42B_COUNT
;
LE590:	brset	LCCPMW, #LCCPMW_TC43, LE598
	brclr	NVRAMWD1, #%10000000, LE59B
;
LE598:	bset	MALFDET3,#MALFDET3_TC43
;
; Start TC44
;
LE59B:	bclr	DIAGMW3,DIAGMW3_TC44

	ldaA	TC44_COUNT
	ldaB	LO2FILT
	cmpB	KKO2MIN	; 0.2V
	bhi	LE5BD

	cmpA	KK44TIM	; 60 Sec
	bhi	LE5C0

	brclr	MWFA1, #%10000000, LE5BD
	brset	DIAGMW3,DIAGMW3_INTRST,LE5BD
	brclr	DIAGMW1, #%00001000, LE5C6
	incA	
	jr	LE5C6
;
LE5BD:	clrA	
	jr	LE5C6
;
LE5C0:	bset	MALFDET3,#MALFDET3_TC44
	bset	DIAGMW3,DIAGMW3_TC44

LE5C6:	staA	TC44_COUNT
;
; Start TC45
;
	ldaA	TC45_COUNT
	cmpB	KKO2MAX		; = 0.75V
	bls	LE5F2

	cmpA	KK45TIM		; = 30 Sec
	bhi	LE5F5

	brclr	MWFA1, #%10000000, LE5F2
	brset	DIAGMW3,DIAGMW3_INTRST,LE5F2

	ldaB	NTPSLD
	cmpB	KK45TPH		; = 20%
	bhi	LE5EB

	cmpB	KK45TPL		; = 2.7%
	bcc	LE5F2

LE5EB:	brclr	DIAGMW1, #%00001000, LE5FB
	incA	
	jr	LE5FB
;
LE5F2:	clrA	
	jr	LE5FB
;
LE5F5:	bset	MALFDET3,MALFDET3_TC45
	bset	DIAGMW3, DIAGMW3_TC44
LE5FB:	staA	TC45_COUNT                  
;
; Start TC63
;
	brclr	DIAGMW1, #%00100100, LE604 ; if ((DIAGMW1_TC21 && DIAGMW1_TC22) == 0) test for lambda sensor errors
	jr	LE63D		; else skip
;
LE604:	ldX	TIMERUN
	cmpX	KKO2MPTI		; = 0x0078 = 120 seconds
	bcs	LE63D		; if (enginerunning < 120 sec) goto LE63D
	
	ldaA	TC63_COUNT
	
	ldaB	ADRO2FILT
	cmpB	KKO2HIGH		; = 0x7C = 0.55V
	bhi	LE63D		; if (ADRO2FILT > 0.55V) goto E63D
	
	cmpB	KKO2LOW		; = 0x4F = 0.35V
	bls	LE63D		; if (ADRO2FILT < 0.35V) goto E63D
	
	cmpA	KKO2OLTM		; = 0x0F
	bhi	LE640		; if (TC63_COUNT > 15) log a TC63
	
	brclr	DIAGMW1, #%00010000, LE646
	
	ldaB	CTSFILT
	cmpB	KKO2CT		; = 0x99 = 74.75 DegC
	bls	LE646		; if (CTSFILT < 74.75C) goto LE646
	
	ldaB	NTPSLD
	cmpB	KKO2LOD		; = 0x0D = 5%
	bhi	LE63A		; if (NTPSLD > 5%) goto LE63A

	tstA	
	beq	LE646		; if (TC63_COUNT == 0) don't decrement it !
	decA			; TC63_COUNT--	
	jr	LE646
;
LE63A:	incA			; TC63_COUNT++	
	jr	LE646
;
LE63D:	clrA	
	jr	LE646
;
LE640:	bset	MALFDET4,MALFDET4_TC63	; Flag a TC63
	bset	DIAGMW4, DIAGMW4_TC63
;
LE646:	staA	TC63_COUNT
;
; Start TC64
;
	bclr	DIAGMW4,DIAGMW4_TC64
	ldaA	TC64_COUNT
	
	ldaB	RO2FILT
	cmpB	KKO2MIN		; 0.2V
	bhi	LE66B
	
	cmpA	KK44TIM		; = 60 Sec
	bhi	LE66E
	
	brclr	MWFA1, #%10000000, LE66B
	brset	DIAGMW3,DIAGMW3_INTRST,LE66B
	brclr	DIAGMW1, #%00001000, LE674
	incA	
	jr	LE674
;
LE66B:	clrA	
	jr	LE674
;
LE66E:	bset	MALFDET5,#MALFDET5_TC64
	bset	DIAGMW4,DIAGMW4_TC64
LE674:	staA	TC64_COUNT
;
; Start TC65
;
	ldaA	TC65_COUNT
	cmpB	KKO2MAX
	bls	LE6A0

	cmpA	KK45TIM
	bhi	LE6A3

	brclr	MWFA1, #%10000000, LE6A0
	brset	DIAGMW3,DIAGMW3_INTRST,LE6A0

	ldaB	NTPSLD
	cmpB	KK45TPH
	bhi	LE699

	cmpB	KK45TPL
	bcc	LE6A0

LE699:	brclr	DIAGMW1, #%00001000, LE6A9
	incA	
	jr	LE6A9
;
LE6A0:	clrA	
	jr	LE6A9
;
LE6A3:	bset	MALFDET5,#MALFDET5_TC65
	bset	DIAGMW4,DIAGMW4_TC64
LE6A9:	staA	TC65_COUNT
;
; Start TC66
;
	bclr	DIAGMW3, DIAGMW3_INTRST
	brclr	WGATEMW, WGATEMW_TC66,LE6B6
	bset	MALFDET5,MALFDET5_TC66
;
LE6B6:	ret
;	
;**********************************************************************
; Called once every 100mS, on (TIMER_TICK & 0x0F) == 0x0F
;
LE6B7:	brset	TIMER_TICK, #%00010000, LE6BE
	jmp	LE74D
;
LE6BE:	brset	MW1,#MW1_ENGRUN,LE730
	brset	NVRAMWD1, #%00001000, LE702
	
	ldaA	CTS116MAX
	ldX	#F54
	call	LOOKUP1DBY16
	clrB	
	stD	AFRCTS
	
	ldX	#L832B
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	subA	L832A	; = 0x55
	staA	L000C
	
	ldX	#L833B
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	
	ldX	#L8339	; = 0x1DFF
	call	MULT8BY16
	stD	L000E
	
	ldX	#L85A8
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	
	ldX	#L85A6	; = 0x0A00
	call	MULT8BY16
	stD	L000A
	
LE702:	ldX	#L8357
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	tAB	
	clrA	
	stD	L00B1
	
	ldX	#L85C4
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L00AE
	
	ldX	#L85B6
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L00AF
	
	ldX	#L8349
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L00B3
	
LE730:	ldX	#L85D3
	ldaA	CTS116MAX
	call	LOOKUP1DBY16
	staA	L0158

	ldX	#L897E
	ldaA	CTSFILT
	call	LOOKUP1DBYN
	staA	L00DF
	
	cmpA	L00DC
	bcc	LE74D
	staA	L00DC

LE74D:	ldaA	NTPSLD
	brclr	MWFA1, #%00001000, LE765
	brset	CLCCMW, #%00100000, LE78B

	cmpA	L844D	; = 90 %
	bls	LE765

	bset	CLCCMW, #%00100000
	clr	L01B8
	jr	LE7A3
;
LE765:	ldaA	NMPH
	cmpA	L844E
	bhi	LE7A0
	
	cmpA	L844F
	bcs	LE7A0
	
	ldaA	NTRPMX
	cmpA	L8450	; = 0xFF = 6350 RPM
	bhi	LE7A0
	
	cmpA	L8451	; = 0x58 = 2200 RPM
	bcs	LE7A0
	
	ldaA	L01B9
	cmpA	L8452
	bls	LE798
	
	bset	MWFA1, #%00001000
	jr	LE7A3
;
LE78B:	cmpA	L844D	; = 90%
	bcs	LE79D

	ldaA	L01B9
	cmpA	L8453
	bcc	LE79D

LE798:	inc	L01B9
	jr	LE7A6
;
LE79D:	bclr	CLCCMW, #%00100000

LE7A0:	bclr	MWFA1, #%00001000

LE7A3:	clr	L01B9

LE7A6:	ret	
;**********************************************************************
;   
DOIACV:
LE7A7:	ldX	#$8936
	brset	MALFDET3,MALFDET3_TC51,LE7B6
	brset	VBATMW,VBATMW_VLOW,LE7C2
	brset	IACMW2,IACMW2_IACV_RESET,LE7C2
LE7B6:	brset	MW1,MW1_ENGRUN, LE7C5
	brclr	DIAGMW3, #%10000000, LE7C2
	ldaB	#$81
	staB	ISSPMP_DELTA
LE7C2:	jmp	LE84F
;
LE7C5:	ldaB	ADBAT
	cmpB	#$AB
	bhi	LE7D0		; if (ADBAT > 17.1 V) bounce to LE8D0 
	
	cmpB	#$5A
	bhi	LE7D3		; if (ADBAT > 9.0 V) goto LE7D3
	
LE7D0:	jmp	LE8D0               ; if (ADBAT <= 9.0 V) goto LE8D0
;
; We get here if (9.0 < VBAT < 17.1)
;
LE7D3:	brset	IACMW2, #%00001000, LE7FB
	ldaB	L8938
	addB	L00DF
	bcs	LE7E7
	
	brclr	FMD1,#FMD1_ACREQ,LE7E9

	addB	L8939
	bcc	LE7E9
LE7E7:	ldaB	#$FF
LE7E9:	call	IACVADJUST

	ldaA	L00D8
	incA	
	cmpA	5, X
	bls	LE84D

	bset	IACMW2, #%00001000
	clr	>L00D8
	jr	LE81B
;
LE7FB:	brset	IACMW2, #%00100000, LE84F
	brset	IACMW1, #%00010000, LE80B
	brset	IACMW1, #%00001000, LE84F
	brset	IACMW1, #%00000100, LE81B
LE80B:	ldaA	ISSPMP_DELTA
	bpl	LE81B
	brset	IACMW1, #%00100000, LE81B
	dec	>L00D8
	beq	LE81B
	jmp	LE8FC
;
LE81B:	ldaA	MPH
	cmpA	#$20    	; 32 MPH
	bcs	LE824
	ldaA	#$FF
LE824:	lslA	
	lslA	
	lslA	
	ldaB	44, X
	mul	
	addA	43, X
	bcs	LE848
	brset	IACMW1, #%00000100, LE84D
	lslA	
	bcs	LE848
	pushA	
	ldaB	RPMFILT
	subB	ISESDD
	clrA	
	lslD	
	lslD	
	tstA	
	bne	LE84C
	comB	
	ldaA	45, X
	mul	
	popB	
	aBA	
	bcc	LE84D
LE848:	ldaA	#$FF
	jr	LE84D
;
LE84C:	popA	
LE84D:	staA	L00D8
LE84F:	bclr	IACMW2, #IACMW2_ALDL_IACV

	brclr	VBATMW,#VBATMW_HUD,LE859
	call	L5806
;
; Check for ALDL Mode 4 IACV control
;
LE859:	brclr	ALDLMW,#ALDLMW_STARTMD4, LE87D
	ldaA	ALDLMD_FMCW
	bitA	#ALDL_FMCW_IACMOD
	beq	LE87D		; if ALDL isn't requesting IACRPM goto LE87D
	bitA	#ALDL_FMCW_IACRPM
	bne	LE87D               ; if ALDL isn't requesting IAC control goto LE87D
	
	ldaA	ISSPMP
	subA	ALDLMD_IACRPM	; A = ISSPMP - desiredIAC
	bcc	LE870
	negA			; if (desired > current) A=0-A
		
LE870:	bpl	LE874
	ldaA	#$7F 		; limit deltaIACV to 0x7F
LE874:	bcs	LE878
	oraA	#%10000000	; if delta is -ve, flag this in bit 8
	
LE878:	staA	ISSPMP_DELTA	; store the desired IAC change
	bset	IACMW2,#IACMW2_ALDL_IACV ; Flag that ALDL has IAC Control
;
LE87D:	ldaB	ISSPMP_DELTA
	lslB	
	beq	LE8AB
	dec	>ISSPMP_DELTA
	ldaB	ISSPMP
	bcc	LE891
	beq	LE88C
	decB	
LE88C:	dec	>L00DD
	jr	LE89A
;
LE891:	cmpB	56, X
	bcc	LE8AB
	incB	
	inc	>L00DD
	clc	
LE89A:	staB	ISSPMP
	brclr	IACMW1, #%00010000, LE8AB
	ldaB	L00D9
	incB	
	bcc	LE8A9
	decB	
	beq	LE8A9
	decB	
LE8A9:	staB	L00D9
LE8AB:	brclr	IACMW1, #%00001000, LE8B2
	inc	>L00E1
LE8B2:	ldaB	ISSPMP
	cmpB	56, X
	bls	LE8BC
	ldaB	ISSPMP_DELTA
	bpl	LE8D0
	
LE8BC:	ldaB	L00DD
	ldX	#IAC_PHASES
	andB	#IACV_DRIVE ; filter off the desired IAC phase
	aBX		; index into the IAC_PHASES table
		
	di	
	ldaA	IO_PORTA
	andA	#NOT_IACV_DRIVE
	addA	0,X	; set the IACV_DRIVE bits
	staA	IO_PORTA
	ei
		
LE8D0:	ldaB	L00DC
	addB	L00D9
	bcc	LE8D8
	ldaB	#$FF
LE8D8:	tBA	
	ldaB	L00E1
	brclr	LCCPMW, #%01000000, LE8E0
	negB	
LE8E0:	aBA	
	tAB	
	ldaA	ISSPMP
	sBA	
	staA	L00E2
	ldaB	ISSPMP
	subB	L00E2
	ldaB	#$80
	bcc	LE8F5
	cBA	
	bhi	LE8FA
	incB	
	jr	LE8F9
;
LE8F5:	cBA	
	bcs	LE8FA
	decB	
LE8F9:	tBA	
LE8FA:	staA	L00E2
LE8FC:	ret	
;
;**********************************************************************
;
;Read the TPS Value
;
TPSREAD:
LE8FD:	ldaA	#TPSAtoD
	call	ReadAtoD
	staA	ADTHROT
	
	ldaB	MALFWD1_MASK
	bitB	#MALFWD1_TC21
	beq	LE917	; if (TC21 disabled) goto E917

	; We get here if TC21 error checking is enabled (it is)
	cmpA	KKTA21A	; KKTA21A == 255, so ...
	bls	LE917     ; this jump be taken if ADTHROT < 255
	
	bset	DIAGMW1,#DIAGMW1_TC21
	bset	MALFDET1,#MALFDET1_TC21

LE917:	brclr	DIAGMW1,#%00100100,LE91E ; jump if no TC21 or TC22
	ldaA	KKTPDF 		; use KKTPDF during TC21 & TC22
	
LE91E:	pushA	          ; Save TPS on stack
;
; Lower TPS Filtering for TPS offset - see TurboP4.pdf 2.4.3.1
;
	cmpA	ADTAOFF
	bhi	LE930	; if (TPS > MINPS) goto LE930
	
	ldX	ADTAOFF
	ldaB	KTAOFF
	call	LAGFILTER
	stD	ADTAOFF	; filter in TPS to Lower TPS
;
; Throttle Position Load (NTPSLD) Calculation - see TurboP4.pdf 2.4.3
;
LE930:	ldD	ADTAOFF	; A:B = ADTAOFF	
	addd	#$0080	; Round the MSByte of ADTAOFF
	tAB		; B = MSByte of ADTAOFF	
	popA	          ; A = Current ADTHROT from stack

	sBA		; A = (ADTHROT-ADTAOFF)	          ; 
	bcc	LE93C
	clrA		; make sure A >= 0
		
LE93C:	ldaB	K3	; 0x44 = 68 = NTPSLD gain calibration
	mul
		
	addd	#$0020	; Round up the LSBit of the result

	lslD		; Multiply A:B * 4, and limit A to 0xFF	
	bcs	LE949
	lslD	
	bcc	LE94B
LE949:	ldaA	#$FF

LE94B:	staA	NTPSLD	; Store the new NTPSLD

	ldX	NTPSLDFILT
	ldaB	KNTPSLDFILT
	call	LAGFILTER
	stD	NTPSLDFILT

	bclr	DIAGMW1, #%00100000
	brclr	MW1,#MW1_ENGRUN, LE978
	
	ldaA	MALFWD1_MASK
	bitA	#MALFWD1_TC22
	beq	LE981	; if (TC22 not Enabled) goto E981

	ldaA	ADTHROT
	cmpA	KKTA22
	bcc	LE981	; if (ADTHROT >= KKTA22) goto LE981

	bset	MALFDET1,#MALFDET1_TC22
	bset	DIAGMW1,#DIAGMW1_TC22
	jr	LE981	; ret
;
LE978:	ldaA	K4	; A = 0x0D
	staA	ADTAOFF
	clr	ADTAOFF_LSB

LE981:	ret	
;
;**********************************************************************
;
; Called when ALDL byte is received from TECH 1
;
ALDL_RX:
LE982:	ldaB	ALDL_FLAG_REG
	ldaA	ALDL_RXD_REG
	ldX	ALDL_PTABLE
	clr	ALDL_AWAKE_TIME
	bitB	#%00001110	; ALDL_FE | ALDL_NF | ALDL_OE
	bne	LE9F7		; if (ALDL_FE | ALDL_NF | ALDL_OE) goto LE9F7 - an error has occured
	
	tAB	
	addB	ALDL_CSUM
	staB	ALDL_CSUM		; Add the latest character to the checksum
	
	ldaB	ALDL_COUNT
	bne	LE9BC		; if (ALDL_COUNT != 0) goto LE9BC - we are already in an ALDL command
	
	ldX	#L89E6		; ALDL Pre-Wakeup command control block
	brclr	ALDLMW,#ALDLMW_TEST,LE9A8
	ldX	#LED03		; ALDL Post-Wakeup command control block
;
; At this point, X points to a linked list of ALDL control blocks. Traverse the linked list looking
; for the correct messageID
; 	
LE9A8:	cmpA	2, X		; Compare the first byte received with the tables MESSAGEID 
	beq	LE9B2		; if it matches, we've found what we're looking for. Goto LE9B2
	ldX	0, X		; Pick up the link to the next control block
	bne	LE9A8		; Loop while (next control block != NULL)
	jr	LE9F7               ; We've got a NULL pointer, and haven't found the desired MESSAGEID. Bomb out
;
; At this point, X points to the correct ALDL message control block for the requested MESSAGEID
;
LE9B2:	stX	ALDL_PTABLE	; Store the address of the message control block
	ldaA	#$25
	staA	SCI_CTRL_REG	; 0x25 = enable SCI_RDRF & SCI_EXTIRQ & SCI_RWU
	jr	LE9F2               ; inc ALDL_COUNT and return
;
; We get here if (ALDL_COUNT != 0)
;
LE9BC:	decB			; B = ALDL_COUNT - 1	
	bne	LE9C8		; if (ALDL_COUNT != 1) goto LE9C8
;
; We get here if (ALDL_COUNT == 1). This is the second character, which is MESSAGE_LEN
;
	subA	#$55		; Subtract the fixed offset. Message lengths are offset by 0x55
	bcs	LE9F7		; if there is a carry, then the message length is -ve ! Bomb out.
	
	staA	ALDL_BYTES_TODO
	jr	LE9F2               ; inc ALDL_COUNT and return
;
; We get here if (ALDL_COUNT >= 2)
;
LE9C8:	decB			; B = ALDL_COUNT - 2	
	cmpB	ALDL_BYTES_TODO
	bcc	LE9F9               ; if we have received all the bytes we were expecting, goto LE9F9
	
	tstB	
	bne	LE9ED		; if (ALDL_COUNT != 2) goto LE9ED
;
; We get here if (ALDL_COUNT == 2). This is the third character, which is MESSAGE_MODE
;
	brclr	L0066,#L0066_ALDL_AWAKE,LE9ED
	
	cmpA	#$07
	bhi	LE9F7		; if (MESSAGE_MODE > 7) bomb out.
	
	beq	LE9E8		; if (MESSAGE_MODE == 7) goto LE9E8.
	
	cmpA	#$04
	bhi	LE9F7		; if (MESSAGE_MODE > 7) bomb out.
	
	pushB			; Save (ALDL_COUNT-2) silly really, coz (B == 0)	
	tAB	                    ; B = A = MESSAGE_MODE
	lslB	                    ; B = B * 2, we're gonna index into a WORD table
	aBX	                    ; X = X + (MODE * 2)
	popB			; Restore B.
		
	ldX	9, X                ; The addresses of the Mode control blocks are stored immediatley after
	jr	LE9EA               ; The block for MODE 0 - i.e at MODE0+9 !!!
;
; We get here if (ALDL_COUNT == 2), and (MESSAGE_MODE == 7)
;
LE9E8:	ldX	19, X		; Cludge X to point to the message control block for MESSAGE_MODE 5
;
; We get here always if (ALDL_COUNT == 2), and there's more data to come
;
LE9EA:	stX	ALDL_PTABLE	; Store the address of the mode control block for the requested MODE
;
; We get here always (assuming there are no errors)
;
LE9ED:	ldX	7, X		; X = Address of functions input buffer
	aBX	                    ; Add on (ALDL_COUNT - 2) as an offset into the buffer
	staA	0, X		; Store the received character in the buffer

LE9F2:	inc	ALDL_COUNT	; inc the count of bytes RX'ed
	jr	LEA6C		; ret
;
;**********************************************************************
;
LE9F7:	jr	ALDL_CLEANUP	; Bounce forward to LEA5F
;
;**********************************************************************
;
; We get here when we've received all the ALDL bytes we were expecting
; At this point X -> Message control block
;
LE9F9:	ldaB	ALDL_CSUM
	bne	ALDL_CLEANUP	; If checksum didn't work
	
	ldaA	2, X		; Pick up the MESSAGE_ID from the control block
	staA	ALDL_MSGID
	
	ldaA	ALDL_BYTES_TODO
	beq	LEA16		; If there were no input bytes, goto LEA16
	
	ldX	#$0204		; If there were input bytes, 
LEA0B:	ldaB	0, X                ; copy them from 0x0204 to 0x0204 + 34 = 0x0226
	staB	34, X
	incX	
	decA	
	bne	LEA0B                                         
	
	ldX	ALDL_PTABLE	; restore X after the copy
	
LEA16:	brset	ALDLMW,#ALDLMW_TEST, LEA29	; if we're in funny mode, goto LEA29
	brclr	L0066,#L0066_ALDL_AWAKE,LEA26 ; if we aren't awake yet, goto LEA26 
	
	bclr	L0066,#L0066_ALDL_AWAKE	; if (ALDL_MODE == 0) clear the AWAKE bit
	tst	ALDL_MODE                     ; if (ALDL_MODE != 0) det the AWAKE bit
	beq	LEA29
LEA26:	bset	L0066,#L0066_ALDL_AWAKE

LEA29:	brset	4,X,#%10000000,ALDL_CLEANUP 	; if (bit 8 of mode_ctrl_blk[4]) then there is no data out 

	ldaA	ALDL_MODE		; Get the requested ALDL mode
	cmpA	#$07      	; If it's not mode 7
	bne	LEA40       	; Goto LEA40
	                    
	                    	; Execute ALDL Mode 7
	ldX	#F90MST		; Normal mode ALDL schedule table
	ldaB	L0227		; Get the index of the desided frame
	lslB			; Double it - F90MST is a 16bit table	
	call	ALDL_MODE7          ; Initiate the Mode 7 TX stuff
	jr	LEA6C               ; return
;
; Send the MESSAGE_ID of from the requested control block
;
LEA40:	ldaA	2, X		; X[2] = the MESSAGE_ID
	staA	ALDL_TXD_REG        ; Transmit the MESSAGE_ID
	staA	ALDL_CSUM           ; Initialise the checksum 
	ldaB	#$01
	staB	ALDL_COUNT          ; ALDL_COUNT = 1
	
	ldX	#IO_PORTA
	bset	0,X,#SPI_ALDLTX	; Enable the ALDL Tx Output Buffer
	
	ldaA	#$81
	staA	SCI_CTRL_REG	; 0x81 = enable SCI_TDRE & SCI_EXTIRQ
	ldaA	#$89
	staA	SCI_CTRL_REG	; 0x89 = enable SCI_TDRE & SCI_TE & SCI_EXTIRQ
	jr	LEA6C               ; return
;
;**********************************************************************
;
; This is the ALDL error cleanup section of code
;
ALDL_CLEANUP:
LEA5F:	clrA	
	clrB	
	stD	ALDL_PTABLE
	stD	ALDL_COUNT	; This clears ALDL_COUNT and ALDL_CSUM
	ldaA	#$27
	staA	SCI_CTRL_REG	; 0x27 = enable SCI_RDRF & SCI_EXTIRQ & SCI_RE & SCI_RWU

LEA6C:	ret	
;
;**********************************************************************
;
; Called when ALDL port is ready to TX next byte to TECH 1
;
ALDL_TX:
LEA6D:	ldX	ALDL_PTABLE	; Pickup the pointer to the control block

	ldaB	ALDL_COUNT
	decB	
	bne	LEA9A     	; if (ALDL_COUNT != 1) goto LEA9A

	ldaA	4, X		; A = Tx Word Count

	brclr	L0066,#L0066_ALDL_AWAKE,LEA92
;
; We get in here if (ALDL_COUNT == 1). We need may need to get bytes to TX
;
	ldaB	ALDL_MODE		; Get the mode
	subB	#$02
	bls	LEA92               ; if (ALDL_MODE < 2) goto LEA92

	ldaA	ALDL_BYTES_TODO	; Get the number of input bytes
	cmpB	#$05
	beq	LEA92		; if (ALDL_MODE == 7) goto LEA92               
	
	decA	                    ; A = ALDL_BYTES_TODO - 1 (remove the MODE byte) 
	decB	
	beq	LEA90		; if (ALDL_MODE == 3) goto LEA90
	                              
	                              ; we get here if (ALDL_MODE == 4)
	                              ; in MODE 4, there are 10 bytes other
	                              ; than the address, so subtract them
	subA	#$0A		; A = ALDL_BYTES_TODO - 11
;
; At this point, we have a number of 16 bit addresses for data to output
; Convert this to a number of bytes. - one byte per 16 bit address
;
LEA90:	asrA			; A = A >> 2	
	incA	                    ; A = A + 1
	                              ; A = number of output BYTES

LEA92:	staA	ALDL_BYTES_TODO	; Store the number of bytes to TX
	addA	#$55                ; add on the constant length offset
	jmp	LEB19               ; goto TRANSMIT_BYTE
;
; We get here if (ALDL_COUNT != 1), with B = ALDL_COUNT - 1
;
LEA9A:	decB			; B = ALDL_COUNT - 2	
	bne	LEAA8               ; if (ALDL_COUNT != 2) goto LEAA8
	
	brclr	L0066,#L0066_ALDL_AWAKE,LEAA8 ; if we're asleep goto LEAA8

	ldaA	ALDL_MODE		; Get the mode
	cmpA	#$07
	bne	LEB19		; if (ALDL_MODE != 7) goto TRANSMIT_BYTE
;
; We get here if (ALDL_COUNT > 2), with B = ALDL_COUNT - 2
;
LEAA8:	cmpB	ALDL_BYTES_TODO
	bcc	LEB13		; if (ALL Transmitted) goto LEB13
	
; if we have a 16 bit value from last time, goto LEB07
	brset	ALDLMW,#ALDLMW_LSB,LEB07
	
; if bit 7 of control_block[3] is set, then addreses follow the control block
	brset	3, X, #%10000000, LEAC0
;	
; if bit 6 of control_block[3] is set, then addreses are stored in the output
; buffer pointed to in control_block[5]
	brset	3, X, #%01000000, LEAC7
;
; else, output data is stored at the address stored in the output buffer 
; pointed to by control_block[5]	
	ldX	5, X		; X = control_block[5] 
	aBX	                    ; index into the buffer
	ldaA	0, X                ; pickup the byte
	jr	LEB19 		; goto TRANSMIT_BYTE
;
; List of 16 bit output addresses follow the control block
;
LEAC0:	decB			; B = ALDL_COUNT - 3	
	lslB	                    ; double the index, it's a word table
	aBX	                    ; index into the table
	ldX	9, X                ; The table starts after the control block
	jr	LEAE7		; X = address of the byte to TX
;
; List of 16 bit output addresses stored in the output buffer pointed to 
; by control_block[5]
;
LEAC7:	decB	                    ; B = ALDL_COUNT - 3
	ldX	5, X		; X = control_block[5]
	ldaA	ALDL_MODE           ; pick up the ALDL_MODE
;
; If we aren't awake, then force the mode to 0
	brset	L0066,#L0066_ALDL_AWAKE,LEAD2
	clrA
;
LEAD2:	cmpA	#$02
	beq	LEAE3	; if it's mode 2, goto LEAE3
	
	lslB	          ; addresses are 16 bit, so double the offset
	incB	          ; skip over the mode byte in the buffer
	
	cmpA	#$04
	bne	LEADE
	addB	#$0A	; if it's Mode 4, skip over the extra 10 bytes in the Mode4 buffer
LEADE:	aBX		; index into the buffer
	
	ldX	0, X      ; pick up the 16 bit address from the buffer
	jr	LEAE7	; X = address of the byte to TX
;
; If we get here, X points to a Mode 2 style buffer
;
LEAE3:	incX		; The first byte in the Mode2 buffer is the ALDL_MODE. Skip it	
	ldX	0, X	; Pick up the start address
	aBX	          ; Index the start address - still need to validate it
;
; We get here then X contains the address of the data byte we want to TX
; BUT - we need to check it. Values in the 3000 range are used to indicate
; that its a 16 bit value, and we need to save the whole 16 bits before
; we transmit the first byte. Also, we inhibit accesses to addreses
; 0x2000 - 0x6FFF, because this will cause a bus error interrupt.
;
LEAE7:	cmpX	#$3000
	bcs	LEB0F		; if (address < 0x3000) goto LEB0F
	cmpX	#$6FFF
	bhi	LEB0F		; if (address > 0x6FFF) goto LEB0F               
	
	pushX			; Push the address onto the stack	
	popA			; Pop the MSB of the address	
	bitA	#%00100000           
	beq	LEAF9               
	andA	#%00000011          ; either mask address with 0x03FF
LEAF9:	andA	#%00011111          ; or mask with 0x1FFF
	pushA	                    ; Save the masked address MSB
	popX	                    ; retreive the masked X
	
	ldD	0, X		; Pickup the 16 bit value in A:B
	staB	ALDL_WORDLSB	; Store the Lobyte for next time
	bset	ALDLMW,#ALDLMW_LSB	; set the byte from lasttime flag
	jr	LEB19		; goto TRANSMIT_BYTE
;
LEB07:	bclr	ALDLMW,#ALDLMW_LSB ; clear the byte from lasttime flag
	ldaA	ALDL_WORDLSB        ; pickup the byte from lasttime
	jr	LEB19               ; goto TRANSMIT_BYTE
;
LEB0F:	ldaA	0, X                ; pick up the byte to TX from [X+0]
	jr	LEB19               ; goto TRANSMIT_BYTE 
;
LEB13:	bne	LEB27		; if ((ALDL_COUNT - 2) > BYTES_TODO) goto LEB27
;
; We get here when there is one byte remaining to TX - the Checksum
;
	ldaA	ALDL_CSUM		; Pick up the checksum so far
	negA                          ; A = (0 - A) is the checksum
		
LEB19:	staA	ALDL_TXD_REG	; Transmit the next byte
	addA	ALDL_CSUM
	staA	ALDL_CSUM		; Add the next byte to the checksum
	inc	ALDL_COUNT	; ALDL_COUNT++
	jr	LEB3D               ; return
;
; Cleanup, and set hardware to wait for a transmit complete interrupt
;
LEB27:	clrA	
	clrB	
	bclr	ALDLMW,#ALDLMW_LSB
	stD	ALDL_COUNT	; This clears ALDL_COUNT and ALDL_CSUM
	stD	ALDL_PTABLE
	ldaA	ALDL_FLAG_REG
	ldaA	ALDL_RXD_REG
	
	ldaA	#$41
	staA	SCI_CTRL_REG	; 0x41 = enable SCI_TC & SCI_EXTIRQ 
	
LEB3D:	ret	
;
;**********************************************************************
;
; Check for ALDL blink-out mode ?
;
LEB3E:	ldS	#STACK_TOP
	ldaA	#ALDLAtoD
	call	ReadAtoD	; A = ALDL Pin Voltage 

	cmpA	#$64
	bcc	LEB4E	; if ADALDL >= 1.95V goto LEB4E
	
	cmpA	#$28
	bcc	LEB4F	; if ADALDL >= 0.78V goto LEB4F
	
	; If we get here, we are in ALDL test mode. Cause a software int
LEB4E:	swi	                             
   
	; If we get here ??
LEB4F:	ldD	#$FF00
	stD	COP_WDOGFF 	; Tickle the watchdog
	
	ldaB	ALDL_MSGID
	cmpB	#$02
	beq	LEB64
	
	cmpB	#$03
	bne	LEB6F
	
	brclr	L007F, #%00000001, LEB6F
LEB64:	bset	L007F, #%00000001
	ldX	ALDL_MODE
	call	0, X
	jmp	LECD8
;
LEB6F:	ldaB	ALDL_MSGID
	cmpB	#$01
	bne	LEB93

	bclr	L007F, #%00000001
	ldX	ALDL_MODE
	ldY	#$0228
	ldaB	#$20
LEB82:	ldaA	0, Y
	staA	0, X
	incY	
	incX	
	decB	
	bne	LEB82	; 
;
	com	ALDL_MSGID
	jmp	LECD8
;
LEB93:	tstB	
	bne	LEB9F
	di	
	call	LEDB3
	ei	
	bitA	#%00000001
	bne	LEBA2
LEB9F:	jmp	LEC43

LEBA2:	ldaA	#VBATAtoD	; Read the battery voltage
	call	ReadAtoD
	cmpA	#$28	; 4.0V
	bcc	LEBAC	; if (VBAT > 4.0V) goto LEBAC
	swi		; software interrupt ?	                                       
	
LEBAC:	call	TOGGLECOP2

	ldD	#$0001
	stD	L3FCE
	stD	L3FAE
	nop	
	nop	
	nop	
	nop	
	stD	L3FB0
	nop	
	nop	
	nop	
	nop	
	stD	L3FB2
	nop	
	nop	
	nop	
	nop	
	stD	L3FB4
	
	ldD	#$8001
	ldX	#IOREG4000
	call	LED2F
	
	ldX	#$3F80
	ldD	#$00C5
	stD	0, X
	stD	80, X
	
	call	NULLFUNCTION
	stD	2, X
	
	call	NULLFUNCTION
	stD	4, X
	
	call	NULLFUNCTION
	stD	6, X
	
	call	NULLFUNCTION
	stD	8, X
	
	call	NULLFUNCTION
	stD	10, X
	
	ldX	#IOREG4000
	oraA	#%01000000
	di	
	call	LED2F
	ei	
	
	ldX	#$FFF1
	stX	L3FF6
	bset	FMDSDI, #%00000100
	ldX	#$0042
	nop	
	stX	L3FDC
	
	ldaB	TIMER_TICK
	cmpB	#$8F
	bls	LEC1A
	clrB	
LEC1A:	staB	TIMER_TICK

	bitB	#%00001111
	beq	LEC23
	jmp	LECD8
;
LEC23:	lsrB	
	lsrB	
	ldX	#$ECDB
	aBX	

	ldY	#IAC_PHASES
	ldaB	L007E
	aBY		; index into the IAC_PHASES table
		
	incB	
	andB	#IACV_DRIVE
	staB	L007E   
	
	ldaA	IO_PORTA
	andA	#NOT_IACV_DRIVE
	oraA	0, Y
	staA	IO_PORTA
	jr	LEC4C
;
LEC43:	ldX	#IO_PORTA
	bclr	0,X,#IACV_DRIVE
	ldX	#$ECFF

LEC4C:	ldD	L3FBC
	andB	#%11110011
	oraB	0, X
	call	NULLFUNCTION
	stD	L3FBC
	
	ldD	L3FFC
	andB	#%11100001
	oraB	1, X
	callr	NULLFUNCTION
	stD	L3FFC
	di	
	ldaA	SPIDEV8_OUT
	andA	#%11110000
	oraA	2, X
	staA	SPIDEV8_OUT
	pushX
		
	ldX	#IOREG4000
	bclr	IOPORTA,X,#SPI_DEV8
	call	LEDD3		; Transmit [X+0x00]
	bset	IOPORTA,X,#SPI_DEV8
	ei	
	
	popX	
	ldaA	IO_PORTB
	andA	#%11110011
	oraA	3, X
	staA	IO_PORTB
	
	cmpX	#$ECFF
	beq	LECD8
	ldX	#$D066
	ldaB	#$33
	stX	PWM_WGATE
	callr	NULLFUNCTION
	aBX	
	stX	PWM_PURGE
	callr	NULLFUNCTION
	aBX	
	stX	PWM_EWP
	callr	NULLFUNCTION
	aBX	
	stX	L3FD8
	callr	NULLFUNCTION
	aBX	
	stX	L3FDA
	callr	NULLFUNCTION
	aBX	
	stX	L3FCC
	callr	NULLFUNCTION
	aBX	
	stX	PWM_EFAN
	callr	NULLFUNCTION
	aBX	
	stX	PWM_ACCLUTCH
	callr	NULLFUNCTION
	aBX	
	stX	PWM_EXCPV
	callr	NULLFUNCTION
	aBX	
	stX	L3F92
	
	ldaA	IO_PORTA
	oraA	#SPI_ALDLTX
	staA	IO_PORTA		; Enable the ALDL Tx Output Buffer

	ldX	#$ED0C
	call	LC14A
LECD8:	jr	LECD8
;
;**********************************************************************
;
; This is a null function - used for timing routines ????
;
NULLFUNCTION:
LECDA:	ret	
;
;**********************************************************************
;? dword table used in routine at EC23. Indexed by ?
LECDB:	db	$08,$1A,$03,$00
	db	$08,$1A,$05,$00
	db	$08,$1A,$09,$00
	db	$08,$12,$01,$00
	db	$08,$1E,$01,$00
	db	$0C,$1A,$01,$00
	db	$00,$1A,$01,$00
	db	$08,$1A,$01,$04
	db	$08,$1A,$01,$08
;**********************************************************************
;
LECFF:	db	$00,$00,$00,$00
;
;**********************************************************************
;
; ALDL Table used in routine at E9A8
LED03:	dw	$ED0C	; Link to next command
	db	$01	; MESSAGE_ID
	db	$00
	db	$00       ; Bit 7 Clear means output Bits [5..0] data words
	dw	$0226     ; Message output buffer
	dw	$0204	; Message input buffer
;
; ALDL Table used in routine at E9A8
LED0C:	dw	$ED15	; Link to next command
	db	$02	; MESSAGE_ID
	db	$00
	db	$00       ; Bit 7 Clear means output Bits [5..0] data words
	dw	$0226     ; Message output buffer
	dw	$0204	; Message input buffer
;
; ALDL Table used in routine at E9A8
LED15:	dw	$0000	; Link to next command
	db	$03	; MESSAGE_ID
	db	$00
	db	$18       ; Bit 7 Clear means output Bits [5..0] data words
	dw	$0204     ; Message output buffer
	dw	$0204	; Message input buffer
;
;**********************************************************************
;
; Called with B = Desired new ISSPMP value
;
IACVADJUST:
LED1E:	ldaA	ISSPMP
	sBa		; A = currentISSPMP - newISSPMP
	bcc	LED24	; if (current >= new), goto LED24
	negA	          ; A = 0 - A
	
			; At this point A = delta ISSPMP
LED24:	bpl	LED28     ; if (deltaISSPMP > 0x7f)
	ldaA	#$7F      ; A = 0x7F
	
LED28:	bcs	LED2C
	oraA	#%10000000 ; if the delta was -ve, make ISSPMP_DELTA -ve 
;	
LED2C:	staA	ISSPMP_DELTA
	ret	
;
;**************************************************
;Some Kind of H/W Conversion Routine ?  
;Called  with ACCA = desired converter channel #1
;	    ACCB = desired converter channel #2
;	    ACCX = 0x4000
;Returns with [SPIDEV7_MSB:SPIDEV7_LSB] = 16 bit converter result
;
LED2F:	bset	IOPORTA, X,SPI_DEV7
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staB	SPI_DATA,X
	bclr	SPI_CTRL,X,SPI_START
	staA	SPIDEV7_MSB		; Store the MSB
	pushB	
	mul	
	mul	
	popB	
	pushB	
	popB	
	ldaA	SPI_DATA,X
	staA	SPIDEV7_LSB	; Store the LSB
	lslA	                    ; Shift the MSbit into the carry flag
	bpl	LED55               ; Jump if MSbit set
	bset	SEQMW1, #%00001000
LED55:	bclr	IOPORTA, X,SPI_DEV7
;
	ret
;**************************************************
; MALFWD Checksum Calculation Routine
; Returns with the 16 bit checksum of the 5 MALFW bytes in A:B
;
MALFWD_CSUM:
LED59:	ldX	#$0005
	ldD	#$0001
LED5F:	addB	2, X
	adcA	#$00
	decX	
	bne	LED5F
	ret
;	
;**************************************************
;A/D Conversion Routine  
;Called  with ACCA = A/D desired converter channel
;Returns with ACCA = A/D converter result
LED67: 
ReadAtoD:	ldX	#IOREG4000
	di             		; Disable interrupts	
	bclr	IOPORTA, X,#SPI_ADC	; Enable SPI_ADC
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	staA	SPI_JUNK
	nop	
	mul	
	mul	
	ldaA	#ENDAtoD
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	bset	IOPORTA,X,#SPI_ADC	; Disable SPI ADC
	ei		          ; Enable interrupts
	ret	
;**************************************************
;
LED93:	pushX	
	ldaA	SPIDEV8_OUT
	ldX	#IOREG4000
	bclr	IOPORTA, X,#SPI_DEV8
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	bset	IOPORTA, X,#SPI_DEV8
	popX	
	ret	
;
;**************************************************
;
TOGGLECOP2:
LEDAD:	ldaA	FMDSDI
	xorA	#FMDSDI_COP2
	staA	FMDSDI
	
LEDB3:	bclr	FMDSDI, #%10000000
	jr	LEDBB
;
LEDB8:	bset	FMDSDI, #%10000000

LEDBB:	ldX	#IOREG4000
	bset	IOPORTA, X,#SPI_DEV3
	ldaA	FMDSDI
	staA	SPI_DATA,X
	bclr	SPI_CTRL,X,#SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	SPI_DATA,X
	bclr	IOPORTA, X,#SPI_DEV3
	ret	
;
;**************************************************
; Called with  X = IOREG4000
;              A = Value to transmit
;              SPI_DEV8 already enabled
;
LEDD3:	staA	0, X
	bclr	1, X, #SPI_START
	pushB	
	mul	
	mul	
	mul	
	popB	
	ldaA	0, X
	ret	
;
;**************************************************
; First Order Lag filter routine  See TurboP4.pdf Sec 2.4.7
; Called with X = Pointer to initial 16 bit filtered value
;             A = Latest value to be corrected
;             B = Lag filter coefficient
;
; Return with A:B = Updated 16 bit filtered value
;
LAGFILTER:
LEDE0:	pushB	
	pushX	; [x+4] = Filter coefficient	
	pushX	; [x+2] = Pointer to initial value 	
	tSX	; [x+0] = Pointer to initial value
		
	subA	0, X	; A = currentvalue - lastvalue
	bcc	LEDEF	; if (current > last) goto LEDEF
	
	negB		; Negate the coefficient if delta is -ve	
	addB	0, X      ; 
	staB	0, X      ;
	ldaB	4, X	; restore B = Filter coefficient
	
LEDEF:	mul		; A:B = current * coeff	
	staB	1, X	; save LSB in [x+1]
	pushA	          ; save the MSB on the stack
	ldD	3, X
	negB	
	beq	LEDFB	; if (B = 0) goto LEDFB
	mul		;	
	adcA	#$00 
	
LEDFB:	tAB	
	popA		; retreive the MSB from the stack	
	addD	0, X	; A:B = A:B + initial value

	popX		; clean up the stack	
	popX	          ; and restore the initial value of X
	incS	
	ret	
;
;**************************************************************************
;
; This routine multiplies the 8 bit value passed in A by the 16 bit value
; pointed to by X. The 16 bit result is returned in A:B 
;
MULT8BY16:
LEE03:	pushA		; Save input value on stack for later	
	ldaB	1, X
	mul		; A:B = First Partial Result	
	adcA	#$00	; Round the MSB

	popB		; Get the input value from the stack
		
	pushA		; Save the first partial result MSB	

	ldaA	0, X
	mul	    	; A:B = Second partial result
	
	pushX		; Save the multiplier factor pointer
	tSX		; X = SP	

	addB	2, X	; Get the first partial result
	adcA	#$00

	popX		; Restore X	                           
	incS		; Restore the stack	
	ret	
;
;**************************************************
; 3D lookup table routine
; Called with X = Lookup table base address
;             A = Latest X value
;             B = Latest Y value
;
; Return with A = Corrected value
;
LOOKUP3D:
LEE17:	pushY	
	pushB	
	pushX	
	subA	0, X
	bcc	LEE20
	clrA	
LEE20:	subB	1, X
	bcc	LEE25
	clrB	
LEE25:	pushX	
	popY	
	pushA	
	ldaA	#$10
	mul	
	pushB	
	tAB	
	aBX	
	popA	
	popB	
	pushA	
	ldaA	#$10
	mul	
	pushB	
	ldaB	2, Y
	mul	
	aBX	
	pushX	
	ldaB	2, Y
	aBX	
	tSY	
	ldD	3, X
	sBA	
	ldaB	3, Y
	bcc	LEE50
	negA	
	mul	
	adcA	3, X
	jr	LEE56
;
LEE50:	mul	
	adcA	#$00
	negA	
	addA	3, X
LEE56:	popX	
	pushA	
	ldD	3, X
	sBA	
	ldaB	3, Y
	bcc	LEE66
	negA	
	mul	
	adcA	3, X
	jr	LEE6C
;
LEE66:	mul	
	adcA	#$00
	negA	
	addA	3, X
LEE6C:	popB	
	pushA	
	sBA	
	ldaB	2, Y
	bcc	LEE7B
	negA	
	mul	
	adcA	1, Y
	jr	LEE82
;
LEE7B:	mul	
	adcA	#$00
	negA	
	addA	1, Y
LEE82:	incS	
	popX	
	popX	
	popB	
	popY	
	ret	

;*********************************************************
; 2D lookup table routine
; Called with X = Lookup table base address
;                 The first value is the size of the array
;             A = Latest value to be corrected
;             B = Don't care
;
; Return with A = Corrected value
;
LOOKUP1DBYN:
LEE89:	pushX	
	pushB	
	ldaB	0, X	; B = [X + 0x00] This is the sise of the row in a 2D Array
	incX		; X++ Point X at the start of the data array
	jr	LEE98
;
;*********************************************************
; 1D lookup table routine
; Called with X = Lookup table base address
;             A = Index into table
;             B = Amount to subtract from A before indexing
;
LOOKUP1DBY16OFFSET:
LEE90:	sBA	
	bcc	LOOKUP1DBY16
	clrA	
;
;*********************************************************
; 1D lookup table routine
; Called with X = Lookup table base address
;             A = Index into table
;             B = Don't care
;
; Return with A = Lookup Table Value
;
LOOKUP1DBY16:
LEE94:	pushX	
	pushB	
	ldaB	#$10     
;
; At this point B = Size of the array row
;
LEE98:	mul		; A:B = A * B
	pushB	
	tAB		; B = A
	aBX		; X = X + B
	ldD	0, X	; A:B = [X + 0x00]
	sBA	
	popB	
	bcc	LEEA8
	negA	
	mul	
	adcA	0, X
	jr	LEEAE
;
LEEA8:	mul	
	adcA	#$00
	negA	
	addA	0, X
LEEAE:	popB	
	popX	
	ret	
;
;*********************************************************
;
LEEB1:	pushA	
	pushX	
	pushX	
	pushB	
	pushA	
	tSX	
	ldaA	3, X
	mul	
	adcA	#$00
	staA	5, X
	ldD	1, X
	mul	
	addB	5, X
	adcA	#$00
	stD	4, X
	ldaA	0, X
	ldaB	3, X
	clr	6, X
	mul	
	addD	4, X
	rol	6, X
	staA	4, X
	ldaA	0, X
	ldaB	2, X
	mul	
	addB	4, X
	adcA	6, X
	stD	2, X
	rol	5, X
	popX	
	popA	
	popB	
	popX	
	incS	
	ret	
;
;*********************************************************
;
; This routine multiplies the 16 bit value passed in A:B by the 
; 16 bit value passed in X. The 16 bit result is returned in A:B 
;
MULT16BY16:
LEEE7:	pushX	
	pushX	
	pushB	
	pushA	
	tSX	
	ldaA	3, X
	mul	
	adcA	#$00
	staA	5, X
	ldD	1, X
	mul	
	addB	5, X
	adcA	#$00
	stD	4, X
	ldaA	0, X
	ldaB	3, X
	mul	
	addD	4, X
	bcs	LEF15
	stD	4, X
	ldaA	0, X
	ldaB	2, X
	mul	
	tstA	
	bne	LEF15
	addB	4, X
	staB	4, X
	bcc	LEF1A
LEF15:	ldD	#$FFFF
	stD	4, X
LEF1A:	popX	
	popX	
	popA	
	popB	
	ret	

;*********************************************************
; EPROM Checksum Calculation Routine
; Called with X = Start address = 0x8008
;           A:B = EPROM size    = 0x7FF8 
;
LEF1F:	pushX	
	pushB	
	pushA	
	lsrD			; A:B = A:B >> 1  (0x3FF4)
	pushA			; Save MSB of count
	ldY	#$0000	; Y = 0
	tBA			; A = 0xF4
	beq	LEF39		; if LSB == 0, go to outer loop
                
LEF2B:	ldaB	0, X		; B = [X + 0x00]
	aBY			; Y = Y + B
	ldaB	1, X		; B = [X + 0x01]
	aBY			; Y = Y + B
	ldaB	#$02		; B = 2
	aBX			; X = X + B
	decA			; A--
	bne	LEF2B		; while (A) goto LEF2B

LEF39:	pushX	
	ldX	#$FF00
	stX	COP_WDOGFF	; tickle the watchdog
	tSX			; X = SP
	dec	2, X		; [SP+0x02]--  dec msb of count
	popX	
	bpl	LEF2B		; jump while msb of count != 0

	incS			; SP++         junk msb of count
	popA	
	popB	
	popX	
	ret
;	
;*********************************************************
; If carry flag isn't set, 
; Multiplies A * B * 2, rounds the result and limits it to 255
;
MULTAB2NC:
LEF4B:	bcc	LEF4F
	clrA	
	ret	
;
; Multiplies A * B * 2, rounds the result and limits it to 255
;
MULTAB2:
LEF4F:	mul	
	lslD	
	bcs	LEF59
	tstB	
	bpl	LEF5B
	incA	
	bne	LEF5B
LEF59:	ldaA	#$FF
LEF5B:	ret	

;**********************************************************************
;17 byte table used in CTS linearisation routine at DB64.
;This table is used whilst the CTS pullup resistor is 3998 ohms.
;This is true before CTS > 50C, or when CTS drops < 39.5C
;A full description is given in TurboP4.pdf in section 2.4.1  
;
FCTL4K:
LEF5C:	db	$FF,$D7,$9B,$84,$75,$6A,$61,$58,$51
	db	$4A,$43,$3C,$34,$2C,$22,$16,$00
;**********************************************************************
; 17 byte table used in CTS linearisation routine at DB64.
; This table is used whilst the CTS pullup resistor is 348 ohms.
; This is true after CTS > 50C, and untill CTS drops < 39.5C
; A full description is given in TurboP4.pdf in section 2.4.1
;
FCTL348:  
LEF6D:	db	$FF,$FF,$F9,$DF,$CD,$BF,$B2,$A7,$9D
	db	$93,$89,$7F,$75,$68,$59,$43,$00
;**********************************************************************
; 17 byte table used in MAT linearisation routine at DE3B.
;
; Indexed by (COM(MATFILT) - 0x0C), or effectivly ((0xFF - MATFILT) - 0x0C)
;
; Resultant value is true MAT + 40 Deg C, or T = LEF7E[] - 40  
;
LEF7E:	db	$BC,$98,$87,$7B,$71,$69,$62,$5B,$55
	db	$4F,$48,$41,$3A,$31,$24,$06,$00
;**********************************************************************
;
; IAC Stepper motor 2 phase table.
;
; When stepping up,   sequence is 00 - 01 - 11 - 10 - 00 etc
; When stepping down, sequence is 00 - 10 - 11 - 01 - 00 etc
;
IAC_PHASES:
LEF8F:	db	$00,$01,$03,$02
;
;**********************************************************************
	db	$00,$40,$80,$C0
;**********************************************************************
; This looks like an error code table of some sort,possibly used for
; dashboard blink codes
;
LEF97: 	db	$12,$12,$13,$14,$15,$16,$21,$22
	db	$23,$24,$25,$26,$31,$32,$33,$34
	db	$35,$36,$41,$42,$43,$44,$45,$46
	db	$51,$52,$53,$54,$55,$56,$61,$62
	db	$63,$64,$65,$66
;
;**********************************************************************
;8 word table used in routine at B9C0 & BA87. Indexed into by CYLINDER
;
LEFBB:	dw	$3FD0,$4000,$3F80,$3F82,$3F84,$3F86,$3F88,$3F8A
;
;**********************************************************************
	fill	$00, 4113
;**********************************************************************
;
LFFDC:	dw	$EF1F ; Address of checksum routine - Why ?
LFFDE:	dw	$EDD3 ; Address of SPI_ANY interface routine - Why ?
LFFE0:	dw	$0204 ; Address of the ALDL IO Buffer
LFFE2:	dw	$0049 ; Address of the FMDSDI Variable - Why ?
LFFE4:	dw	$EDAD ; Address of SPI_DEV3 interface routine Entry 1 - Why ?
LFFE6:	dw	$EDB3 ; Address of SPI_DEV3 interface routine Entry 2 - Why ?
LFFE8:	dw	$ED93 ; Address of SPI_DEV8 interface routine - Why ?
LFFEA:	dw	$ED67 ; Address of SPI_ADC interface routine - Why ?
LFFEC:	dw	$ED2F ; Address of SPI_DEV7 interface routine - Why ?
LFFEE:	dw	$8A04 ; Address of ALDL F95 table - Why ?

LFFF0: 	dw	$B000 ; SWI instruction
LFFF2: 	dw	$B34A ; ALDL interrupt vector & periodic timer
LFFF4: 	dw	$B59D ; External Interrupt Vector
LFFF6: 	dw	$B006 ; Illegal Instruction Interrupt Vector
LFFF8: 	dw	$B00A ; Bus Reset Vector (read or write 0x6000-0x6FFF)
LFFFA: 	dw	$B00E ; Watchdog Vector
LFFFC: 	dw	$B012 ; Clock Fail Vector
LFFFE: 	dw	$B016 ; Reset Vector

	end
